#include <cstdio>
#include <set>
#include <bitset>
#include <vector>
using namespace std;
#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define sz(a) ((int) (a).size())
#define int64 long long
const int N = (int) 1e4;
const int64 INF = (int64) 1e18 + 10;
bitset<N> who[N], curpath;
vector<int> order;
vector< vector< pair<int, int> > > paths;
vector< pair<int, int> > adj[N], path;
int n, m, k, s, t, w;
int64 d[N], ans[N];

struct cmp_d {
	bool operator()(int i, int j) {
		return (mp(d[i], i) < mp(d[j], j));
	}
};

set<int, cmp_d> cur;

int main() {
	freopen("trains.in", "r", stdin);
	freopen("trains.out", "w", stdout);
	scanf("%d%d", &n, &m);
	for (int i = 0; i < m; ++i) {
		scanf("%d%d", &k, &s), --s;
		path.clear();
		path.pb(mp(s, -1));
		for (int j = 0; j < k; ++j) {
			scanf("%d%d", &w, &t), --t;
			path.pb(mp(t, w));
			adj[s].pb(mp(t, w));
			s = t;
		}
		paths.pb(path);
	}
	for (int i = 0; i < n; ++i) {
		d[i] = (i == 0) ? 0 : INF;
		cur.insert(i);
	}
	order.clear();
	while (!cur.empty()) {
		int v = *cur.begin();
		cur.erase(cur.begin());
		order.pb(v);
		for (int i = 0; i < sz(adj[v]); ++i) {
			int u = adj[v][i].fs, w = adj[v][i].sc;
			if (d[u] > d[v] + w) {
				cur.erase(u);
				d[u] = d[v] + w;
				cur.insert(u);
			}
		}
	}
	for (int i = 0; i < sz(paths); ++i) {
		for (int j = 0; j < sz(paths[i]); ++j) {
			if ((j == 0) || (d[paths[i][j].fs] != d[paths[i][j - 1].fs] + paths[i][j].sc)) {
				curpath.reset();
			}
			curpath[paths[i][j].fs] = 1;
			who[paths[i][j].fs] |= curpath;
		}
	}
	for (int i = 0; i < sz(order); ++i) {
		int v = order[i];
		ans[v] = 0;
		if (d[v] == INF) {
			break;
		}
		for (int j = 0; j < i; ++j) {
			int u = order[j];
			int64 w = ans[u] + (d[u] - d[v]) * (int64) (d[u] - d[v]);
			if ((ans[v] < w) && who[v][u]) {
				ans[v] = w;
			}
		}
	}
	if (d[n - 1] == INF) {
		printf("-1\n");
	} else {
		printf("%lld %lld\n", d[n - 1], ans[n - 1]);
	}
	return 0;
}
