/*
File name: solve_mt.cpp
Tag: MAIN
Author: endagorion
Change time: Wed Mar 29 21:35:36 MSK 2017

*/
#include <iostream>
#include <bitset>
#include <vector>
#include <cmath>
#include <ctime>
#include <cassert>
#include <cstdio>
#include <queue>
#include <set>
#include <map>
#include <fstream>
#include <cstdlib>
#include <string>
#include <cstring>
#include <algorithm>
#include <numeric>

#define mp make_pair
#define mt make_tuple
#define fi first
#define se second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for (int i = (int)(n) - 1; i >= 0; --i)
#define fore(i, a, b) for (int i = (int)(a); i <= (int)(b); ++i)

using namespace std;

typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<pii> vpi;
typedef vector<vi> vvi;
typedef long long i64;
typedef vector<i64> vi64;
typedef vector<vi64> vvi64;

template<class T> bool uin(T &a, T b) { return a > b ? (a = b, true) : false; }
template<class T> bool uax(T &a, T b) { return a < b ? (a = b, true) : false; }

void consume(vector< pair<char, int> > &v) {
    if (v.empty()) return;
    pair<char, int> z = v.back();
    v.pop_back();
    while (!v.empty()) {
        if (v.back().fi == z.fi || v.back().se < z.se) {
            z.se += v.back().se;
            v.pop_back();
        } else break;
    }
    v.pb(z);
}

bool solve_prim(string s, char c) {
    vector< pair<char, int> > v;
    pair<char, int> x = {'Z', 0};
    for (char cc: s) {
        if (x.fi != cc) {
            if (x.se) v.pb(x);
            x = {cc, 0};
        }
        ++x.se;
    }
    v.pb(x);

    vector< pair<char, int> > st;
    for (auto w: v) {
        if (st.empty()) {
            st.pb(w);
            continue;
        }
        if (st.back().fi == w.fi || (st.back().fi == c && w.se < st.back().se)) st.back().se += w.se;
        else st.pb(w);
        if (st.back().fi == c) consume(st);
    }
    return st.size() == 1 && st[0] == mp(c, (int)s.size());
}

bool solve(string s, string t) {
    int n = s.size();
    int p = 0;
    forn(i, n - 1) {
        if (t[i] != t[i + 1]) {
            if (s[i] != t[i] || s[i + 1] != t[i + 1] || !solve_prim(string(s.begin() + p, s.begin() + i + 1), t[i])) return false;
            p = i + 1;
        }
    }
    return solve_prim(string(s.begin() + p, s.end()), t.back());
}
 
int main() {
    freopen("storage.in", "rt", stdin);
    freopen("storage.out", "wt", stdout);

    ios::sync_with_stdio(false);
    cin.tie(0);

    int T;
    cin >> T;
    while (T--) {
        string s, t;
        cin >> s >> t;
        cout << (solve(s, t) ? "Yes" : "No") << '\n';
    }
}

