/*
File name: sol_ge_wa3.cpp
Tag: REJECTED
Author: glebshp
Change time: Wed Mar 29 20:01:56 MSK 2017

*/
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const int size = 1000 * 1000 + 100;
const int inf = 1000 * 1000 * 1000;

struct range {
	bool valid;
	int lb;
	int rb;
};

range lres[size], rres[size];
int lbt[size], rbt[size];
int t[size];
int n;

range intersect(range a, range b) {
	range res;
	res.valid = a.valid && b.valid;
	if (res.valid) {
		res.lb = max(a.lb, b.lb);
		res.rb = max(a.rb, b.rb);
	}

	if (res.lb > res.rb) {
		res.valid = false;
	}

	return res;
}

void update(range& rg, int t, int lb, int rb) {
	if (!rg.valid)
		return;

	rg.lb = max(rg.lb, lb);
	rg.rb = min(rg.rb, rb);
	
	if (rg.lb > rg.rb) {
		rg.valid = false;
		return;
	}

	if (rg.lb == lb) {
		rg.lb = max(rg.lb - t, 0);
	}
}

int main () {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    scanf("%d", &n);
    for (int i = 0; i < n; i++) {
    	scanf("%d", &t[i]);
    }
    for (int i = 0; i < n - 1; i++) {
    	scanf("%d%d", &lbt[i], &rbt[i]);
    }

    lres[0].valid = true;
    lres[0].lb = 0;
    lres[0].rb = inf;
    for (int i = 1; i < n; i++) {
  		lres[i] = lres[i - 1];
  		update(lres[i], t[i], lbt[i - 1], rbt[i - 1]);
    }

    rres[n - 1].valid = true;
    rres[n - 1].lb = 0;
    rres[n - 1].rb = inf;
    for (int i = n - 2; i >= 0; i--) {
    	rres[i] = rres[i + 1];
    	update(rres[i], t[i], lbt[i], rbt[i]);
    } 

    for (int i = 0; i < n; i++) {
    	range r = intersect(lres[i], rres[i]);
    	if (r.valid) {
    		printf("%d\n", r.lb);
    	} else {
    		printf("-1\n");
    	}
    }


    return 0;
}
