#include <cstdio>
#include <algorithm>
#include <deque>

using namespace std;

const int MAXA = 3000000;
const int MAXN = 100000;

pair<int, long long> dp[MAXA];
int l[MAXN], r[MAXN], c[MAXN];

struct Qmin {
	int last;
	deque<int> mins;
	void pop() {
	 if (mins.front() == last--) 
		 mins.pop_front(); 
	}
	void push(int x) {
		while (!mins.empty() && dp[mins.back()] >= dp[x]) {
			mins.pop_back();
		}
		mins.push_back(x);
	}
	pair<int, long long> get_min() { 
		return dp[mins.front()]; 
	}
};

int A;
Qmin q[MAXN];


int main() {
  freopen("coffee.in", "r", stdin);
  freopen("coffee.out", "w", stdout);
  int n;
  scanf("%d%d", &n, &A);

  for (int i = 0; i < n; i++) {
    scanf("%d%d%d", &l[i], &r[i], &c[i]);
    q[i].last = A;
  }

  for (int i = A; i >= 0; i--) {
    dp[i] = make_pair(i, 0);
    for (int j = 0; j < n; j++) {
      if (i + l[j] <= A) {
        q[j].push(i + l[j]);
      }
      if (i + r[j] < A) {
        q[j].pop();
      }
    }
    for (int j = 0; j < n; j++) {
      if (i + r[j] > A) continue;
      pair<int, long long> mv = q[j].get_min();
      mv.second -= c[j];
      dp[i] = max(dp[i], mv);
    }
  }

  printf("%d %lld\n", dp[0].first, -dp[0].second);
}
