#include <cstdio>
#include <algorithm>

using namespace std;

const int MAXA = 2000000;
const int MAXN = 100000;
const int MAXLOG = 21;

const long long COST = 1000 * 1000 * 1000;


long long dp[MAXA];
int l[MAXN], r[MAXN], c[MAXN];

int sp[MAXLOG][MAXA];
int lg[MAXA];
int A;

long long get(int l, int r) {
  int p = lg[r - l];
  long long res = min(dp[sp[p][l]], dp[sp[p][r - (1 << p)]]);
  //fprintf(stderr, "get(%d, %d) = %d, p = %d\n", l, r, res, p);
  return res;
}

void add(int pos) {
  //fprintf(stderr, "dp[%d] = %d\n", pos, val);
  sp[0][pos] = pos;
  for (int i = 1; pos + (1 << i) <= A + 1; i++) {
    int a = sp[i - 1][pos];
    int b = sp[i - 1][pos + (1 << (i - 1))];
    if (dp[a] < dp[b]) {
      sp[i][pos] = a;
    } else {
      sp[i][pos] = b;
    }
  }
}

int main() {
  freopen("anti.in", "r", stdin);
  freopen("anti.out", "w", stdout);
  int n;
  scanf("%d%d", &n, &A);

  for (int i = 0; i < n; i++) {
    scanf("%d%d%d", &l[i], &r[i], &c[i]);
  }

  lg[1] = 0;
  for (int i = 2; i <= A + 1; i++) {
    if (i & (i - 1)) {
      lg[i] = lg[i - 1];
    } else {
      lg[i] = lg[i - 1] + 1;
    }
  }

  for (int i = A; i >= 0; i--) {
    dp[i] = i * COST;
    for (int j = 0; j < n; j++) {
      if (i + r[j] > A) continue;
      long long mv = get(i + l[j], i + r[j] + 1);
	  mv -= c[j];
      dp[i] = max(dp[i], mv);
    }
    add(i);
  }

  printf("%lld\n", dp[0]);
}
