/*
File name: anti_sm_backpack_slow.java
Tag: REJECTED
Author: pkunyavskiy
Change time: Wed Mar 29 22:35:52 MSK 2017

*/
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Random;
import java.util.StringTokenizer;

/**
 * Created by Sergey Melnikov (sergey@melnikov.ch) on 2017-03-29.
 */
public class anti_sm_backpack_slow {

    public static final boolean DEBUG = false;
    public static final int TL = 1_000_000_000;
    public static final long C = 1_000_000_000;

    class Button {
        int x, y, c;

        public Button(int x, int y, int c) {
            this.x = x;
            this.y = y;
            this.c = c;
        }
    }

    private int A;
    private Button[] bs;
    long[] dp;
    int D;
    Random rand = new Random(0);

    long calc(int x) {
        if (x > A) {
            return 0;
        }
        if (dp[x] != -1) {
            return dp[x];
        }
        long max = C * x;
        for (int i = 0; i < bs.length; i++) {
            long min = Long.MAX_VALUE / 2;
            for (int outcome = bs[i].x; outcome <= bs[i].y; outcome++) {
                if (DEBUG) System.err.println(x + " " + outcome + ": " + out(calc(x + outcome)));
                min = Math.min(min, calc(x + outcome) - bs[i].c);
            }
            max = Math.max(max, min);
        }
        if (DEBUG) System.err.println(x + " -> " + out(max));
        dp[x] = max;
        return max;
    }

    void solve() throws IOException {
        int n = nextInt();
        A = nextInt();
        D = TL / n / A;
        bs = new Button[n];
        for (int i = 0; i < n; i++) {
            bs[i] = new Button(nextInt(), nextInt(), nextInt());
        }
        dp = new long[A + 1];
        Arrays.fill(dp, -1);
        Arrays.sort(bs, new Comparator<Button>() {
            @Override
            public int compare(Button a, Button b) {
                if (a.y == b.y) {
                    return b.x - a.x;
                }
                return a.y - b.y;
            }
        });
        long result = calc(0);
        out.println(result);
        if (DEBUG) System.err.println(out(result));
    }

    String out(long t) {
        return "(" + ((t + C - 1) / C) + " " + (C - t % C) % C + ")";
    }

    int nextInt() throws IOException {
        while (st == null || !st.hasMoreElements()) {
            st = new StringTokenizer(br.readLine());
        }
        return Integer.parseInt(st.nextToken());
    }

    StringTokenizer st;
    BufferedReader br;
    PrintWriter out;

    void run() throws IOException {
        br = new BufferedReader(new FileReader("anti.in"));
        out = new PrintWriter("anti.out");
        solve();
        out.close();
    }

    public static void main(String[] args) throws IOException {
        new anti_sm_backpack_slow().run();
    }
}

