#define _CRT_SECURE_NO_WARNINGS
#include <cstdio>
#include <ctime>
#include <algorithm>
#include <vector>
#include <cassert>
#include <set>
#include <map>
using namespace std;
#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define sz(a) ((int) (a).size())
#define int64 long long
#define TASKNAME "twosegments"

const int N = (int) 5e5 + 10;
int n, m, x[N], y[N], wx[N], wy[N], who[2 * N], cnt[2 * N], ansi, ansj, ansk, ansl;
int64 maxsum, sumx, sumy, sy[N], sx[N], value[N], rmq[4 * N], rmq_delta[4 * N];
vector< pair<int, int> > pts;
vector< pair< int64, pair<int, int> > > stl, str;
double start = clock();

bool cmp_second(const pair<int, int>& p1, const pair<int, int>& p2) {
	return (p1.sc < p2.sc);
}

void update(int t, int l, int r, int x, int y, int64 delta) {
	if ((y <= l) || (r <= x)) {
		return;
	}
	if ((x <= l) && (r <= y)) {
		rmq_delta[t] += delta;
		rmq[t] += delta;
		return;
	}
	int m = (l + r) / 2;
	update(t * 2 + 1, l, m, x, y, delta);
	update(t * 2 + 2, m, r, x, y, delta);
	rmq[t] = max(rmq[t * 2 + 1], rmq[t * 2 + 2]) + rmq_delta[t];
}

int get_opt_value_pos(int t, int l, int r) {
	if (l == r - 1) {
		return l;
	} else {
		int m = (l + r) / 2;
		return (rmq[t * 2 + 1] > rmq[t * 2 + 2]) ? get_opt_value_pos(t * 2 + 1, l, m) : get_opt_value_pos(t * 2 + 2, m, r);
	}
}

void init(int t, int l, int r) {
	if (l == r - 1) {
		rmq[t] = -sy[l];
	} else {
		int m = (l + r) / 2;
		init(t * 2 + 1, l, m);
		init(t * 2 + 2, m, r);
		rmq[t] = max(rmq[t * 2 + 1], rmq[t * 2 + 2]);
	}
}

void update_stack(vector< pair< int64, pair<int, int> > > &str, int ypos, int64 dx, int64 mx) {
	while (!str.empty() && (str.back().fs > dx)) {
		update(0, 0, m, str.back().sc.fs, str.back().sc.sc, -str.back().fs);
		str.pop_back();
	}
	int pre = str.empty() ? 0 : str.back().sc.sc;
	str.pb(mp(dx, mp(pre, ypos + 1)));
	update(0, 0, m, str.back().sc.fs, str.back().sc.sc, +str.back().fs);
	str.pb(mp(mx, mp(ypos + 1, m)));
	update(0, 0, m, str.back().sc.fs, str.back().sc.sc, +str.back().fs);
}

void empty_stack(vector< pair< int64, pair<int, int> > > &str) {
	while (!str.empty()) {
		update(0, 0, m, str.back().sc.fs, str.back().sc.sc, -str.back().fs);
		str.pop_back();
	}
}

void solve(int l, int r) {
	if (l == r - 1) {
		int pos = who[x[l]], curk, curl;
		int64 cursum = 0;
		if (pos == -1) {
			cursum = sumy + wx[l], curk = 0, curl = m - 1;
		} else if (sy[pos] > sumy - sy[pos] - wy[pos]) {
			cursum = sy[pos] + wx[l], curk = 0, curl = pos - 1;
		} else {
			cursum = sumy - sy[pos] - wy[pos], curk = pos + 1, curl = m - 1;
		}
		if (cursum > maxsum) {
			maxsum = cursum, ansk = curk, ansl = curl;
		}
		return;
	}
	int64 limit = sy[m] - sy[0] + sx[r] - sx[l];
	if (limit <= maxsum) {
		return;
	}
	int mid = (l + r) / 2;
	stl.clear(), str.clear(), pts.clear();
	for (int i = l; i < r; ++i) {
		if (who[x[i]] != -1) {
			pts.pb(mp(i, who[x[i]]));
		}
	}
	stl.pb(mp(sx[mid] - sx[l], mp(0, m)));
	update(0, 0, m, stl.back().sc.fs, stl.back().sc.sc, +stl.back().fs);
	str.pb(mp(sx[r] - sx[mid], mp(0, m)));
	update(0, 0, m, str.back().sc.fs, str.back().sc.sc, +str.back().fs);
	sort(pts.begin(), pts.end(), cmp_second);
	for (int i = 0; i < sz(pts); ++i) {
		int xpos = pts[i].fs, ypos = pts[i].sc;
		int64 cursum = sy[ypos] + rmq[0];
		if (cursum > maxsum) {
			maxsum = cursum, ansk = get_opt_value_pos(0, 0, m), ansl = ypos - 1;
		}
		if (xpos < mid) {
			update_stack(stl, ypos, sx[mid] - sx[xpos + 1], sx[mid] - sx[l]);
		} else {
			update_stack(str, ypos, sx[xpos] - sx[mid], sx[r] - sx[mid]);
		}
	}
	int64 cursum = sy[m] + rmq[0];
	if (cursum > maxsum) {
		maxsum = cursum, ansk = get_opt_value_pos(0, 0, m), ansl = m - 1;
	}
	empty_stack(stl);
	empty_stack(str);
	solve(l, mid);
	solve(mid, r);
}

int main() {
	freopen(TASKNAME".in", "r", stdin);
	freopen(TASKNAME".out", "w", stdout);
	scanf("%d%d", &n, &m);
	for (int i = 0; i < n; ++i)
		scanf("%d", &x[i]), x[i]--;
	for (int i = 0; i < n; ++i) {
		scanf("%d", &wx[i]), sumx += wx[i];
		sx[i + 1] = sx[i] + wx[i];
	}
	for (int i = 0; i < n + m; ++i) {
		who[i] = -1;
	}
	for (int i = 0; i < m; ++i) {
		scanf("%d", &y[i]), y[i]--;
		who[y[i]] = i;
	}
	for (int i = 0; i < m; ++i) {
		scanf("%d", &wy[i]), sumy += wy[i];
		sy[i + 1] = sy[i] + wy[i];
	}
	if (sumx > sumy) {
		maxsum = sumx, ansi = 0, ansj = n - 1, ansk = -1, ansl = -1;
	} else {
		maxsum = sumy, ansi = -1, ansj = -1, ansk = 0, ansl = m - 1;
	}
	fprintf(stderr, "%.2f\n", (clock() - start) / CLOCKS_PER_SEC);
	init(0, 0, m);
	solve(0, n);
	if ((ansk != -1) && (ansl != -1)) {
		for (int ypos = ansk; ypos <= ansl; ypos++) {
			cnt[y[ypos]]++;
		}
		int64 cursum = 0, bestsum = 0;
		int start = 0;
		for (int k = 0; k < n; ++k) {
			if (cnt[x[k]] > 0) {
				cursum = 0;
				start = k + 1;
				continue;
			}
			cursum += wx[k];
			if (cursum > bestsum) {
				bestsum = cursum, ansi = start, ansj = k;
			}
		}
	}
	printf("%lld\n", maxsum);
	printf("%d %d\n", ansi + 1, ansj + 1);
	printf("%d %d\n", ansk + 1, ansl + 1);
	fprintf(stderr, "%.2f\n", (clock() - start) / CLOCKS_PER_SEC);
	return 0;
}
