/*
File name: segments_nn_wrong.cpp
Tag: WRONG_ANSWER
Author: niyaznigmatul
Change time: Wed Mar 29 22:13:56 MSK 2017

*/
#include <cstdio>
#include <algorithm>
#include <cassert>
using namespace std;

struct answer {
  long long ans;
  int l1, r1;
  int l2, r2;
};

answer mx(answer a, answer b) {
  return a.ans > b.ans ? a : b;
}

int const N = 1234567;

int where[N];
bool removed[N], toRemove[N];
int p[N];
long long sz[N];
int lp[N], rp[N];

int get(int x) {
  return x == p[x] ? x : (p[x] = get(p[x]));
}

void join(int from, int to) {
  assert(from != to);
  p[from] = to;
  sz[to] += sz[from];
  lp[to] = std::min(lp[to], lp[from]);
  rp[to] = std::max(rp[to], rp[from]);
}

long long rem(int pos, int m) {
  assert(!removed[pos]);
  if (pos > 0 && removed[pos - 1]) {
    int from = get(pos - 1);
    int to = get(pos);
    join(from, to);
  }
  if (pos + 1 < m && removed[pos + 1]) {
    int from = get(pos);
    int to = get(pos + 1);
    join(from, to);
  }
  removed[pos] = true;
  return sz[get(pos)];
}

answer solve(int n, int m, int *a, int *wa, int *b, int *wb) {
  for (int i = 0; i < n + m; i++) where[i] = -1;
  long long sumW1 = 0;
  for (int i = 0; i < m; i++) {
    where[b[i]] = i;
    toRemove[i] = true;
    sz[i] = wb[i];
    p[i] = i;
    lp[i] = rp[i] = i;
    removed[i] = false;
  }
  for (int i = 0; i < n; i++) {
    sumW1 += wa[i];
    toRemove[where[a[i]]] = false;
  }
  long long cur = 0;
  int cl2 = -1;
  int cr2 = -1;
  for (int i = 0; i < m; i++) {
    if (toRemove[i]) {
      long long val = rem(i, m);
      if (cur < val) {
        cur = val;
        cl2 = lp[get(i)];
        cr2 = rp[get(i)];
      }
    }
  }
  int l1 = -1;
  int r1 = -1;
  int l2 = -1;
  int r2 = -1;
  long long ans = 0;
  for (int i = n - 1; i >= 0; i--) {
    if (ans < cur + sumW1) {
      ans = cur + sumW1;
      l1 = 0;
      r1 = i;
      l2 = cl2;
      r2 = cr2;
    }
    ans = std::max(ans, cur + sumW1);
    sumW1 -= wa[i];
    int pos = where[a[i]];
    if (pos < 0) continue;
    long long val = rem(pos, m);
    if (cur < val) {
      cur = val;
      cl2 = lp[get(pos)];
      cr2 = rp[get(pos)];
    }
  }
  return {ans, l1, r1, l2, r2};
}

int a[N], b[N], wa[N], wb[N];

int main() {
  assert(freopen("internship.in", "r", stdin));
  assert(freopen("internship.out", "w", stdout));
  int n, m;
  assert(scanf("%d%d", &n, &m) == 2);
  for (int i = 0; i < n; i++) {
    int x;
    assert(scanf("%d", &x) == 1);
    --x;
    a[i] = x;
  }
  for (int i = 0; i < n; i++) {
    int x;
    assert(scanf("%d", &x) == 1);
    wa[i] = x;
  }
  for (int i = 0; i < m; i++) {
    int x;
    assert(scanf("%d", &x) == 1);
    --x;
    b[i] = x;
  }
  for (int i = 0; i < m; i++) {
    int x;
    assert(scanf("%d", &x) == 1);
    wb[i] = x;
  }
  answer ans1 = solve(n, m, a, wa, b, wb);
  std::reverse(a, a + n);
  std::reverse(wa, wa + n);
  answer ans2 = solve(n, m, a, wa, b, wb);
  ans2 = {ans2.ans, n - ans2.r1 - 1, n - ans2.l1 - 1, ans2.l2, ans2.r2};
  std::reverse(a, a + n);
  std::reverse(wa, wa + n);
  answer ans3 = solve(m, n, b, wb, a, wa);
  ans3 = {ans3.ans, ans3.l2, ans3.r2, ans3.l1, ans3.r1};
  std::reverse(b, b + m);
  std::reverse(wb, wb + m);
  answer ans4 = solve(m, n, b, wb, a, wa);
  ans4 = {ans4.ans, ans4.l2, ans4.r2, m - ans4.r1 - 1, m - ans4.l1 - 1};
  answer ans = mx(mx(mx(ans1, ans2), ans3), ans4);
  printf("%lld\n", ans.ans);
  printf("%d %d\n%d %d\n", ans.l1 + 1, ans.r1 + 1, ans.l2 + 1, ans.r2 + 1);
}

