from functools import lru_cache

import sys
from pprint import pprint


class Point:
    def __init__(self, x, y, i=-1):
        self.x = x
        self.y = y
        self.i = i

    def is_on(self, p1, p2, p3):
        ideal = abs((p1 - p2) * (p1 - p3))
        this = abs((self - p1) * (self - p2)) + abs((self - p2) * (self - p3)) + abs((self - p3) * (self - p1))
        return this <= ideal

    def __sub__(self, other):
        return Point(self.x - other.x, self.y - other.y)

    def __mul__(self, other):
        return self.x * other.y - other.x * self.y


def main():
    n = int(input())
    points = [Point(*map(int, input().split()), _ + 1) for _ in range(n)]
    different = []
    for i1, point1 in enumerate(points):
        for i2, point2 in enumerate(points[i1 + 1:], i1 + 1):
            for i3, point3 in enumerate(points[i2 + 1:], i2 + 1):
                for point4 in points:
                    if point4 in (point1, point2, point3):
                        continue
                    if point4.is_on(point1, point2, point3):
                        break
                else:
                    different.append((i1 + 1, i2 + 1, i3 + 1))

    # pprint(different)

    q = int(input())
    for _ in range(q):
        for triangle in different:
            print("? 3", *triangle)
            if input() == "Yes":
                print("! 3", *triangle)
                break


if __name__ == '__main__':
    # sys.stdin = open("output.txt", "r")
    main()
