#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef double dbl;

const int INF = 2e9;
const dbl EPS = 1e-9;
const dbl PI = acos(-1);

struct Dist {
	int d;
	ll g;

	inline bool friend operator <(const Dist &a, const Dist &b) {
		return a.d < b.d || (a.d == b.d && a.g > b.g);
	}
};

int main() {
	ios::sync_with_stdio(0);
	cin.tie(nullptr);
	cout.tie(nullptr);

#ifdef GA_ROI
	freopen("/home/roi/prjs/file.in", "r", stdin);
	freopen("/home/roi/prjs/file.out", "w", stdout);
#else
	freopen("trains.in", "r", stdin);
	freopen("trains.out", "w", stdout);
#endif

	int n, m;
	cin >> n >> m;

	vector<vector<pair<int, int> > > edges(n);

	for (int i = 0; i < m; i++) {
		int s;
		cin >> s;

		vector<int> tmp(2 * s + 1);

		for (int j = 0; j < 2 * s + 1; j++) {
			cin >> tmp[j];
		}

		for (int f = 0; f < 2 * s + 1; f += 2) {
			int c = 0;

			for (int t = f + 2; t < 2 * s + 1; t += 2) {
				c += tmp[t - 1];

				edges[tmp[f] - 1].push_back({tmp[t] - 1, c});
			}
		}
	}

	vector<Dist> dist(n, {INF, -1});
	dist[0] = {0, 0};
	set<pair<Dist, int> > q;
	q.insert({{0, 0}, 0});

	while (!q.empty()) {
		int v = q.begin()->second;
		q.erase(q.begin());

		for (auto e : edges[v]) {
			Dist nx = {dist[v].d + e.second, dist[v].g + e.second * e.second};

			if (nx < dist[e.first]) {
				q.erase({dist[e.first], e.first});
				dist[e.first] = nx;
				q.insert({dist[e.first], e.first});
			}
		}
	}

	cout << dist[n - 1].d << " " << dist[n - 1].g << "\n";

	return 0;
}
