#include <bits/stdc++.h>

using namespace std;

struct Edge {
    int u, v;
    pair<long long, long long> w;

    Edge(int u, int v, long long ww) : u(u), v(v) {
        w.first = ww;
        w.second = ww * ww;
    }

    Edge() {}
};

const long long INF = 1000000000;
vector<vector<Edge>> al;
vector<long long> d1, d2;

int main() {
    int n, m;
    scanf("%d%d", &n, &m);
    al.resize(n);
    d1.assign(n, INF);
    d2.assign(n, -INF * INF);

    for (int i = 0; i < m; i++) {
        int s;
        scanf("%d", &s);
        vector<int> v(s + 1), t(s);
        scanf("%d", &v[0]);
        v[0]--;
        for (int j = 0; j < s; j++) {
            scanf("%d%d", &t[j], &v[j + 1]);
            v[j + 1]--;
        }

        for (int L = 0; L < s + 1; L++) {
            long long cur = 0;
            for (int R = L + 1; R < s + 1; R++) {
                cur += t[R - 1];
                al[v[L]].push_back(Edge(v[L], v[R], cur));
            }
        }
    }

    d1[0] = 0;
    d2[0] = 0;

    set<pair<pair<long long, long long>, int>> st;
    st.insert({{d1[0], -d2[0]}, 0});

    while (!st.empty()) {
        auto p = *st.begin();
        st.erase(st.begin());

        int u = p.second;
        long long curd1 = p.first.first;
        long long curd2 = -p.first.second;

        for (auto e : al[u]) {
            int v = e.v;
            long long nd1 = curd1 + e.w.first;
            long long nd2 = curd2 + e.w.second;
            if (d1[v] > nd1 || (d1[v] == nd1 && d2[v] < nd2)) {
                pair<pair<long long, long long>, int> pv = {{d1[v], -d2[v]}, v};
                if (st.count(pv)) {
                    st.erase(pv);
                }

                d1[v] = nd1;
                d2[v] = nd2;

                st.insert({{d1[v], -d2[v]}, v});
            }
        }
    }

    cout << d1[n - 1] << " " << d2[n - 1] << endl;

    return 0;
}

/*

2 1
1 1 3 2

5 2
4 1 3 2 3 3 5 5 10 4
3 4 2 2 1 3 4 1

5 2
3 1 1 2 2 3 3 4
3 2 2 3 3 4 4 5

 */
