#include <bits/stdc++.h>

using namespace std;

const long long INF = 1000000000000000000;
const long long cost = 1000000000;

const int MAXN = 100;

struct Stack1 {
    vector<long long> mn;

    Stack1() {
        mn.push_back(INF);
    }

    void push(long long x) {
        mn.push_back(min(mn.back(), x));
    }

    void pop() {
        mn.pop_back();
    }

    long long getMin() {
        return mn.back();
    }

    bool isEmpty() {
        return mn.size() == 1;
    }
};

struct Stack2 {
    vector<long long> st, mn;

    Stack2() {
        mn.push_back(INF);
    }

    void push(long long x) {
        st.push_back(x);
        mn.push_back(min(mn.back(), x));
    }

    long long pop() {
        long long ans = st.back();
        st.pop_back();
        mn.pop_back();
        return ans;
    }

    long long getMin() {
        return mn.back();
    }

    bool isEmpty() {
        return st.empty();
    }
};

struct Queue {
    Stack1 s1;
    Stack2 s2;

    Queue() {
        s1 = Stack1();
        s2 = Stack2();
    }

    void push(long long x) {
        s2.push(x);
    }

    void pop() {
        if (s1.isEmpty()) {
            while (!s2.isEmpty()) {
                s1.push(s2.pop());
            }
        }
        s1.pop();
    }

    long long getMin() {
        return min(s1.getMin(), s2.getMin());
    }
};

const int MAXA = 2000001;
long long ans[MAXA];
int l[MAXN], r[MAXN], c[MAXN], l1[MAXN], r1[MAXN];
Queue qs[2 * MAXN];
long long qm[2 * MAXN];
const int LG = 9;

long long sp[LG][2 * MAXN];
int p2[2 * MAXN];
int spsz;

void build() {
    p2[1] = 0;
    for (int i = 0; i < spsz; i++) {
        sp[0][i] = qm[i];
        if (i > 1) {
            p2[i] = p2[i / 2] + 1;
        }
    }
    p2[spsz] = p2[spsz / 2] + 1;
    for (int j = 1; j < LG; j++) {
        int ln = 1 << (j - 1);
        for (int i = 0; i < spsz; i++) {
            sp[j][i] = sp[j - 1][i];
            if (i + ln < spsz) {
                sp[j][i] = min(sp[j][i], sp[j - 1][i + ln]);
            }
        }
    }
}

long long gMin(int L, int R) {
    int len = R - L;
    int l1 = p2[len];
    return min(sp[l1][L], sp[l1][R - (1 << l1)]);
}

int main() {
    int n, a;
    scanf("%d%d", &n, &a);
    vector<int> lrs;
    for (int i = 0; i < n; i++) {
        scanf("%d%d%d", &l[i], &r[i], &c[i]);
        r[i]++;
        lrs.push_back(l[i]);
        lrs.push_back(r[i]);
    }

    sort(lrs.begin(), lrs.end());
    lrs.resize(unique(lrs.begin(), lrs.end()) - lrs.begin());

    // qs[i] хранит все элементы на отрезке [lrs[i], lrs[i + 1])

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < lrs.size(); j++) {
            if (lrs[j] == l[i]) {
                l1[i] = j;
            }
            if (lrs[j] == r[i]) {
                r1[i] = j;
            }
        }
    }

    long long added = cost;
    ans[a] = 0;

    // Move windows

    // TODO PODGON

    for (int j = 0; j < lrs.size() - 1; j++) {
        if (a + lrs[j + 1] - 1 <= a) {
            qs[j].pop();
        }
        if (a + lrs[j] - 1 <= a) {
            qs[j].push(ans[a + lrs[j] - 1]);
        }
    }

    for (int i = a - 1; i >= 0; i--) {
        long long cv = 0;
        // Choose min

        spsz = (int) (lrs.size() - 1);
        for (int j = 0; j < spsz; j++) {
            qm[j] = qs[j].getMin();
        }
        build();

        for (int j = 0; j < n; j++) {
            if (i + r[j] - 1 <= a) {
                long long mx = gMin(l1[j], r1[j]);
                cv = max(cv, mx - c[j] + added);
            }
        }
        ans[i] = cv - added;

        if (i != 0) {
            added += cost;

            // Move windows
            for (int j = 0; j < lrs.size() - 1; j++) {
                if (i + lrs[j + 1] - 1 <= a) {
                    qs[j].pop();
                }
                if (i + lrs[j] - 1 <= a) {
                    qs[j].push(ans[i + lrs[j] - 1]);
                }
            }
        }
    }

    cout << ans[0] + added << endl;

    return 0;
}