# include <iostream>
# include <stack>
# include <algorithm>
# include <vector>
# include <map>

using namespace std;

const int INF = 1e9 + 7;
char aa[4];

struct Point
{
    long long x, y;
    Point(){}
    Point(long long _x, long long _y)
    {
        x = _x;
        y = _y;
    }
    Point operator-(const Point &other) const
    {
        return Point(x - other.x, y - other.y);
    }
    long long operator^(const Point &other) const
    {
        return x * other.y - other.x * y;
    }
    long long sz() const
    {
        return x * x + y * y;
    }
    bool operator<(const Point &other) const
    {
        if (((*this) ^ other) == 0)
        {
            return sz() < other.sz();
        }
        else
        {
            return ((*this) ^ (other)) > 0;
        }
    }
    bool operator==(const Point &other) const
    {
        return x == other.x && y == other.y;
    }
};

map<Point, int> all;
vector<Point> obol(vector<Point> a)
{
    int n = a.size();
    pair<pair<long long, long long>, int> mn = {{INF, INF}, INF};
    for (int i = 0; i < n; i++)
    {
        mn = min(mn, {{a[i].x, a[i].y}, i});
    }
    swap(a[0], a[mn.second]);
    for (int i = 0; i < n; i++)
    {
        a[i].x -= mn.first.first;
        a[i].y -= mn.first.second;
    }
    vector<Point>::iterator it = a.begin();
    ++it;
    sort(it, a.end());
    vector<Point> curr;
    a.push_back(a[0]);
    curr.push_back(a[0]);
    for (int i = 1; i < n + 1; i++)
    {
        while (curr.size() > 1 && ((curr[(int)curr.size() - 2] - curr[(int)curr.size() - 1]) ^ (a[i] - curr[(int)curr.size() - 1])) >= 0) curr.pop_back();
        curr.push_back(a[i]);
    }
    for (int i = 0; i < curr.size(); i++)
    {
        curr[i].x += mn.first.first;
        curr[i].y += mn.first.second;
    }
    return curr;
}

bool is_inside(const Point &A, const Point &B, const Point &C, const Point &D)
{
    if (A == D || B == D || C == D) return false;
    long long f = ((D - A) ^ (B - A)), s = ((D - A) ^ (C - A)), t = ((D - B) ^ (A - B)), fo = ((D - B) ^ (C - B));
    if (f > 0 && s > 0) return false;
    if (s < 0 && f < 0) return false;
    if (t > 0 && fo > 0) return false;
    if (fo < 0 && t < 0) return false;
    return true;
}

vector<Point> p, ob;

void fool(vector<Point> curr)
{
    for (int i = 0; i < curr.size(); i++)
    {
        for (int j = i + 1; j < curr.size(); j++)
        {
            for (int k = j + 1; k < curr.size(); k++)
            {
                cout << "? " << all[curr[i]] << " " << all[curr[j]] << " " << all[curr[k]] << endl;
                cin >> aa;
                if (aa[0] == 'Y')
                {
                    bool flag = true;
                    for (int t = 0; t < curr.size(); t++)
                    {
                        if (t == i || t == j || t == k) continue;
                        if (is_inside(curr[i], curr[j], curr[k], curr[t]))
                        {
                            flag = false;
                            break;
                        }
                    }
                    if (flag)
                    {
                        cout << "! " << all[curr[i]] << " " << all[curr[j]] << " " << all[curr[k]] << endl;
                        return;
                    }
                }
            }
        }
    }
}

/*void solve()
{
    int n = p.size(), m = ob.size();
    while (true)
    {
        int l = 1, r = m - 1;
        while (r - l > 1)
        {
            int mid = (l + r) / 2;
            cout << "? " << mid + 1 << " ";
            for (int i = 0; i <= mid; i++)
            {
                cout << all[ob[i]] << " ";
            }
            cout << endl;
            cin >> aa;
            if (aa[0] == 'Y')
            {
                r = mid;
            }
            else
            {
                l = mid;
            }
        }
        vector<Point> curr;
        for (int i = 0; i < n; i++)
        {
            if (is_inside(ob[0], ob[l], ob[r], p[i]))
            {
                curr.push_back(p[i]);
            }
        }
        if (curr.size() <= 3)
        {
            curr.push_back(ob[0]);
            curr.push_back(ob[l]);
            curr.push_back(ob[r]);
            fool(curr);
            break;
        }
    }
} */

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        long long x, y;
        cin >> x >> y;
        p.push_back(Point(x, y));
        all[*p.rbegin()] = i + 1;
    }
    ob = obol(p);
    int q;
    cin >> q;
    while (q--)
    {
        fool(p);
    }
}

