#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <list>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> par;
typedef vector<ll> vll;
typedef vector<par> vpar;

#define forn(i, b, n) for(ll i = b; i < n; ++i)
#define rforn(i, b, n) for(ll i = b; i >= n; --i)
#define F first
#define S second
#define all(x) (x).begin(), (x).end()
#define mp make_pair

void error() { cout << "No\n"; }
void OK() { cout << "Yes\n"; }

struct L {
	ll x, y;
	L *l, *r;
	L() {}
	L(ll x, ll y) : x(x), y(y), l(0), r(0) {}
};

void addL(ll x, ll y, L *& b, L *& e) {
	L *cur = new L(x, y);
	if (e == 0) {
		b = cur;
		e = cur;
	}
	else {
		auto tmp = e;
		e = cur;
		tmp->r = e;
		e->l = tmp;
	}
}

void deleteL(L *cur, L *& b, L *& e) {
	if (cur->l) cur->l->r = cur->r;
	if (cur->r) cur->r->l = cur->l;
	if (b == cur) b = cur->r;
	if (e == cur) e = cur->l;
	delete cur;
	cur = 0;
}

void gen(string &s, string &t) {
	ll len = rand() % 16 + 1;
	forn(i, 0, len) t.push_back('+');
	forn(i, 0, len) s.push_back((rand() % 2 ? '+' : '-'));
}

int source(string s, string t) {
	//cin >> s >> t;
	if (s == t) {
		OK();
		return 0;
	}
	vpar a, b;
	if (s.size() != t.size()) {
		error();
		return 0;
	}
	ll n = s.size();
	forn(i, 0, n) {
		if (!i || (s[i] != s[i - 1])) a.push_back(par((s[i] == '+' ? 1 : 0), 1));
		else a[a.size() - 1].S++;
	}
	forn(i, 0, n) {
		if (!i || (t[i] != t[i - 1])) b.push_back(par((t[i] == '+' ? 1 : 0), 1));
		else b[b.size() - 1].S++;
	}
	ll l = 0, r = 0;
	forn(i, 0, b.size()) {
		if (a[i] == b[i]) ++l;
		else break;
	}
	reverse(all(a));
	reverse(all(b));
	forn(i, 0, b.size()) {
		if (a[i] == b[i]) ++r;
		else break;
	}
	reverse(all(a));
	reverse(all(b));
	vpar a1, b1;
	forn(i, l, a.size() - r) a1.push_back(a[i]);
	forn(i, l, b.size() - r) b1.push_back(b[i]);
	ll it = 0;
	forn(i, 0, b1.size()) {
		ll s1 = b1[i].S;
		ll type = b1[i].F;
		ll sum = 0;
		ll siz = 0;
		L *b = 0, *e = 0;
		while (it < a1.size() && a1[it].S + sum <= s1) {
			sum += a1[it].second;
			addL(a1[it].S, a1[it].F, b, e);
			it++;
			siz++;
		}
		if (sum != s1) {
			error();
			return 0;
		}
		if (b->y != type && ((it - siz) != 0)) {
			error();
			return 0;
		}
		if (e->y != type && it < a1.size()) {
			error();
			return 0;
		}
		L* cur = b;
		while (cur) {
			if (cur->y != type) {
				cur = cur->r;
				continue;
			}
			while (cur->l && cur->x > cur->l->x) {
				if (cur->l->l) {
					cur->l->l->x += cur->x + cur->l->x;
					auto tmpo = cur->l->l;
					tmpo->r = cur->r;
					deleteL(cur->l, b, e);
					deleteL(cur, b, e);
					cur = tmpo;
					siz -= 2;
				}
				else {
					cur->x += cur->l->x;
					deleteL(cur->l, b, e);
					siz--;
				}
			}

			while (cur->r && cur->x > cur->r->x) {
				if (cur->r->r) {
					cur->x += cur->r->x + cur->r->r->x;
					auto tmpo = cur->r->r->r;
					deleteL(cur->r->r, b, e);
					deleteL(cur->r, b, e);
					cur->r = tmpo;
					siz -= 2;
				}
				else {
					cur->x += cur->r->x;
					deleteL(cur->r, b, e);
					siz--;
				}
			}
			while (cur->l && cur->x > cur->l->x) {
				if (cur->l->l) {
					cur->l->l->x += cur->x + cur->l->x;
					auto tmpo = cur->l->l;
					tmpo->r = cur->r;
					deleteL(cur->l, b, e);
					deleteL(cur, b, e);
					cur = tmpo;
					siz -= 2;
				}
				else {
					cur->x += cur->l->x;
					deleteL(cur->l, b, e);
					siz--;
				}
			}
			cur = cur->r;
		}
		if (siz == 1 && b->y == type) {
			continue;
		}
		else {
			error();
			return 0;
		}
		//////
	}
	OK();
	return 0;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios::sync_with_stdio(0);
	ll test;
	cin >> test;
	forn(i, 0, test) {
		string s, t;
		cin >> s >> t;
		//gen(s, t);
		//cout << s << '\n' << t << '\n';
		source(s, t);
	}
	return 0;
}