#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef vector<ll> vll;

#define forn(i, b, n) for(ll i = b; i < n; ++i)
#define all(x) (x).begin(), (x).end()

#define TASK "sum"

string sum(string s1, string s2) {
	string res;
	ll add = 0;
	while (s1.size() < s2.size()) s1.push_back('0');
	while (s1.size() > s2.size()) s2.push_back('0');
	forn(i, 0, s1.size()) {
		ll tmp = s1[i] + s2[i] - 2 * '0' + add;
		res.push_back(tmp % 10 + '0');
		add = tmp / 10;
	}
	if (add) res.push_back(add + '0');
	reverse(all(res));
	return res;
}

bool f(string s1, string s2) {
	if (s2.size() > s1.size()) return 1;
	if (s2.size() < s1.size()) return 0;
	reverse(all(s1));
	reverse(all(s2));
	forn(i, 0, s2.size()) {
		if (s2[i] > s1[i]) return 1;
		if (s2[i] < s1[i]) return 0;
	}
	return 0;
}

string not_sum(string s1, string s2) {
	string res;
	ll add = 0;
	forn(i, 0, s2.size()) {
		ll tmp = s1[i] - s2[i] + add;
		res.push_back((tmp + 10) % 10 + '0');
		add = -(tmp < 0);
	}
	forn(i, s2.size(), s1.size()) {
		ll tmp = s1[i] + add - '0';
		res.push_back((tmp + 10) % 10 + '0');
		add = -(tmp < 0);
	}
	while (res.size() && res.back() == '0') res.pop_back();
	if (res.empty()) res.push_back('0');
	reverse(all(res));
	return res;
}

int source() {
	string s1, s2;
	cin >> s1 >> s2;
	reverse(all(s1));
	reverse(all(s2));
	bool flag1 = s1.back() == '-';
	bool flag2 = s2.back() == '-';
	if (flag1) s1.pop_back();
	if (flag2) s2.pop_back();
	if (flag1 == flag2) {
		if (flag1) cout << '-';
		cout << sum(s1, s2);
	} else {
		if (flag1) swap(s1, s2);
		if (f(s1, s2)) {
			cout << '-';
			swap(s1, s2);
		}
		cout << not_sum(s1, s2);
	}
	//forn(i, 0, 1e8);
	return 0;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif
	ios::sync_with_stdio(0);
	source();
	return 0;
}