#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <vector>
#include <set>
#include <fstream>
#include <string>
#include <map>

using namespace std;

const int MAX = 13;

int n, q;

struct point {
	long long x, y;
	point() {}
	point(int a, int b) {
		x = a;
		y = b;
	}
};

struct vect {
	long long x, y;
	vect(int a, int b) {
		x = a;
		y = b;
	}
};

vect operator -(point a, point b) {
	return vect(b.x - a.x, b.y - a.y);
}

long long operator *(vect a, vect b) {
	return a.x * b.x + a.y * b.y;
}

long long operator %(vect a, vect b) {
	return a.x * b.y - a.y * b.x;
}

long long s(point a, point b, point c) {
	return fabs((a - b) % (a - c));
}

bool in(point a, point b, point c, point p) {
	return s(p, a, b) + s(p, a, c) + s(p, b, c) == s(a, b, c);
}

point p[MAX];

bool ask(int a, int b, int c) {
	cout << "? " << 3 << ' ' << a << ' ' << b << ' ' << c << endl;
	cout.flush();
	string ans;
	cin >> ans;
	return (ans == "Yes");
}

void out(int a, int b, int c) {
	cout << "! " << a << ' ' << b << ' ' << c << endl;
	cout.flush();
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	//ifstream cin("tests.txt");
	
	cin >> n;

	for (int i = 1; i <= n; i++) {
		cin >> p[i].x >> p[i].y;
	}

	cin >> q;

	for (; q > 0; q--) {
		int a, b, c;
		a = b = c = -1;
		for (int i = 1; i <= n && a == -1; i++) {
			for (int j = i + 1; j <= n && a == -1; j++) {
				for (int k = j + 1; k <= n && a == -1; k++) {
					if (ask(i, j, k)) {
						a = i;
						b = j;
						c = k;
					}
				}
			}
		}

		out(a, b, c);
	}
	return 0;
}

