#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <vector>
#include <set>
#include <fstream>
#include <string>
#include <map>

using namespace std;

const int MAX = 1e6 + 13;

int n, q;

struct point {
	long long x, y, id;
	point() {}
	point(long long a, long long b) {
		x = a;
		y = b;
	}
};

struct vect {
	long long x, y;
	vect(long long a, long long b) {
		x = a;
		y = b;
	}
};

bool operator <(point a, point b) {
	return a.x < b.x || (a.x == b.x && a.y < b.y);
}

vect operator -(point a, point b) {
	return vect(b.x - a.x, b.y - a.y);
}

long long operator *(vect a, vect b) {
	return a.x * b.x + a.y * b.y;
}

long long operator %(vect a, vect b) {
	return a.x * b.y - a.y * b.x;
}

long long s(point a, point b, point c) {
	return abs((a - b) % (a - c));
}

bool in(point a, point b, point c, point p) {
	return (s(p, a, b) + s(p, a, c) + s(p, b, c) == s(a, b, c));
}

point p[MAX];

bool ask(int a, int b, int c) {
	cout << "? " << 3 << ' ' << a << ' ' << b << ' ' << c << endl;
	cout.flush();
	string ans;
	cin >> ans;
	return (ans == "Yes");
}

void out(int a, int b, int c) {
	cout << "! " << 3 << ' ' << a << ' ' << b << ' ' << c << endl;
	cout.flush();
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	//ifstream cin("tests.txt");

	cin >> n;

	for (int i = 1; i <= n; i++) {
		cin >> p[i].x >> p[i].y;
		p[i].id = i;
	}

	sort(p + 1, p + n + 1);

	cin >> q;

	for (; q > 0; q--) {
		int a, b;
		a = b = -1;

		for (int i = 2; i <= n; i++) {
			bool fl = 0;
			for (int j = i + 1; j <= n; j++) {
				if (ask(p[1].id, p[i].id, p[j].id)) {
					a = i;
					b = j;
					fl = 1;
					break;
				}
			}
			if (fl)
				break;
		}

		int c = 1;

		while (1) {
			int v = -1;

			for (int i = 1; i <= n; i++) {
				if (i == c || i == a || i == b)
					continue;

				if (in(p[c], p[a], p[b], p[i])) {
					v = i;
				}
			}

			if (v == -1)
				break;

			if (ask(p[c].id, p[a].id, p[v].id)) {
				b = v;
				continue;
			}
			if (ask(p[c].id, p[b].id, p[v].id)) {
				a = v;
				continue;
			}
			c = v;
		}

		out(p[a].id, p[b].id, p[c].id);
	}
	return 0;
}