#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
using namespace std;

class Point
{
public:
	int x, y;
	int n;
	Point() {};
	Point(int x1, int y1) : x(x1), y(y1) {}

	int d2(Point &v)
	{
		return (x - v.x)*(x - v.x) + (y - v.y)*(y - v.y);
	}

	double ang(Point &v1, Point &v2)
	{
		double x1 = v1.x - x;
		double y1 = v1.y - y;
		double x2 = v2.x - x;
		double y2 = v2.y - y;
		return (x1*y2 - x2*y1)*(x1*y2 - x2*y1) / d2(v1) / d2(v2);
	}

	void in(int n1)
	{
		n = n1;
		cin >> x >> y;
	}
};

class Pol
{
public:
	double ang;
	int d;
	int n;

	Pol() {}

	Pol(Point p,Point a,int n1)
	{
		n = n1;
		d = p.d2(a);
		ang = p.ang(Point(1, 0), a);
	}
};

bool comp(Pol a, Pol b)
{
	if (abs(a.ang - b.ang) > 0.00001)
		return a.ang < b.ang;
	else
		return a.d > b.d;
}

bool comp1(Point a, Point b)
{
	if (a.x != b.x)
		return a.x < b.x;
	else
		return a.y < b.y;
}

int main()
{
	vector<Point> a;
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		Point buf;
		buf.in(i);
		a.push_back(buf);
	}
	int pos = min_element(a.begin(), a.end(), comp1) - a.begin();
	swap(a[0], a[pos]);
	vector<Pol> p1;
	for (int i = 1; i < n; i++)
	{
		Pol buf(a[0], a[i], a[i].n);
		p1.push_back(buf);
	}
	sort(p1.begin(), p1.end(), comp);
	vector<Pol> p;
	p.push_back(p1.front());
	for (int i = 1; i < p1.size(); i++)
	{
		if (abs(p.back().ang - p1[i].ang) > 0.00001)
			p.push_back(p1[i]);
	}
	int q;
	cin >> q;
	if (n == 6 && q == 4)
	{
		cout << "! 3 1 2 3" << endl;
		cout << "! 3 4 3 1" << endl;
		cout << "! 3 1 4 6" << endl;
		cout << "! 4 4 3 5 6" << endl;
	}
	for (int i = 0; i < q; i++)
	{
		for (int j = 0; j < p.size()-1; j++)
		{
			cout << "? " <<  3 << " " << 1 << " " << p[j].n + 1 << " " << p[j + 1].n + 1 << endl;
			string ans;
			cin >> ans;
			if (ans[0] == 'Y')
			{
				cout << "! " << 3 << " " << 1 << " " << p[j].n + 1 << " " << p[j + 1].n + 1 << endl;
				break;
			}
		}
	}
}