#include <iostream>
#include <fstream>
#include <utility>
#include <set>
#include <unordered_set>
#include <map>
#include <algorithm>
#include <vector>
#include <stack>
#include <string>
#include <cassert>
using namespace std;

/*

ifstream fin("input.txt");
ofstream fout("output.txt");

ifstream fin("order.in");
ofstream fout("order.out");

*/

#define int int64_t

ifstream fin("input.txt");
ofstream fout("output.txt");

int sgn(int a) {
	if (a < 0)
		return -1;
	else if (a > 0)
		return 1;
	return 0;
}

struct pt {
	int x, y, id;
	pt(int x = 0, int y = 0, int id = 0) : x(x), y(y), id(id) {}
};

ostream &operator<<(ostream &out, pt a) {
	out << a.x << " " << a.y << " " << a.id;
	return out;
}

struct trian {
	pt a, b, c;
	trian(pt a, pt b, pt c) : a(a), b(b), c(c) {}
};

struct vec {
	int x, y, id;
	vec(int x = 0, int y = 0, int id = 0) : x(x), y(y), id(id) {}
	vec(pt a, pt b) {
		x = b.x - a.x;
		y = b.y - a.y;
	}
};

pt glob_start;

int operator^(vec a, vec b) {
	return a.x * b.y - a.y * b.x;
}

bool comp(pair<vec, pt> a, pair<vec, pt> b) {
	return ((a.first ^ b.first) > 0);
}

bool query(vector<pt> &a, char c = '?') {
	cout << c << " " << a.size() << " ";
	for (auto p : a) {
		cout << p.id + 1 << " ";
	}
	cout << endl;

	if (c == '?') {
		string dec;
		cin >> dec;
		return (dec == "Yes");
	}
	else
		return true;
}


bool equal_line(pt a, pt b, pt p1, pt p2) {
	vec v1(a, b);
	vec v2(a, p1);
	vec v3(a, p2);

	return (sgn(v1 ^ v2) == sgn(v1 ^ v3));
}

bool in_tr(pt f, vector<pt> &cur) {
	pt a = cur[0];
	pt b = cur[1];
	pt c = cur[2];

	return equal_line(a, b, f, c) && equal_line(a, c, f, b) && equal_line(c, b, f, a);
}

bool is_good(vector<pt> &p, vector<pt> &cur) {
	for (auto f : p) {
		if (in_tr(f, cur))
			return false;
	}
	return true;
}



void solve(vector<trian> &triangles, vector<pt> &p) {
	for (auto tr : triangles) {
		vector<pt> qr;
		qr.push_back(tr.a);
		qr.push_back(tr.b);
		qr.push_back(tr.c);
		bool ans = query(qr);
		if (ans) {
			if (!is_good(p, qr))
				assert(0);
			query(qr, '!');
			return;
		}
	}
	assert(0);
}


signed main() {
	int n;
	cin >> n;
	vector<pt> p(n);
	for (int i = 0; i < n; i++) {
		cin >> p[i].x >> p[i].y;
		p[i].id = i;
	}
	int q;
	cin >> q;

	pt start = p[0];
	glob_start = start;
	for (auto f : p) {
		if (f.y < start.y || f.y == start.y && f.x < start.x)
			start = f;
	}

	vector<pair<vec, pt> > vecs(n - 1);
	for (int i = 1; i < n; i++) {
		vecs[i - 1] = { vec(start, p[i]), p[i] };
	}

	sort(vecs.begin(), vecs.end(), comp);
	vector<pt> sp;
	for (auto x : vecs)
		sp.push_back(x.second);

	vector<trian> triangles;
	for (int i = 1; i < sp.size(); i++) {
		triangles.push_back(trian(sp[i - 1], sp[i], start));
	}

	vector<pt> cur;
	for (auto x : sp)
		cur.push_back(x);

	bool is_changeable = true;
	while (is_changeable) {
		is_changeable = false;
		for (int i = 0; i < (int)cur.size() - 1; i++) {
			if (i + 2 < cur.size()) {
				pt a = cur[i], b = cur[i + 1], c = cur[i + 2];
				vec v1(a, b), v2(a, c);
				if ((v1 ^ v2) < 0) {
					is_changeable = true;
					triangles.push_back(trian(cur[i], cur[i + 1], cur[i + 2]));
					cur.erase(cur.begin() + i + 1);
				}
			}
		}
	}

	for (int qq = 0; qq < q; qq++) {
		solve(triangles, p);
	}

	return 0;
}