#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> need;


struct Node {
	Node *one = NULL, *zero = NULL;
	set<int> places;
	int _max_place = -1;
	int _min_place = 1e9;
	bool collission = false;
	int level = -1;
	short int pref_push = -1;
	bool alive = true;

	friend bool is_alive(Node *&node) {
		if (!node) return false;
		if (!node->alive) {
			delete node;
			node = NULL;
			return false;
		} else {
			return true;
		}
	}

	void recalc() {
		if (level == -1) {
			_max_place = *places.rbegin();
			_min_place = *places.begin();
			collission = false;
		} else {
			_max_place = -1;
			if (is_alive(one)) _max_place = max(_max_place, one->_max_place);
			if (is_alive(zero)) _max_place = max(_max_place, zero->_max_place);

			_min_place = 1e9;
			if (is_alive(one)) _min_place = min(_min_place, one->_min_place);
			if (is_alive(zero)) _min_place = min(_min_place, zero->_min_place);

			// collission = (zero->_max_place > one->_max_place);
			if (pref_push != -1) {
				need[level][pref_push]--;
			}
			pref_push = -1;
			collission = false;
			if (is_alive(zero)) collission = zero->collission || collission;
			if (is_alive(one)) collission = one->collission || collission;
			if (is_alive(zero) && is_alive(one)) {
				if (zero->_max_place < one->_min_place) {
					pref_push = 0;
					need[level][0]++;
				} else
				if (one->_max_place < zero->_min_place) {
					pref_push = 1;
					need[level][1]++;
				} else {
					collission = true;
				}
			}
		}
	}

	void add(int value, int place) {
		if (level == -1) {
			places.insert(place);
		} else {
			if (value & (1 << level)) {
				if (!is_alive(one)) one = new Node(level - 1);
				one->add(value, place);
			} else {
				if (!is_alive(zero)) zero = new Node(level - 1);
				zero->add(value, place);
			}
		}
		recalc();
	}

	void del(int value, int place) {
		if (level == -1) {
			places.erase(place);
			if (places.empty()) {
				alive = false;
			}
		} else {
			if (value & (1 << level)) {
				// if (!one) one = new Node(level - 1);
				one->del(value, place);
				// if (!is_alive(one)) one = NULL;
			} else {
				// if (!zero) zero = new Node(level - 1);
				zero->del(value, place);
				// if (!is_alive(zero)) zero = NULL;
			}
			if (!is_alive(one) && !is_alive(zero)) {
				if (pref_push != -1) {
					need[level][pref_push]--;
				}
				alive = false;
			}
		}
		if (alive) {
			recalc();
		}
	}

	Node(int _level) {
		level = _level;
	}
};

int get_injector() {
	int inj = 0;
	for (int i = 0; i < 31; i++) {
		if (need[i][0] && need[i][1]) return -1;
		if (!need[i][0] && need[i][1]) {
			inj = inj | (1 << i);
		}
	}
	return inj;
}

signed main() {
	freopen("order.in", "r", stdin);
	freopen("order.out", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n;
	cin >> n;
	need.resize(31, {0, 0});
	vector<int> v(n);
	Node *root = new Node(30);

	for (int i = 0; i < n; i++) {
		int x;
		cin >> x;
		root->add(x, i);
		v[i] = x;
	}

	if (root->collission) {
		cout << -1 << endl;
	} else {
		cout << get_injector() << endl;
	}

	int cnt_q;
	cin >> cnt_q;
	for (int i = 0; i < cnt_q; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		root->del(v[a], a);
		v[a] = b;
		root->add(v[a], a);

		if (root->collission) {
			cout << -1 << endl;
		} else {
			cout << get_injector() << endl;
		}
	}

	// for (int i = 0; i < need.size(); i++) {
	// 	cout << need[i][0] << " " << need[i][1] << endl;
	// }


}