#include <bits/stdc++.h>

using namespace std;


struct Exp {
	int min, max, cost;

	Exp(int _min, int _max, int _cost) {
		min = _min;
		max = _max;
		cost = _cost;
	}

	Exp() {}
};

namespace TS {
	typedef pair<int, int> value_type;

	auto magic = [](const value_type &a, const value_type &b){
		return min(a, b);
	};

	struct Node {
		value_type value;
		Node *left_child, *right_child;
		int ths_left, ths_right;

		bool included_by(int qleft, int qright) {
			return (qleft <= ths_left && ths_right <= qright);
		}

		bool intersections_with(int qleft, int qright) {
			return !(ths_right <= qleft || qright <= ths_left);
		}

		bool is_list() {
			return ths_left + 1 == ths_right;
		}

		Node(int left, int right) {
			ths_left = left;
			ths_right = right;
			if (!is_list()) {
				int mid = (ths_right + ths_left) / 2;
				left_child = new Node(ths_left, mid);
				right_child = new Node(mid, ths_right);
				value = magic(left_child->value, right_child->value);
			} else {
				value = make_pair(left, 0);
			}
		}

		value_type query(int qleft, int qright) {
			if (included_by(qleft, qright)) {
				return value;
			}

			bool inleft = left_child->intersections_with(qleft, qright);
			bool inright = right_child->intersections_with(qleft, qright);

			if (inleft && inright) {
				return magic(left_child->query(qleft, qright), right_child->query(qleft, qright));
			} else if (inleft) {
				return left_child->query(qleft, qright);
			} else if (inright) {
				return right_child->query(qleft, qright);
			} else {
				assert(false);
			}
		}

		void replace(int i, value_type d) {
			if (is_list()) {
				value = d;
				return;
			}

			bool inleft = left_child->intersections_with(i, i + 1);
			bool inright = right_child->intersections_with(i, i + 1);

			if (inleft) {
				left_child->replace(i, d);
			}
			if (inright) {
				right_child->replace(i, d);
			}
			value = magic(left_child->value, right_child->value);
		}
	};
};

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	// freopen("anti.in", "r", stdin);
	// TS::Node ts(0, 10);
	// ts.replace(1, 3);
	// ts.replace(2, 2);
	// ts.replace(2, 10);
	// cout << ts.query(1, 3);
	// return 0;

	int n, max_w;
	cin >> n >> max_w;

	TS::Node ts(0, max_w + 1);
	vector<Exp> exps(n);
	for (int i = 0; i < n; i++) {
		int _min, _max, _cost;
		cin >> _min >> _max >> _cost;
		exps[i] = Exp(_min, _max, _cost);
	}

	for (int i = max_w; i > -1; i--) {
		pair<int, int> _max = { i, 0 };
		for (const Exp &exp : exps) {
			if (i + exp.max > max_w) continue;
			auto sub = ts.query(i + exp.min, i + exp.max + 1);
			sub.second -= exp.cost;
			_max = max(_max, sub);
		}
		// cout << _max.first << " " << _max.second << endl;
		ts.replace(i, _max);
	}

	long long rez = ts.query(0, 1).first;
	rez *= 1e9;
	rez += ts.query(0, 1).second;
	cout << rez << endl;

	// for (int i = 0; i <= 17; i++) {
		// cout << i << ": " << ts.query(i, i + 1).first << " " << ts.query(i, i + 1).second << endl;
	// }


}