#include <bits/stdc++.h>

using namespace std;

struct Node;
typedef Node* PNode;

struct Node {
    PNode prev = NULL;
    PNode next = NULL;
    int sz = 0;
    int toChange = false;
};

inline int getSize(PNode node) {
    return (node ? node->sz : 0);
}

PNode head;

inline void solve(PNode node) {
    if (!node)
        return;

    if (!node->toChange)
        return;

    if (getSize(node->prev) <= node->sz && getSize(node->next) <= node->sz)
        return;

    node->toChange = false;
    node->sz += getSize(node->prev) + getSize(node->next);

    if (node->next && node->next->next)
        node->next->next->prev = node;

    if (node->prev && node->prev->prev)
        node->prev->prev->next = node;

    if (node->prev)
        node->prev = node->prev->prev;

    if (node->next)
        node->next = node->next->next;

    //for (PNode cur = head; cur; cur = cur->next)
    //    cout << cur->sz << ' ';
    //cout << endl;

    solve(node->next);
    solve(node->prev);
}

int main() {
    ios_base::sync_with_stdio(false);

    int Q;
    cin >> Q;
    for (int T = 0; T < Q; T++) {
        string s, t;
        cin >> s >> t;
        int n = (int)s.size();
        vector< pair<int, int> > toChange;
        for (int i = 0; i < n; i++)
            if (s[i] != t[i]) {
                if (toChange.empty() || toChange.back().second < i || (i > 0 && t[i - 1] != t[i]))
                    toChange.push_back({i, i + 1});
                else
                    toChange.back().second++;
            }

        vector<int> segments(1, 0);
        for (int i = 1; i < n; i++)
            if (s[i - 1] != s[i])
                segments.push_back(i);
        segments.push_back(n);

        bool f = true;
        for (auto& i : toChange)
            if (!binary_search(segments.begin(), segments.end(), i.first) || !binary_search(segments.begin(), segments.end(), i.second))
                f = false;

        for (int i = 0; i + 1 < (int)toChange.size(); i++)
            if (toChange[i].second == toChange[i + 1].first)
                f = false;

        int m = (int)segments.size() - 1;

        if (f) {
            PNode cur = NULL;
            for (int i = 0; i < m; i++) {
                PNode node = new Node();
                node->sz = segments[i + 1] - segments[i];
                node->toChange = int(s[segments[i]] != t[segments[i]]);

                if (cur)
                    cur->next = node;

                node->prev = cur;

                cur = node;
            }

            if (cur)
                while (cur->prev != NULL)
                    cur = cur->prev;

            head = cur;
            for (cur = head; cur; cur = cur->next)
                solve(cur);

            for (cur = head; cur; cur = cur->next)
                if (cur->toChange)
                    f = false;
        }

        cout << (f ? "Yes" : "No") << endl;

        segments.clear();
        toChange.clear();
    }

    return 0;
}