#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <bitset>
#include <set>

using namespace std;

const int MAXN = 1005;
const long long INF = 1000000000;

vector < pair <long long, long long> > g[MAXN];
pair <long long, long long> dist[MAXN];
int n;


void dijkstra() {
    dist[1] = {0, 0};
    for(int i = 2; i <= n; i++) dist[i] = {INF, 0};
    set < pair < pair <long long, long long> , long long > > go;
    go.insert({{0, 0}, 1});

    while(!go.empty()) {
        pair < pair <long long, long long> , long long > now = *go.begin();
        go.erase(go.begin());
        for(auto j: g[now.second]) {
            if(dist[j.first].first > now.first.first + j.second || (dist[j.first].first == now.first.first + j.second && dist[j.first].second < now.first.second + j.second * j.second))
            {
                go.erase({dist[j.first], j.first});
                go.insert({{now.first.first + j.second, now.first.second + j.second * j.second}, j.first});
                dist[j.first] = {now.first.first + j.second, now.first.second + j.second * j.second};
            }
        }
    }
}

int main()
{
    cin >> n;
    int m;
    cin >> m;
    for(int i = 0; i < m; i++) {
        int tmp1;
        cin >> tmp1;
        int tmp2, tmp3;
        cin >> tmp1 >> tmp2 >> tmp3;
        g[tmp1].push_back({tmp3, tmp2});
        //g[tmp3].push_back({tmp1, tmp2});
    }

    dijkstra();

    //for(int i = 1; i <= n; i++) cout << dist[i].first << " " << dist[i].second << endl;

    cout << dist[n].first << " " << dist[n].second << endl;
    return 0;
}
