#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <bitset>
#include <set>

using namespace std;

const int MAXN = 1005;
const long long INF = 1000000000;

vector < pair <long long, long long> > g[MAXN];
pair <long long, long long> dist[MAXN];
int n;
vector <long long> city, way;


void dijkstra() {
    dist[1] = {0, 0};
    for(int i = 2; i <= n; i++) dist[i] = {INF, 0};
    set < pair < pair <long long, long long> , long long > > go;
    go.insert({{0, 0}, 1});

    while(!go.empty()) {
        pair < pair <long long, long long> , long long > now = *go.begin();
        //cout << "Iterating for vertex " << now.second << endl;
        go.erase(go.begin());
        for(auto j: g[now.second]) {
            if(dist[j.first].first > now.first.first + j.second || (dist[j.first].first == now.first.first + j.second && dist[j.first].second < now.first.second + j.second * j.second))
            {
                //cout << "Optimized for " << j.first << endl;
                go.erase({dist[j.first], j.first});
                go.insert({{now.first.first + j.second, now.first.second + j.second * j.second}, j.first});
                dist[j.first] = {now.first.first + j.second, now.first.second + j.second * j.second};
            }
        }
    }
}

int main()
{
    cin >> n;
    int m;
    cin >> m;
    for(int i = 0; i < m; i++) {
        int route;
        cin >> route;
        city.assign(route + 1, 0);
        way.assign(route, 0);
        for(int j = 0; j < route; j++) cin >> city[j] >> way[j];
        cin >> city[route];

        //all subdistances
        for(int j = 0; j < route; j++) {
            long long leng = 0;
            for(int k = j + 1; k <= route; k++) {
                leng += way[k - 1];
                g[city[j]].push_back({city[k], leng});
            }
        }
    }

    /*cout << "Graph" << endl;
    for(int i = 1; i <= n; i++) {
        cout << "Ver " << i << ": ";
        for(auto j: g[i]) cout << j.first << " ";
        cout << endl;
    }*/

    dijkstra();

    //for(int i = 1; i <= n; i++) cout << dist[i].first << " " << dist[i].second << endl;

    cout << dist[n].first << " " << dist[n].second << endl;
    return 0;
}
