#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const long long MAXA = 1200000;
const int MAXN = 105;
const long long COST = 1000000000;
long long a;

long long lex[MAXN], rex[MAXN], cex[MAXN];

struct segment_tree {
    vector <long long> t;
    int n;

    segment_tree(int val) {
        n = 1;
        while(n < val) n *= 2;
        t.assign(2 * n, COST * COST);
    }

    void update(int pos, long long val) {
        pos = pos + n - 1;
        t[pos] = val;
        while(pos >= 1) {
            pos /= 2;
            t[pos] = min(t[pos * 2], t[pos * 2 + 1]);
        }
    }

    long long nowget(int l, int r, int nowl, int nowr, int pos) {
        if(nowl > r || nowr < l) return COST * COST;
        if(nowl >= l && nowr <= r) return t[pos];
        return min(nowget(l, r, nowl, (nowl + nowr) / 2, pos * 2), nowget(l, r, (nowl + nowr) / 2 + 1, nowr, pos * 2 + 1));

    }

    long long get(int l, int r) {
        if(l == 0) return min(MAXA * COST, nowget(l + 1, r, 1, n, 1));
        return nowget(l, r, 1, n, 1);
    }
};

segment_tree garant(1);

int main()
{
    int n;
    cin >> n >> a;
    for(int i = 0; i < n; i++) cin >> lex[i] >> rex[i] >> cex[i];

    garant.n = 1;
    while(garant.n < a) garant.n *= 2;
    garant.t.assign(2 * garant.n, COST * COST);
    for(long long i = 1; i <= a; i++) garant.t[garant.n + i - 1] = (MAXA - i) * COST;
    for(long long i = a - 1; i >= 0; i--) garant.t[i] = min(garant.t[2 * i], garant.t[2 * i + 1]);

    //for(int i = 0; i <= a; i++) cout << garant.get(i, i) << endl;
    /*cout << "Got";
    for(auto j: garant.t) cout << j << " ";
    cout << endl;*/

    long long nowval, today;
    for(long long i = 1; i <= a; i++) {
        //cout << "Up for " << i << endl;
        for(int j = 0; j < n; j++) {
            if(i - rex[j] < 0) continue;
            nowval = garant.get(i - rex[j], i - lex[j]);
            //cout << nowval << endl;
            nowval -= (MAXA - i) * COST;
            nowval -= cex[j];
            today = garant.get(i, i);
            today -= (MAXA - i) * COST;
            //cout << nowval << " " << today << endl;
            if(nowval > today) {
                garant.update(i, nowval + (MAXA - i) * COST);
            }
        }
    }

    long long maxinc = 0;
    for(int i = 1; i <= a; i++) {
        maxinc = max(maxinc, garant.get(i, i) - (MAXA - i) * COST);
    }
    cout << maxinc;

    return 0;
}

