#include <iostream>
#include <cstring>
#include <vector>

using namespace std;

#define INF 200000000000ll

pair<long long, long long> intersect(const pair<long long, long long> &a, const pair<long long, long long> &b) {
    if (a.first > b.second || a.second < b.first) return make_pair(INF, INF);
    return make_pair(max(a.first, b.first), min(a.second, b.second));
}

int main() {
    int n = 0;
    cin >> n;
    int* t = new int[n];
    int* L = new int[n];
    int* R = new int[n];
    L[n - 1] = 0;
    R[n - 1] = INF;
    for (int i = 0; i < n; i++)
        cin >> t[i];
    for (int i = 0; i < (n - 1); i++)
        cin >> L[i] >> R[i];
    pair<long long, long long> IL[n], IR[n];
    IL[0] = pair<long long, long long>(0, INF);
    for (int i = 1; i < n; i++) {
        IL[i] = intersect(IL[i - 1], make_pair(L[i - 1], R[i - 1]));
        if (IL[i] !=  make_pair(INF, INF) && IL[i].first == L[i - 1]) IL[i].first -= t[i];
    }

    IR[n - 1] = pair<long long, long long>(0, INF);
    for (int i = n - 2; i >= 0; i--) {
        IR[i] = intersect(IR[i + 1], make_pair(L[i], R[i]));
        if (IR[i] !=  make_pair(INF, INF) && IR[i].first == L[i]) IR[i].first -= t[i];
    }
    for (int i = 0; i < n; i++) {
        auto res = intersect(IL[i], IR[i]);
        if (res == make_pair(INF, INF)) {
            cout << "-1\n";
        } else {
            cout << res.first << '\n';
        }
    }
    delete[] t;
    delete[] L;
    delete[] R;
    return 0;
}
