#include <iostream>
#include <vector>
#include <stack>
#include <cstdlib>

using namespace std;

bool ask(int l, int r) {
    cout << "? " << l + 1 << " " << r + 1 << endl;
    string ans;
    cin >> ans;
    return ans == "Yes";
}

vector<bool> ans;

stack<int> open;
stack<int> close;

void rek() {
    int l = open.top() + 1,
        r = close.top() - 1;
    if (l > r) {
        return;
    }
    if (ask(l, r)) {
        ans[l] = true;
        ans[r] = false;
        open.push(l);
        close.push(r);
        ++l, --r;
    } else {
        if (ask(open.top(), l)) {
            open.pop();
            ans[l] = false;
            ++l;
            if (open.empty() && l <= r) {
                ans[l] = true;
                open.push(l);
            }
        } else {
            close.pop();
            ans[r] = true;
            --r;
            if (close.empty() && l <= r) {
                ans[r] = false;
                close.push(r);
            }
        }
    }
    rek();
}

void finish() {
    cout << "! ";
    for (auto b : ans) {
        if (b) {
            cout << "(";
        } else {
            cout << ")";
        }
    }
    cout << "\n";
    exit(0);
}

int main() {
    int n;
    cin >> n;
    ans.resize(n);
    open.push(0);
    close.push(n - 1);
    ans[0] = true;
    ans[n - 1] = false;
    rek();
    finish();
    return 0;
}