#include <iostream>
#include <fstream>
#include <vector>
#include <map>
#include <set>

using namespace std;

typedef long long ll;

struct ForSet {
    ll sum;
    short l, r;
};

bool operator<(const ForSet &a, const ForSet &b) {
    return a.sum > b.sum || (a.sum == b.sum && a.l < b.l);
}

int main() {
    freopen("internship.in", "r", stdin);
    freopen("internship.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    short n, m;
    cin >> n >> m;
    vector<short> a(n);
    ll fake1[n + 1];
    ll *pref1 = fake1 + 1;
    pref1[-1] = 0;
    for (short i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (short i = 0; i < n; ++i) {
        int x;
        cin >> x;
        pref1[i] = pref1[i - 1] + x;
    }
    vector<short> b(m);
    ll fake2[m + 1];
    ll *pref2 = fake2 + 1;
    pref2[-1] = 0;
    map<int, short> indInS;
    for (short i = 0; i < m; ++i) {
        cin >> b[i];
        indInS[b[i]] = i;
    }
    for (short i = 0; i < m; ++i) {
        int y;
        cin >> y;
        pref2[i] = pref2[i - 1] + y;
    }
    vector<vector<multiset<ForSet>>> dp(n, vector<multiset<ForSet>>(n));
    vector<vector<set<short>>> in(n, vector<set<short>>(n));
    for (short i = 0; i < n; ++i) {
        short last = -1;
        in[i][i].insert(last);
        if (indInS.find(a[i]) != indInS.end()) {
            short el = indInS[a[i]];
            in[i][i].insert(el);
            if (last < el - 1) {
                dp[i][i].insert({pref2[el - 1S] - pref2[last], last + 1S, el - 1S});
            }
            last = el;
        }
        if (last < m - 1) {
            dp[i][i].insert({pref2[m - 1S] - pref2[last], last + 1S, m - 1S});
        }
        in[i][i].insert(m);
    }
    ll ans = pref2[m - 1];
    short ansLA = 0, ansRA = 0, ansLB = 1, ansRB = m;
    for (short len = 0; len < n; ++len) {
        for (short l = 0; l < n - len; ++l) {
            short r = l + len;
            ll maxSum = (dp[l][r].empty()) ? 0 : dp[l][r].begin()->sum;
            if (pref1[r] - pref1[l - 1] + maxSum > ans) {
                ans = pref1[r] - pref1[l - 1] + maxSum;
                if (maxSum) {
                    ansLB = dp[l][r].begin()->l + 1S;
                    ansRB = dp[l][r].begin()->r + 1S;
                } else {
                    ansLB = 0, ansRB = 0;
                }
                ansLA = l + 1S, ansRA = r + 1S;
            }
            short nr = r + 1S;
            if (nr == n) {
                dp[l][r].clear();
                in[l][r].clear();
                continue;
            }
            in[l][nr] = in[l][r];
            dp[l][nr] = dp[l][r];
            if (indInS.find(a[nr]) == indInS.end()) {
                continue;
            }
            short el = indInS[a[nr]];
            auto it = in[l][r].upper_bound(el);
            short to = *it;
            --it;
            short fr = *it;
            ll oldSum = pref2[to - 1] - pref2[fr];
            ll nSum = pref2[el - 1] - pref2[fr];
            ll nSum2 = pref2[to - 1] - pref2[el];
            in[l][nr].insert(el);
            dp[l][nr].erase({oldSum, fr + 1S, to - 1S});
            if (nSum) {
                dp[l][nr].insert({nSum, fr + 1S, el - 1S});
            }
            if (nSum2) {
                dp[l][nr].insert({nSum2, el + 1S, to - 1S});
            }
            dp[l][r].clear();
            in[l][r].clear();
        }
    }
    cout << ans << "\n" << ansLA << " " << ansRA << "\n" << ansLB << " " << ansRB << "\n";
    return 0;
}