// D4_Railway.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <vector>
#include <set>

using namespace std;

struct End
{
	int v;
	long long t;

	End(int w = 0, long long tt = 0) :
		v(w), t(tt) {}
};

struct Time
{
	long long tm;
	long long sq;

	Time(long long t, long long s) :
		tm(t), sq(s) {}
	Time(long long t = 0) :
		tm(t), sq(t * t) {}

	Time operator +(Time t)
	{
		return Time(tm + t.tm, sq + t.sq);
	}
};

bool operator <(Time t1, Time t2)
{
	return (t1.tm < t2.tm || t1.tm == t2.tm && t1.sq > t2.sq);
}

const long long INF = (1e16);
const int LEN = (1e6);

vector <End> path[LEN];
int n, m, s, dest[LEN];
//set <pair <Time, int> > fr;
//Time dist[LEN];
//vector <Time> dist;
Time dist[LEN];
long long tm[LEN], tmcnt;

int main()
{
	cin.tie(NULL);

	cin >> n >> m;

	//path.clear();
	//path.resize(n);
	for (int i = 0; i < n; i++)
		path[i].clear();

	//int dest[LEN];
	//long long tm[LEN], tmcnt;
	for (int i = 0; i < m; i++)
	{
		cin >> s >> dest[0];
		dest[0]--;
		for (int j = 1; j <= s; j++)
		{
			cin >> tm[j] >> dest[j];
			dest[j]--;
		}
		for (int b = 0; b < s; b++)
		{
			tmcnt = 0;
			for (int e = b + 1; e <= s; e++)
			{
				tmcnt += tm[e];
				path[dest[b]].push_back(End(dest[e], tmcnt));
			}
		}
	}

	//dist.clear();
	//dist.resize(n, Time(-1, 0));
	for (int i = 0; i < n; i++)
		dist[i] = Time(-1, 0);
	dist[0] = Time(0, 0);
	//fr.clear();
	//fr.insert(make_pair(Time(0, 0), 0));

	pair <Time, int> p;
	int v, vi;
	Time d;
	for (int i = 0; i < n; i++)
	{
		//p = (*fr.begin());
		//fr.erase(p);
		//v = p.second, d = p.first;
		d = Time(INF, 0);
		for (v = 0; v < n; v++)
		{
			if (dist[v].tm != -1 && dist[v] < d)
			{
				d = dist[v];
				vi = v;
			}
		}
		v = vi;
		for (int j = 0; j < path[v].size(); j++)
		{
			if (dist[path[v][j].v].tm == -1 || d + Time(path[v][j].t) < dist[path[v][j].v])
			{
				//fr.erase(make_pair(dist[path[v][j].v], path[v][j].v));
				dist[path[v][j].v] = d + Time(path[v][j].t);
				//fr.insert(make_pair(dist[path[v][j].v], path[v][j].v));
			}
		}
	}

	cout << dist[n - 1].tm << ' ' << dist[n - 1].sq << '\n';
	cout.flush();

	return 0;
}