#include <bits/stdc++.h>

using namespace std;

bool get_bit(int mask, int i) {
    return (mask & (1 << i)) > 0;
}

int n;
vector<int> b;

struct segment_tree {
    vector<int> st;
    int n_;

    segment_tree() {
        n_ = 0;
    }

    segment_tree(vector<int>& a) {
        n_ = a.size();
        st.assign(n_ * 4, 0);
        build(a, 1, 0, n_ - 1);
    }

    void build(vector<int>& a, int v, int l, int r) {
        if (l == r) {
            st[v] = a[l];
        } else {
            int m = (l + r) / 2;
            build(a, v * 2, l, m);
            build(a, v * 2 + 1, m + 1, r);
            st[v] = st[v * 2] + st[v * 2 + 1];
        }
    }

    int get(int v, int i, int sl, int sr) {
        if (sl == sr) {
            return st[v];
        } else {
            int m = (sl + sr) / 2;
            if (i <= m) {
                return get(v * 2, i, sl, m);
            } else {
                return get(v * 2 + 1, i, m + 1, sr);
            }
        }
    }

    void change(int v, int i, int x, int sl, int sr) {
        if (sl == sr) {
            st[v] = x;
        } else {
            int m = (sl + sr) / 2;
            if (i <= m) {
                change(v * 2, i, x, sl, m);
            } else {
                change(v * 2 + 1, i, x, m + 1, sr);
            }
            st[v] = st[v * 2] + st[v * 2 + 1];
        }
    }

    int get_sum(int v, int ql, int qr, int sl, int sr) {
        if (ql <= sl && sr <= qr) {
            return st[v];
        } else if (sr < ql || qr < sl) {
            return 0;
        } else {
            int m = (sl + sr) / 2;
            int ans_l = get_sum(v * 2, ql, qr, sl, m);
            int ans_r = get_sum(v * 2 + 1, ql, qr, m + 1, sr);
            return ans_l + ans_r;
        }
    }
};

vector<segment_tree> a;

void get_ans(int l, int r, int lev) {
    if (lev == -1) {
        return;
    }
    int sum = a[lev].get_sum(1, l, r, 0, n - 1);
    if (sum == 0 || sum == r - l + 1) {
        get_ans(l, r, lev - 1);
        return;
    }
    if (a[lev].get(1, l, 0, n - 1) == 1) {
        int bl = l;
        int br = r + 1;
        while (bl < br) {
            int bm = (bl + br) / 2;
            sum = a[lev].get_sum(1, l, bm, 0, n - 1);
            if (sum == bm - l + 1) {
                bl = bm + 1;
            } else {
                br = bm;
            }
        }
        bl--;
        if (a[lev].get_sum(1, bl + 1, r, 0, n - 1) != 0) {
            b[lev] = -1;
            return;
        }
        get_ans(l, bl, lev - 1);
        get_ans(bl + 1, r, lev - 1);
        if (b[lev] < 1) {
            b[lev] = -1;
        } else if (b[lev] == 2) {
            b[lev] = 1;
        }
    } else {
        int bl = l;
        int br = r + 1;
        while (bl < br) {
            int bm = (bl + br) / 2;
            sum = a[lev].get_sum(1, l, bm, 0, n - 1);
            if (sum == 0) {
                bl = bm + 1;
            } else {
                br = bm;
            }
        }
        bl--;
        if (a[lev].get_sum(1, bl + 1, r, 0, n - 1) != r - bl) {
            b[lev] = -1;
            return;
        }
        get_ans(l, bl, lev - 1);
        get_ans(bl + 1, r, lev - 1);
        if (b[lev] == 1 || b[lev] == -1) {
            b[lev] = -1;
        } else if (b[lev] == 2) {
            b[lev] = 0;
        }
    }
}

int get_b() {
    b.assign(33, 2);
    get_ans(0, n - 1, 31);
    int ans = 0;
    for (int i = 31; i >= 0; i--) {
        if (b[i] == 2 || b[i] == 0) {
            continue;
        } else if (b[i] == -1) {
            return -1;
        } else if (b[i] == 1) {
            ans += (1ll << i);
        }
    }
    return ans;
}

main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    b.assign(32, 0);
    int num = 0;
    vector<vector<int>> vs(32, vector<int>(n, 0));
    for (int i = 0; i < n; i++) {
        cin >> num;
        for (int k = 31; k >= 0; k--) {
            vs[k][i] = get_bit(num, k);
        }
    }
    a.assign(32, segment_tree());
    for (int i = 0; i < 32; i++) {
        a[i] = segment_tree(vs[i]);
    }
    int q_ans = get_b();
    cout << q_ans << '\n';
    int q;
    cin >> q;
    int j, x;
    for (int i = 0; i < q; i++) {
        cin >> j >> x;
        j--;
        for (int k = 0; k < 32; k++) {
            a[k].change(1, j, get_bit(x, k), 0, n - 1);
        }
        q_ans = get_b();
        cout << q_ans << '\n';
    }
    int kek = 0;
}
