#include <iostream>
#include <algorithm>
#include <cstdio>
#include <set>
#include <cassert>
#include <vector>

using namespace std;

const int LEN = 33;
const int MAXN = 2e6;

int lcp[MAXN];
int a[MAXN];
int n;

int add[MAXN];
int del[MAXN];

void clear_(int pos) {
    int l = lcp[pos];
    int g1 = a[pos] / (1 << (l - 1)) % 2;
    int g2 = a[pos + 1] / (1 << (l - 1)) % 2;
    if (g1 != g2) {
        if (g1 == 0) {
            add[l]--;
        }
        else {
            del[l]--;
        }
    }
}

void push(int pos) {
    int l = lcp[pos];
    int g1 = a[pos] / (1 << (l - 1)) % 2;
    int g2 = a[pos + 1] / (1 << (l - 1)) % 2;
    if (g1 != g2) {
        if (g1 == 0) {
            add[l]++;
        }
        else {
            del[l]++;
        }
    }
}

int update(int pos, int f) {
    if (pos - 1 >= 0)
        clear_(pos - 1);
    if (pos + 1 < n)
        clear_(pos);
    a[pos] = f;
    for (int i = LEN; i >= 0; i--) {
        if (pos > 0 && a[pos] / (1 << i) == a[pos - 1] / (1 << i))
            lcp[pos - 1] = i;
        if (pos + 1 < n && a[pos] / (1 << i) == a[pos + 1] / (1 << i))
            lcp[pos] = i;
    }
    if (pos - 1 >= 0)
        push(pos - 1);
    if (pos + 1 < n)
        push(pos);

    int ans = 0;
    for (int i = 1; i < LEN; i++) {
        if (add[i] && del[i])
            return -1;
        else if (del[i])
            ans += (1 << (i - 1));
    }

    return ans;
}

int main() {
    //assert(freopen("input.txt", "r", stdin));
    //assert(freopen("output.txt", "w", stdout));

    ios_base::sync_with_stdio(false);

    cin >> n;
    int cur = 0;
    for (int i = 0; i < n; i++) {
        int a; cin >> a;
        cur = update(i, a);
    }

    cout << cur << endl;

    int m; cin >> m;
    for (int i = 0; i < m; i++) {
        int pos, f; cin >> pos >> f;
        cout << update(pos - 1, f) << endl;
    }

    return 0;
}
