#include <iostream>
#include <algorithm>
#include <cstdio>
#include <set>
#include <cassert>
#include <vector>
#include <cmath>
#include <map>

#define int int64_t

using namespace std;

const int MAXN = 2e6;

int sqr(int a) { return a * a; }

vector <vector <pair <int, int> > > f;
vector <vector <int> > pref_sum;

map <pair <int, int>, pair <int, int> > dp;
map <pair <int, int>, bool> was;
map <pair <int, int>, int> parent;

vector <pair <int, int> > inv_gr[MAXN];

void get(int v, int p) {
    if (was[make_pair(v, p)])
        return;
    dp[make_pair(v, p)] = make_pair(2e18, -2e18);
    was[make_pair(v, p)] = true;
    if (v == 0) {
        dp[make_pair(v, p)] = make_pair(0, 0);
        return;
    }
    vector <int> colors;
    for (int i = 0; i < (int)inv_gr[v].size(); i++) if (inv_gr[v][i].second != p) {
        int to = inv_gr[v][i].first;
        int color = inv_gr[v][i].second;
        colors.push_back(color);
    }
    for (int c : colors) {
        int l = -1;
        for (int j = 0; l == -1; j++)
            if (f[c][j].first == v)
                l = j;
        for (int j = 0; f[c][j].first != v; j++) {
            get(f[c][j].first, c);
            dp[make_pair(v, p)] = min(dp[make_pair(v, p)], make_pair(dp[make_pair(f[c][j].first, c)].first + (pref_sum[c][l] - pref_sum[c][j]),
                                                                     dp[make_pair(f[c][j].first, c)].second - sqr(pref_sum[c][l] - pref_sum[c][j])));
        }
    }
}

int32_t main() {
    //assert(freopen("input.txt", "r", stdin));
    //assert(freopen("output.txt", "w", stdout));

    ios_base::sync_with_stdio(false);

    int n; cin >> n;
    int m; cin >> m;
    for (int i = 0; i < m; i++) {
        int s; cin >> s;
        f.push_back({});
        for (int j = 0; j < s; j++) {
            int v, t; cin >> v >> t;
            f.back().push_back(make_pair(v - 1, t));
        }
        int v; cin >> v;
        f.back().push_back(make_pair(v - 1, -1));

        for (int j = 0; j < (int)f.back().size() - 1; j++)
            inv_gr[f.back()[j + 1].first].push_back(make_pair(f.back()[j].first, i));
        pref_sum.push_back({0});
        for (int i = 0; i < (int)f.back().size() - 1; i++)
            pref_sum.back().push_back(pref_sum.back().back() + f.back()[i].second);
    }

    get(n - 1, -1);
    pair <int, int> ans = dp[make_pair(n - 1, -1)];

    cout << ans.first << " " << -ans.second << endl;

    return 0;
}
