#include<iostream>
#include<vector>
#include<string>

#define int long long

using namespace std;

struct point {
	int x, y;
	point() {}
	point(int x, int y) : x(x), y(y) {}
};

struct vect {
	int x, y;
	vect(int x, int y) : x(x), y(y) {}
	vect(point a, point b) : x(b.x - a.x), y(b.y - a.y) {}
	int operator^(const vect& b) const {
		return x * b.y - y * b.x;
	}
};

vector<point> ps;


int ask(int a1, int a2, int a3) {
	cout << "? " << a1 << " " << a2 << " " << a3 << endl;
	string res;
	cin >> res;
	return res == "Yes";
}

void answer(int a1, int a2, int a3) {
	cout << "! " << a1 << " " << a2 << " " << a3 << endl;
	//exit(0);
}

int sgn(int x) {
	return (x > 0) - (x < 0);
}

bool inside(point x, point a, point b, point c) {
	vect ab(a, b), ax(a, x);
	vect bc(b, c), bx(b, x);
	vect ca(c, a), cx(c, x);
	int sa = sgn(ab ^ ax), sb = sgn(bc ^ bx), sc = sgn(ca ^ cx);
	return (sa == sb && sb == sc);
}

int32_t main() {
	//freopen("input.in", "r", stdin);
	int n;
	cin >> n;
	ps.resize(n);
	for (int i = 0; i < n; i++)
		cin >> ps[i].x >> ps[i].y;
	int q;
	cin >> q;
	for (int cq = 0; cq < q; cq++) {
		bool was = false;
		for (int i = 0; i < n && !was; i++) {
			for (int j = i + 1; j < n && !was; j++) {
				for (int k = j + 1; k < n && !was; k++) {
					bool ok = true;
					for (int l = 0; l < n; l++) {
						if (l == i || l == j || l == k)
							continue;
						if (inside(ps[l], ps[i], ps[j], ps[k]))
							ok = false;
					}
					if (!ok)
						continue;
					if (ask(i, j, k)) {
						answer(i, j, k);
						was = true;
					}
				}
			}
		}
	}
}