#include<iostream>
#include<vector>
#include<string>
#include<cassert>
#include<functional>
#include<queue>

#define int long long
#define cp pair<pair<int, int>, int>

using namespace std;

const int inf = 1e18;

vector<vector<pair<int, int> > > edg;

struct cmp {
	bool operator()(cp a, cp b) {
		if (a.first.first != b.first.first)
			return a.first.first > b.first.first;
		return a.first.second < b.first.second;
	}
};

vector<int> used;
int n;
int mn = inf, mx = -inf;
void walk(int v, int len = 0, int len2 = 0) {
	if (v == n - 1) {
		if (len < mn || (len == mn && len2 > mx)) {
			mn = len, mx = len2;
		}
		return;
	}
	used[v] = 1;
	for (int i = 0; i < edg[v].size(); i++) {
		int to = edg[v][i].first;
		if (used[to])
			continue;
		int w = edg[v][i].second;
		walk(edg[v][i].first, len + w, len2 + (w * w));
	}
	used[v] = 0;
}

int32_t main() {
	//freopen("input.in", "r", stdin);
	ios_base::sync_with_stdio(false);
	int m;
	cin >> n >> m;
	edg.resize(n);
	used.assign(n, false);
	for (int i = 0; i < m; i++) {
		int t;
		cin >> t;
		int u, v;
		cin >> u >> t >> v;
		u--, v--;
		edg[u].push_back({ v, t });
		//edg[v].push_back({ u, t });
	}
	vector<cp> d(n, cp({ inf, -inf }, -1));
	priority_queue<cp, vector<cp>, cmp> q;
	d[0] = cp({ { 0, 0 }, 0 });
	q.push({ { 0, 0 }, 0 });
	while (!q.empty()) {
		auto pos = q.top();
		q.pop();
		int cv = pos.second;
		if (cmp()(pos, d[cv]))
			continue;
		for (int i = 0; i < edg[cv].size(); i++) {
			int to = edg[cv][i].first;
			int w = edg[cv][i].second;
			cp cur({ { pos.first.first + w, pos.first.second + w * w }, to });
			if (cmp()(d[to], cur)) {
				d[to] = cur;
				q.push(cur);
			}
		}
	}
	cout << d[n - 1].first.first << " " << d[n - 1].first.second << "\n";
}