#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cmath>
#include <set>

#define mp make_pair
#define fst first
#define snd second
#define sz(a_) int((a_).size())

using namespace std;

constexpr int maxn = 2e3;
constexpr int maxm = 1e5+20;

using ll = long long;
using pii = pair<int, ll>;
const ll inf = 1e17;

struct tr {
    int a, b, v;
};

vector<pii> g[maxn];
vector<tr> trs[maxm];

ll dist[maxn];
ll comf[maxn];

int main()
{
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int s;
        cin >> s;
        int prev;
        cin >> prev;
        --prev;
        for (int j = 0; j < s; ++j) {
            int v, b;
            cin >> v >> b;
            --b;
            g[prev].push_back(mp(b, v));
            trs[i].push_back(tr{prev, b, v});
            prev = b;
        }
    }
    for (int i = 0; i < n; ++i) {
        dist[i] = inf;
        comf[i] = -inf;
    }
    dist[0] = 0;
    comf[0] = 0;
    for (int i = 0; i < n; ++i) {
        for (int a = 0; a < n; ++a) {
            for (auto to: g[a]) {
                dist[to.fst] = min(dist[to.fst], dist[a]+to.snd);
            }
        }
    }
    cout << dist[n-1] << ' ';
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            for (int k = 0; k < sz(trs[j]); ++k) {
                ll len = 0;
                for (int u = k; u >= 0; --u) {
                    len += trs[j][u].v;
                    if (dist[trs[j][k].b]-dist[trs[j][u].a] == len) {
                        comf[trs[j][k].b] = max(comf[trs[j][k].b], comf[trs[j][u].a]+len*len);
                    }
                }
            }
        }
    }
    cout << comf[n-1] << '\n';
    return 0;
}