#include <iostream>
#include <set>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <cassert>
#include <climits>
#include <functional>
#include <vector>

using namespace std;

typedef unsigned int index;

struct Edge
{
	index to;
	int w;
	Edge(index new_to, int new_w): to(new_to), w(new_w){}
};


int main()
{
#ifdef ONPC
	assert(freopen("a.in", "r", stdin));
	assert(freopen("a.out", "w", stdout));
#else
	assert(freopen("trains.in", "r", stdin));
	assert(freopen("trains.out", "w", stdout));
#endif
	ios::sync_with_stdio(false);
	size_t n, m;
	cin >> n >> m;
	vector<vector<Edge>> g(n);
	for (index i = 0; i < m; i++)
	{
		size_t s;
		index cur;
		cin >> s >> cur;
		cur--;
		for (index j = 0; j < s; j++)
		{
			index to;
			int w;
			cin >> w >> to;
			to--;
			g[cur].push_back({to, w});
			cur = to;
		}
	}
	set<pair<int, index>> a;
	vector<int> d(n, INT_MAX / 2);
	d[0] = 0;
	a = {{0, 0}};
	while (!a.empty())
	{
		index nw = a.begin()->second;
		int cw = a.begin()->first;
		a.erase(a.begin());
		if (cw > d[nw])
			continue;
		for (auto i: g[nw])
		{
			if (d[i.to] > d[nw] + i.w)
			{
				d[i.to] = d[nw] + i.w;
				a.insert({d[i.to], i.to});
			}
		}
	}
	cout << d[n - 1] << " " << d[n - 1] << endl;
}
