#include <iostream>
#include <set>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <cassert>
#include <climits>
#include <functional>
#include <vector>
#include <algorithm>

using namespace std;

typedef unsigned int index;

struct Edge/*{{{*/
{
	index to;
	int w;
	bool can;
	index num;
	Edge(index new_to, int new_w, index new_num): to(new_to), w(new_w), num(new_num){}
};/*}}}*/

struct Dop/*{{{*/
{
	int ps;
	vector<pair<long long, int>> oc;
	Dop(): ps(0), oc(){}
	void push(long long a)
	{
		oc.push_back({a, -ps});
	}
	long long maxs()
	{
		long long ans = -1;
		for (auto &i: oc)
		{
			ans = max(ans, i.first + (long long)(i.second + ps) * (i.second + ps));
		}
		return ans;
	}
};/*}}}*/

void dfs(const vector<vector<Edge *>> &g, index v, vector<int> &out_t, int &ct)
{
	for (auto i: g[v])
		if (i->can)
			dfs(g, i->to, out_t, ct);
	out_t[v] = ct;
	ct++;
}

int main()
{
#ifdef ONPC
	assert(freopen("a.in", "r", stdin));
	assert(freopen("a.out", "w", stdout));
#else
	assert(freopen("trains.in", "r", stdin));
	assert(freopen("trains.out", "w", stdout));
#endif
	ios::sync_with_stdio(false);
	size_t n, m;
	cin >> n >> m;
	vector<vector<Edge*>> g(n);
	vector<vector<Dop*>> t(n);
	for (index i = 0; i < m; i++)
	{
		size_t s;
		index cur;
		cin >> s >> cur;
		cur--;
		t[cur].push_back(NULL);
		for (index j = 0; j < s; j++)
		{
			index to;
			int w;
			cin >> w >> to;
			to--;
			g[cur].push_back(new Edge(to, w, (index)t[to].size()));
			cur = to;
			t[cur].push_back(NULL);
		}
		g[cur].push_back(new Edge(cur, 1, 0));
	}
	set<pair<int, index>> a;/*{{{*/
	vector<int> d(n, INT_MAX / 2);
	d[0] = 0;
	a = {{0, 0}};
	while (!a.empty())
	{
		index nw = a.begin()->second;
		int cw = a.begin()->first;
		a.erase(a.begin());
		if (cw > d[nw])
			continue;
		for (auto i: g[nw])
		{
			if (d[i->to] > d[nw] + i->w)
			{
				d[i->to] = d[nw] + i->w;
				a.insert({d[i->to], i->to});
			}
		}
	}/*}}}*/
	for (index i = 0; i < n; i++)
	{
		for (auto j: g[i])
		{
			if (d[i] + j->w == d[j->to])
				j->can = true;
			else
				j->can = false;
		}
	}
	vector<int> out_t(n, -1);
	int ct = 0;
	for (index i = 0; i < n; i++)
	{
		if (out_t[i] == -1)
		{
			dfs(g, i, out_t, ct);
		}
	}
	vector<pair<int, index>> sr(n);
	for (index i = 0; i < n; i++)
	{
		sr[i] = {-out_t[i], i};
	}
	sort(sr.begin(), sr.end());
	vector<long long> dn(n, LLONG_MIN / 2);
	dn[0] = 0;
	if (n <= 10)
	{
		for (index io = 0; io < n; io++)
		{
			index i = sr[io].second;
				for (index j = 0; j < t[i].size(); j++)
				{
					if (t[i][j] == NULL)
					{
						t[i][j] = new Dop();
					}
					t[i][j]->push(dn[i]);
				}
			for (index j = 0; j < g[i].size(); j++)
			{
				if (g[i][j]->can)
				{
					t[i][j]->ps += g[i][j]->w;
					dn[g[i][j]->to] = max(dn[g[i][j]->to], t[i][j]->maxs());
					t[g[i][j]->to][g[i][j]->num] = t[i][j];
				}
			}
		}
	}
	cout << d[n - 1] << " " << dn[n - 1] << endl;
}
