#include <iostream>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <climits>
#include <functional>

using namespace std;
typedef unsigned int index;

struct LongNum
{
	bool sign;
	vector<int> numbers;
	LongNum()
	{
		sign = false;
		numbers = {};
	}
};

istream &operator >>(istream &in, LongNum &a)
{
	string s;
	cin >> s;
	if (s[0] == '-')
	{
		a.sign = true;
	}
	for (index i = (index)s.size() - 1; i != (a.sign ? 0 : (index)-1); i--)
	{
		a.numbers.push_back((int)(s[i] - '0'));
	}
	return in;
}

ostream &operator <<(ostream &out, LongNum a)
{
	if (a.sign)
		cout << '-';
	for (index i = (index)a.numbers.size() - 1; i != (index)-1; i--)
		cout << a.numbers[i];
	return out;
}

bool clear_less(const LongNum &a, const LongNum &b)
{
	if (a.numbers.size() != b.numbers.size())
		return a.numbers.size() < b.numbers.size();
	for (index i = (index)a.numbers.size() - 1; i != (index)-1; i--)
	{
		if (a.numbers[i] != b.numbers[i])
			return a.numbers[i] < b.numbers[i];
	}
	return false;
}

bool operator <(const LongNum &a, const LongNum &b)
{
	if (a.sign != b.sign)
	{
		return a.sign;
	}
	else if (a.sign == false)
		return clear_less(a, b);
	else
		return clear_less(b, a);
}

LongNum clear_plus(LongNum a, LongNum b)
{
	assert(a.numbers.size() >= b.numbers.size());
	int plus = 0;
	for (index i = 0; i < a.numbers.size(); i++)
	{
		if (i < b.numbers.size())
			plus += b.numbers[i];
		a.numbers[i] += plus;
		plus = a.numbers[i] / 10;
		a.numbers[i] = a.numbers[i] % 10;
	}
	if (plus > 0)
		a.numbers.push_back(plus);
	return a;
}

LongNum clear_minus(LongNum a, LongNum b)
{
	assert(clear_less(b, a));
	LongNum ans;
	int plus = 0;
	for (index i = 0; i < a.numbers.size(); i++)
	{
		if (i < b.numbers.size())
			plus -= b.numbers[i];
		a.numbers[i] += plus;
		if (a.numbers[i] < 0)
			plus = -1;
		else
			plus = 0;
		a.numbers[i] = (a.numbers[i] + 20) % 10;
	}
	assert(plus == 0);
	while (a.numbers.back() == 0)
		a.numbers.pop_back();
	return a;
}


LongNum operator +(const LongNum &a, const LongNum &b)
{
	if (!a.sign and !b.sign)
		return clear_plus(a, b);
	else if (!a.sign and b.sign)
	{
		if (clear_less(b, a))
			return clear_minus(a, b);
		else
		{
			LongNum sv = clear_minus(b, a);
			sv.sign = true;
			return sv;
		}
	}
	else if (a.sign and !b.sign)
	{
		if (clear_less(a, b))
			return clear_minus(b, a);
		else
		{
			LongNum sv = clear_minus(a, b);
			sv.sign = true;
			return sv;
		}
	}
	else
	{
		LongNum sv = clear_plus(a, b);
		sv.sign = true;
		return sv;
	}
}


int main()
{
#ifdef ONPC
	assert(freopen("a.in", "r", stdin));
	assert(freopen("a.out", "w", stdout));
#else
	assert(freopen("sum.in", "r", stdin));
	assert(freopen("sum.out", "w", stdout));
#endif
	LongNum a, b;
	cin >> a >> b;
	cout << a + b << endl;
}
