#include <queue>
#include <random>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cstdio>
#include <string>

#pragma comment(linker, "/STACK:512000000")

using namespace std;
#define coord int64_t
#define pint pair<int64_t, int64_t>
#define int int64_t

int rard() {
	return rand() * RAND_MAX + rand();
}

int32_t main() {
	ios::sync_with_stdio(false);
	srand(128313);
#ifdef _DEBUG
	ifstream cin("input.in");
	ofstream cout("output.out");
#endif

	int n, m;
	cin >> n >> m;
	vector<vector<int>> e_to(n);
	vector<vector<int>> e_l(n);
	for (int i = 0; i < m; i++) {
		int s;
		cin >> s;
		vector<int> vs(s + 1), ts(s);
		cin >> vs[0]; vs[0]--;
		for (int j = 0; j < s; j++) {
			cin >> ts[j] >> vs[j + 1];
			--vs[j + 1];
		}

		for (int i = 0; i < s; i++) {
			int t = ts[i];
			for (int j = i + 1; j < s + 1; j++) {
				e_to[vs[i]].push_back(vs[j]);
				e_l[vs[i]].push_back(t);

				if (j >= s) break;
				t += ts[j];
			}
		}
	}
	

	vector<pint> dist(n, { (int)1e16, 0 });
	vector<bool> was(n, false);
	dist[0] = { 0, 0 };
	priority_queue<pair<pint, int>> q;
	q.push({ dist[0], 0 });
	while (!q.empty()) {
		auto qf = q.top();
		q.pop();
		pint d = qf.first;
		int v = qf.second;
		if (was[v])
			continue;

		
		for (int i = 0; i < e_to[v].size(); i++) {
			pint dto;
			int vto = e_to[v][i];
			dto.first = d.first + e_l[v][i];
			dto.second = d.second - e_l[v][i] * e_l[v][i];
			if (dto < dist[vto]) {
				dist[vto] = dto;
				q.push({ dist[vto], vto });
			}
		}
	}

	cout << dist[n - 1].first << ' ' << -dist[n - 1].second;

	return 0;
}