#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cassert>
#include <cstring>

using namespace std;

typedef long long ll;
typedef long double ld;

int solve();

int main() {
#ifdef PoDuReM
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	return solve();
}

const int dd = (int)1e6 + 7;

char s[dd], t[dd];
vector<pair<char, int> > S;
int p[dd], r[dd];
char ty[dd];

int get_p(int a) { return p[a] = (a == p[a] ? a : get_p(p[a])); }
void merge(int a, int b, char c) {
	a = get_p(a), b = get_p(b);
	if (a == b) return;
	if (r[a] < r[b]) swap(a, b);
	p[a] = b;
	r[b] += r[a];
	t[b] = c;
}

int used[dd];

int solve() {
	int q;
	scanf("%d\n", &q);
	while (q--) {
		S = vector<pair<char, int> >(0);
		scanf("%s %s\n", s, t);
		int n = strlen(s);
		memset(used, 0, sizeof(int) * n);
		int ok = 1;
		for (int i = 0; i < n; ++i)
			p[i] = i, r[i] = 1, ty[i] = s[i];
		for (int i = 0; i < n - 1; ++i)
			if (s[i] == s[i - 1] && t[i] != t[i - 1]) {
				ok = 0;
				break;
			}
		if (!ok) {
			puts("No");
			continue;
		}
		vector<pair<int, int> > K;
		int cnt = 1;
		for (int i = 1; i < n; ++i) {
			if (s[i] == s[i - 1]) {
				++cnt;
				merge(i, i - 1, s[i]);
			} else {
				S.push_back({ s[i - 1], cnt });
				if (s[i - 1] != t[i - 1])
					K.push_back({ i - cnt, i - 1 });
				cnt = 1;
			}
		}
		S.push_back({ s[n - 1], cnt });
		if (s[n - 1] != t[n - 1])
			K.push_back({ n - cnt, n - 1 });

		int obr = 0;
		ok = 1;
		while (obr != (int)K.size()) {
			int cur = 0;
			for (int i = 0; i < (int)K.size(); ++i) if (!used[i]) {
				int o = get_p(K[i].first);
				int L = (K[i].first == 0 ? -1 : get_p(K[i].first - 1));
				int R = (K[i].second == n - 1 ? -1 : get_p(K[i].second + 1));
				int szL = (L == -1 ? 0 : r[L]);
				int szR = (R == -1 ? 0 : r[R]);
				if (r[o] < szL || r[o] < szR) {
					if (L != -1) merge(o, L, ty[L]);
					if (R != -1) merge(L, R, ty[L]);
					used[i] = 1;
					obr++;
					cur = 1;
				}
			}
			for (int i = (int)K.size() - 1; i >= 0; --i) if (!used[i]) {
				int o = get_p(K[i].first);
				int L = (K[i].first == 0 ? -1 : get_p(K[i].first - 1));
				int R = (K[i].second == n - 1 ? -1 : get_p(K[i].second + 1));
				int szL = (L == -1 ? 0 : r[L]);
				int szR = (R == -1 ? 0 : r[R]);
				if (r[o] < szL || r[o] < szR) {
					if (L != -1) merge(o, L, ty[L]);
					if (R != -1) merge(L, R, ty[L]);
					used[i] = 1;
					obr++;
					cur = 1;
				}
			}
			if (!cur) {
				ok = 0;
				break;
			}
		}
		puts(ok ? "Yes" : "No");
	}
	return 0;
}