#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

struct Point {
    int x, y;
    Point(int x, int y) : x(x), y(y) {}
};

double pif(Point a, Point b) {
    return sqrt((a.x - b.x)*(a.x - b.x) + (a.y - b.y)*(a.y - b.y));
}

double sqr(Point a, Point b, Point c) {
    double lA = pif(a, b),
           lB = pif(b, c),
           lC = pif(c, a),
            pol = (lA + lB + lC) / 2;
    return sqrt((pol*(pol - lA) * (pol - lB) * (pol - lC)));
}
struct Triangle {
    Triangle(Point a, Point b, Point c) :
        a(a), b(b), c(c) {
    }
    bool coll(Point x) {
        if(abs(sqr(a, b, c) - sqr(x, b, c) - sqr(a, x, c) - sqr(a, b, x)) < 1e-6) {
            return true;
        }
        return false;
    }
    Point a, b, c;
};

bool valid(int f, int s, int t, vector<Point>& points) {
    Triangle tr(points[f], points[s], points[t]);
    for(uint32_t c = 0; c < points.size(); c++) {
        if(c != f && c != s && c != t && tr.coll(points[c])) {
            return false;
        }
    }
    return true;
}
int main() {
    int n;
    cin >> n;
    vector<Point> points;
    for(uint32_t c = 0; c < n; c++) {
        int x, y;
        cin >> x >> y;
        points.push_back({x, y});
    }
    int q;
    cin >> q;
    uint32_t counter = 0;
    for(uint32_t c = 0; c < q; c++) {
        bool flag = false;
        for(uint32_t f = 0; f < points.size() - 2; f++) {
            if(flag) break;
            for(uint32_t s = f + 1; s < points.size() - 1; s++) {
                if(flag) break;
                for(uint32_t t = s + 1; t < points.size(); t++) {
                    if(valid(f, s, t, points)) {
                        counter++;
                        if(counter > 4000) while(true) {}
                        string answer;
                        cout << "? " << 3 << " " << f + 1 << " " << s + 1 << " " << t + 1 << endl;
                        cin >> answer;
                        if(answer == "Yes") {
                            cout << "! " << 3 << " " << f + 1 << " " << s + 1 << " " << t + 1 << endl;
                            flag = true;
                            break;
                        }
                    }
                }
            }
        }
    }
    return 0;
}
