#include <iostream>
#include <vector>
#include <string>
#include <fstream>

using namespace std;

typedef long long ll;

struct triangle
{
	int a, b, c;
};

const int N = 5001;
int a[N][N];
ll x[N], y[N];
vector<triangle> b;
vector<pair<int, int>> edges;

ll area(int a, int b, int c)
{
	return abs((x[a] - x[b]) * (y[b] - y[a]) + (x[b] - x[c]) * (y[c] - y[b]) + (x[c] - x[a]) * (y[a] - y[c]));
}

bool intersect(int a1, int a2, int b1, int b2)
{
	if (a1 == b1 || a1 == b2 || a2 == b1 || a2 == b2)
		return false;
	ll e1 = y[a2] - y[a1];
	ll f1 = x[a1] - x[a2];
	ll g1 = -e1 * x[a1] - f1 * y[a1];
	ll e2 = y[b2] - y[b1];
	ll f2 = x[b1] - x[b2];
	ll g2 = -e2 * x[b1] - f2 * y[b1];
	ll d = f2 * e1 - e2 * f1;
	ll dx = g2 * f1 - f2 * g1;
	ll dy = e2 * g1 - g2 * e1;
	if (d == 0)
		return false;
	else
	{
		double xp = double(dx) / d;
		double yp = double(dy) / d;
		double xl1, xr1, yl1, yr1, xl2, xr2, yl2, yr2;
		xl1 = x[a1];
		xr1 = x[a2];
		yl1 = y[a1];
		yr1 = y[a2];
		xl2 = x[b1];
		xr2 = x[b2];
		yl2 = y[b1];
		yr2 = y[b2];
		if (xl1 > xr1)
			swap(xl1, xr1);
		if (yl1 > yr1)
			swap(yl1, yr1);
		if (xl2 > xr2)
			swap(xl2, xr2);
		if (yl2 > yr2)
			swap(yl2, yr2);
		if (xp >= xl1 && xp <= xr1 && yp >= yl1 && yp <= yr1 && xp >= xl2 && xp <= xr2 && yp >= yl2 && yp <= yr2)
			return true;
		else
			return false;
	}
}

int main()
{
	int n, q;
	cin >> n;
	for (int i = 0; i < n; i++)
		cin >> x[i] >> y[i];
	cin >> q;
	for (int i = 0; i < n - 1; i++)
		for (int j = i + 1; j < n; j++)
		{
			bool f = true;
			for (int k = 0; k < edges.size(); k++)
				if (intersect(i, j, edges[k].first, edges[k].second))
				{
					f = false;
					break;
				}
			if (f)
			{
				edges.push_back(make_pair(i, j));
				a[i][j] = 1;
				a[j][i] = 1;
			}
		}
	for (int i = 0; i < n - 2; i++)
		for (int j = i + 1; j < n - 1; j++)
			for (int k = j + 1; k < n; k++)
				if (a[i][j] + a[j][k] + a[i][k] == 3)
				{
					triangle t;
					t.a = i;
					t.b = j;
					t.c = k;
					b.push_back(t);
				}
	int i = 0;
	while (i < b.size())
	{
		bool f = true;
		for (int j = 0; j < n; j++)
		{
			if (j == b[i].a || j == b[i].b || j == b[i].c)
				continue;
			ll areaf = area(b[i].a, b[i].b, b[i].c), area1, area2, area3;
			area1 = area(b[i].a, b[i].b, j);
			area2 = area(b[i].a, b[i].c, j);
			area3 = area(b[i].c, b[i].b, j);
			if (area1 + area2 + area3 == areaf)
			{
				f = false;
				break;
			}
		}
		if (f)
			i++;
		else
			b.erase(b.begin() + i);
	}
	while (q--)
	{
		for (int i = 0; i < b.size(); i++)
		{
			cout << "? 3 " << b[i].a + 1 << ' ' << b[i].b + 1 << ' ' << b[i].c + 1 << endl;
			string m;
			cin >> m;
			if (m == "Yes")
			{
				cout << "! 3 " << b[i].a + 1 << ' ' << b[i].b + 1 << ' ' << b[i].c + 1 << endl;
				break;
			}
		}
	}
	return 0;
}