#include <bits/stdc++.h>

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define size(a) (int(a.size()))

using namespace std;

typedef long long llong;
const llong inf = (llong) 1e9 + 7ll;
const llong linf = (llong) 1e18 + 7ll;

static char buff[(int) 1e6 + 17];
const int maxn = (int) 1e6 + 17;

struct node
{
    int l, r, bit;
    set<int> ls, rs;
    node() { l = r = -1; }
    node(int b) : bit(b) { l = r = -1; }
};

mt19937 rnd(time(nullptr));
const int MAXBIT = 30;
int n, k, q;
int a[maxn], cnt0[MAXBIT], cnt1[MAXBIT];
vector<node> T;

bool read()
{
    if (scanf("%d", &n) != 1)
        return false;

    forn (i, n)
        scanf("%d", a + i);

    return true;
}

void add(int x, int i, int v, int bit)
{
    if (bit != 0)
    {
        if ((x >> bit) & 1)
        {
            if (T[v].r == -1)
            {
                T[v].r = size(T);
                T.push_back(node(bit - 1));
            }

            add(x, i, T[v].r, bit - 1);
            T[v].rs.insert(i);
        }
        else
        {
            if (T[v].l == -1)
            {
                T[v].l = size(T);
                T.push_back(node(bit - 1));
            }

            add(x, i, T[v].l, bit - 1);
            T[v].ls.insert(i);
        }
    }
}

void ers(int x, int i, int v, int bit)
{
    if (bit != 0)
    {
        if ((x >> bit) & 1)
        {
            ers(x, i, T[v].r, bit - 1);
            T[v].rs.erase(i);
        }
        else
        {
            ers(x, i, T[v].l, bit - 1);
            T[v].ls.erase(i);
        }
    }
}

void dfs(int v)
{
    if (T[v].bit != 0)
    {
        if (!T[v].ls.empty() && !T[v].rs.empty())
        {
            if (*T[v].ls.rbegin() < *T[v].rs.begin())
                ++cnt0[T[v].bit];
            else
            {
                if (*T[v].rs.rbegin() < *T[v].ls.begin())
                    ++cnt1[T[v].bit];
                else
                    ++cnt0[T[v].bit], ++cnt1[T[v].bit];
            }
        }

        if (T[v].l != -1) dfs(T[v].l);
        if (T[v].r != -1) dfs(T[v].r);
    }
}

int getk()
{
    int k = 0;

    for (int i = 0; i < MAXBIT; ++i)
        if (cnt0[i] && cnt1[i])
            return -1;
        else
        {
            if (cnt1[i])
                k += (1 << i);
        }

    return k;
}

void solve()
{
    T.push_back(node(MAXBIT));

    for (int i = 0; i < n; ++i)
        add(a[i], i, 0, MAXBIT);

    memset(cnt0, 0, sizeof(cnt0));
    memset(cnt1, 0, sizeof(cnt1));
    dfs(0);
    printf("%d\n", getk());
    scanf("%d", &q);

    for (int j = 0; j < q; ++j)
    {
        int p, x;
        scanf("%d %d", &p, &x);
        --p;
        ers(a[p], p, 0, MAXBIT);
        add(x, p, 0, MAXBIT);
        a[p] = x;
        memset(cnt0, 0, sizeof(cnt0));
        memset(cnt1, 0, sizeof(cnt1));
        dfs(0);
        printf("%d\n", getk());
    }
}

void check()
{
    for (int b = 0; b < 100; ++b)
    {
        bool good = true;

        for (int i = 1; i < n; ++i)
            if ((a[i - 1] ^ b) > (a[i] ^ b))
                good = false;

        if (good)
        {
            for (int i = 0; i < n; ++i)
                cout << a[i] << ' ';

            cout << endl << b << endl;
            exit(0);
        }
    }
}

void gen()
{
    n = 1 + rnd() % 6;

    for (int i = 0; i < n; ++i)
        a[i] = rnd() % 16;
}

int main()
{
#ifdef SEREZHKA
    freopen("file.in", "r", stdin);
#endif // SEREZHKA

    while (read())
        solve();

    /*for (; ;)
    {
        gen();
        check();
    }*/

    return 0;
}
