#include <bits/stdc++.h>

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define size(x) (int(x.size()))
typedef long long llong;

using namespace std;

const llong inf = (llong) 1e9 + 7ll;
const llong linf = (llong) 1e18 + 17ll;

const int maxn = (int) 2e5 + 17;
static char buff[(int) 1e6 + 17];

struct bigint
{
    int sz, sign;
    vector<int> c;
    bigint() { }

    void read()
    {
        scanf("%s", buff);
        string s = buff;

        if (s[0] == '-')
        {
            sign = -1;
            s.erase(0, 1);
        }
        else
            sign = 1;

        c.resize(size(s));
        sz = size(c);

        for (int i = 0; i < size(s); ++i)
            c[sz - 1 - i] = int(s[i] - '0');
    }

    void print()
    {
        if (sign == -1)
            printf("-");

        for (int i = size(c) - 1; i >= 0; --i)
            printf("%d", c[i]);
    }

    bool operator <(bigint r)
    {
        if (size(c) < size(r.c))
            return true;

        if (size(c) > size(r.c))
            return false;

        for (int i = size(r.c) - 1; i >= 0; --i)
            if (c[i] != r.c[i])
                return c[i] < r.c[i];

        return false;
    }
};

bigint operator +(bigint a, bigint b)
{
    int sz = max(a.sz, b.sz) + 1;
    bigint k;
    k.sz = sz;
    k.c.resize(sz);

    for (; size(a.c) < sz; a.c.push_back(0));
    for (; size(b.c) < sz; b.c.push_back(0));

    for (int i = 0; i < sz - 1; ++i)
    {
        k.c[i] += a.c[i] + b.c[i];
        k.c[i + 1] += k.c[i] / 10;
        k.c[i] %= 10;
    }

    for (; size(k.c) > 1 && k.c.back() == 0; k.c.pop_back());
    k.sz = size(k.c);
    k.sign = 1;
    return k;
}

bigint operator -(bigint a, bigint b)
{
    bigint k;

    if (a.c == b.c)
    {
        k.sz = k.sign = 1;
        k.c.push_back(0);
        return k;
    }

    if (a < b)
        swap(a, b), k.sign = -1;

    int sz = max(a.sz, b.sz) + 1;
    k.sz = sz;
    k.c.resize(sz);

    for (; size(a.c) < sz; a.c.push_back(0));
    for (; size(b.c) < sz; b.c.push_back(0));

    for (int i = 0; i < sz - 1; ++i)
    {
        if (a.c[i] - b.c[i] < 0)
            for (int j = i + 1; j < sz; ++j)
            {
                if (a.c[j] > 0)
                {
                    --a.c[j];
                    a.c[i] += 10;
                    break;
                }
                else
                    a.c[j] = 9;
            }

        k.c[i] = a.c[i] - b.c[i];
    }

    for (; size(k.c) > 1 && k.c.back() == 0; k.c.pop_back());
    k.sz = size(k.c);
    return k;
}

llong n;

bool read()
{
    if (scanf("%lld", &n) != 1)
        return false;

    return true;
}

void solve()
{
    bigint a, b;
    a.read();
    b.read();

    if (a.sign == -1 && b.sign == -1)
    {
        a.sign = b.sign = 1;
        bigint k = a + b;
        k.sign = -1;
        k.print();
        return ;
    }

    if (a.sign == 1 && b.sign == 1)
    {
        bigint k = a + b;
        k.print();
        return ;
    }

    if (a.sign == -1)
        swap(a, b);

    b.sign = 1;
    bigint k = a - b;
    k.print();
}

int main()
{
#ifdef SEREZHKA
    freopen("file.in", "r", stdin);
#else
    freopen("sum.in", "r", stdin);
    freopen("sum.out", "w", stdout);
#endif // SEREZHKA

    //while (read())
        solve();

    return 0;
}
