#include <bits/stdc++.h>
using namespace std;
typedef long long int ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int maxn = (const int) (1e6 + 5);

struct edge {
    int from;
    int path_num;
    ll timer;
};

int n, m;
vector<edge> vec[maxn];
set<pll> st;
ll found[maxn];
ll secs[maxn];
ll path_sums[maxn];
ll path_nums[maxn];

void recalc(int v, ll sum) {
    for (auto e : vec[v]) {
        int from = e.from;
        int path_num = e.path_num;
        ll timer = e.timer;

        ll maybe_timer = sum + timer;
        ll maybe_secs = 0;
        if (path_nums[v] == path_num) {
            maybe_secs = secs[v] - path_sums[v] * path_sums[v] + (path_sums[v] + timer) * (path_sums[v] + timer);
        } else {
            maybe_secs = secs[v] + timer * timer;
        }

        if (maybe_timer < found[from] || (maybe_timer == found[from] && maybe_secs < secs[from])) {
            found[from] = maybe_timer;
            secs[from] = maybe_secs;
            path_nums[from] = path_num;
            if (path_nums[v] == path_num)
                path_sums[from] = path_sums[v] + timer;
            else
                path_sums[from] = timer;
        }
    }
}

int main() {
    scanf("%d%d", &n, &m);
    for (int i = 0; i < m; i++) {
        int s;
        scanf("%d", &s);
        vector<int> tmp(2 * s + 1);
        for (int z = 0; z < 2 * s + 1; z++)
            scanf("%d", &tmp[z]);
        for (int z = 1; z + 1 < 2 * s + 1; z += 2) {
            int from = tmp[z - 1] - 1;
            int timer = tmp[z];
            int to = tmp[z + 1] - 1;

            edge e;
            e.from = from;
            e.path_num = i;
            e.timer = timer;

            vec[to].push_back(e);
        }
    }

    fill(found, found + n, LLONG_MAX);
    fill(secs, secs + n, LLONG_MAX);
    fill(path_sums, path_sums + n, 0);
    found[n - 1] = 0;
    secs[n - 1] = 0;
    path_nums[n - 1] = -1;

    /*
    for (int i = 0; i < n; i++)
        st.insert({found[i], i});

    for (int i = 0; i < n; i++) {
        pll cur = *st.begin();
        st.erase(st.begin());
        recalc(cur.second, cur.first);
    }
     */

    vector<bool> used(n);
    for (int i = 0; i < n; i++) {
        int ind;
        ll val = LLONG_MAX, val2 = LLONG_MAX;
        for (int z = 0; z < n; z++) {
            if (used[z])
                continue;
            if (val > found[z] || (val == found[z] && val2 > secs[z])) {
                val = found[z];
                val2 = secs[z];
                ind = z;
            }
        }
        used[ind] = true;
        recalc(ind, found[ind]);
    }

    cout << found[0] << " " << secs[0] << endl;
}

/*
5 2
4 1 3 2 3 3 5 5 10 4
3 4 2 2 1 3 4 1

 2 1
1 1 3 2

 5 2
3 1 1 2 2 3 3 4
3 2 2 3 3 4 4 5
 */