#include <bits/stdc++.h>
using namespace std;
typedef long long int ll;
typedef pair<int, int> pii;

int n;

int g_left(string & s, int v, char diff) {
    int cnt = 0;
    for (int i = v - 1; i >= 0; i--) {
        if (s[i] != diff) {
            cnt++;
        } else {
            break;
        }
    }
    return cnt;
}

int g_right(string & s, int v, char diff) {
    int cnt = 0;
    for (int i = v + 1; i < s.size(); i++) {
        if (s[i] != diff) {
            cnt++;
        } else {
            break;
        }
    }
    return cnt;
}

void color(string & s, int a, int b) {
    for (int i = a; i <= b; i++) {
        if (s[i] == '-')
            s[i] = '+';
        else
            s[i] = '-';
    }
}

bool inter(pii a, pii b) {
    if (a.first == b.first && a.second == b.second)
        return false;
    if (a.first < b.first && a.second >= b.second)
        return true;
    if (a.first <= b.first && a.second > b.second)
        return true;
    if (a.first > b.first && a.second > b.second)
        return true;
    if (a.first < b.first && a.second > b.first)
        return true;
    return false;
}

bool can_simple(string a, string b) {
    int len = (int)a.size();
    vector<pii> vec;
    int cur = INT_MAX;
    for (int z = 0; z < len; z++) {
        if (a[z] == b[z]) {
            if (cur <= z - 1)
                vec.push_back({cur, z - 1});
            cur = INT_MAX;
        } else {
            cur = min(cur, z);
        }
    }
    if (cur <= len - 1)
        vec.push_back({cur, len - 1});

    while (vec.size() > 0) {
        bool can = false;
        int cnt = -1;
        for (auto it : vec) {
            cnt++;
            int maximal = max(g_left(a, it.first, a[it.first]),
                              g_right(a, it.second, a[it.second]));
            if (maximal > it.second - it.first + 1) {
                color(a, it.first, it.second);
                can = true;
                break;
            }
        }
        if (!can)
            break;
        vec.erase(vec.begin() + cnt);
    }

    return vec.size() == 0;
}

bool is_correct(string & a, string & b) {
    int len = (int) a.size();

    vector<pii> res_b;
    char ch = b[0];
    int cur = 0;
    for (int i = 0; i < len; i++) {
        if (b[i] != ch) {
            res_b.push_back({cur, i - 1});
            cur = i;
            ch = b[i];
        }
    }
    res_b.push_back({cur, len - 1});

    vector<pii> res_a;
    ch = a[0];
    cur = 0;
    for (int i = 0; i < len; i++) {
        if (a[i] != ch) {
            res_a.push_back({cur, i - 1});
            cur = i;
            ch = a[i];
        }
    }
    res_a.push_back({cur, len - 1});


    vector<string> vec_str_a;
    vector<string> vec_str_b;
    int ptr = 0;
    for (int i = 0; i < res_b.size(); i++) {
        pii pb = res_b[i];
        vector<pii> as;
        while (ptr < res_a.size()) {
            pii p = res_a[ptr];
            if (p.first <= pb.second && p.second > pb.second)
                return false;
            if (p.first > pb.second)
                break;
            ptr++;
            as.push_back(p);
        }

        string tmp_a, tmp_b;
        for (int z = pb.first; z <= pb.second; z++)
            tmp_a += a[z];
        for (int z = pb.first; z <= pb.second; z++)
            tmp_b += b[z];

        if (!can_simple(tmp_a, tmp_b))
            return false;

        vec_str_a.push_back(tmp_a);
        vec_str_b.push_back(tmp_b);
    }

    for (int i = 1; i < vec_str_a.size(); i++) {
        char res = vec_str_b[i][0];
        char diff = (res == '-' ? '+' : '-');
        if (vec_str_a[i][0] == diff && vec_str_a[i - 1][vec_str_a[i - 1].size() - 1] == res)
            return false;
    }

    return true;
}

int main() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        string a, b;
        cin >> a >> b;

        if (is_correct(a, b))
            cout << "Yes" << endl;
        else
            cout << "No" << endl;
    }
}

/*
 1
 ----+++++
 ++++-----

 1
 ++-+--+-+-++
 ++++----++++

 3
 ++- +++
 ++-- ++++
 ++-+--+- ++++++++

 1
 ++-+--+- ++++++++

 3
 ++-+-- ++----
 ++-+-- +++---
 -++- -++-
 */