#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <stack>
#include <map>

using namespace std;

const int MX = 2e5 + 11;
const int UP = 1 << 19 + 5;
const int more = 1000 * 1000 * 1000;
const long long INF = 1e18;
long long t[UP], p[UP];

inline void push(int v) {
	if (p[v]) {
		t[v << 1] += p[v];
		t[(v << 1) | 1] += p[v];
		p[v << 1] += p[v];
		p[(v << 1) | 1] += p[v];
		p[v] = 0;
	}
	return;
}

inline void up(int r) {
	int v = 1, tl = 0, tr = MX - 1;
	while (tl != tr) {
		int tm = (tl + tr) >> 1;
		v <<= 1;
		if (r > tm) {
			t[v] += more;
			p[v] += more;
			v |= 1;
			tl = tm + 1;
		}
		else {
			tr = tm;
		}
	}
	t[v] += more;
	while (v != 1) {
		v >>= 1;
		t[v] = min(t[v << 1], t[(v << 1) | 1]);
	}
	return;
}

inline void update(int pos, long long val) {
	int v = 1, tl = 0, tr = MX - 1;
	while (tl != tr) {
		int tm = (tl + tr) >> 1;
		v <<= 1;
		if (pos > tm) {
			v |= 1;
			tl = tm + 1;
		}
		else {
			tr = tm;
		}
	}
	t[v] = val;
	while (v != 1) {
		v >>= 1;
		t[v] = min(t[v << 1], t[(v << 1) | 1]);
	}
	return;
}

inline long long get(int v, int tl, int tr, int l, int r) {
	if (l > r)
		return INF;
	if (tl == l && tr == r)
		return t[v];
	push(v);
	int tm = (tl + tr) >> 1;
	return min(get(v << 1, tl, tm, l, min(r, tm)), get((v << 1) | 1, tm + 1, tr, max(l, tm + 1), r));
}

int main() {
	ios_base::sync_with_stdio(false);
	int n, a;
	cin >> n >> a;
	int c[MX], l[MX], r[MX];
	for (int i = 0; i < n; i++)
		cin >> l[i] >> r[i] >> c[i];
	long long ans[MX];
	for (int i = 0; i < UP; i++) {
		t[i] = 0;
		p[i] = 0;
	}
	for (int i = 0; i <= a; i++) {
		for (int j = 0; j < n; j++) {
			if (r[j] <= i)
				ans[i] = max(ans[i], get(1, 0, MX - 1, i - r[j], i - l[j]) - c[j]);
		}
		update(i, ans[i]);
		up(i);
	}
	cout << ans[a];
	return 0;
}