#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#include <queue>
#include <set>
#include <string>
#include <map>
#include <iomanip>
#include <cmath>
#include <ctime>

using namespace std;

const int MX = 18e5;
int t[4 * MX];
int arr[MX];

void build(int v, int tl, int tr) {
	if (tl == tr)
		t[v] = arr[tl];
	else {
		int tm = (tl + tr) >> 1;
		build(v << 1, tl, tm);
		build((v << 1) | 1, tm + 1, tr);
		t[v] = t[2 * v] + t[2 * v + 1];
	}
	return;
}	

int get(int v, int tl, int tr, int l, int r) {
	if (l > r)
		return 0;
	if (tl == l && r == tr)
		return t[v];
	int tm = (tl + tr) >> 1;
	return get(v << 1, tl, tm, l, min(r, tm)) + get((v << 1) | 1, tm + 1, tr, max(l, tm + 1), r);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	freopen("sequence.in", "r", stdin);
	freopen("sequence.out", "w", stdout);
	srand(time(NULL));
	for (int i = 0; i < MX; i++) {
		arr[i] = rand();
	}
	build(1, 0, MX - 1);
	long long a;
	stack<long long> s;
	while (cin >> a)
		s.push(a);
	while (!s.empty()) { cout << s.top() << ' '; s.pop(); };
	for (int q = 0; q < MX; q++) {
		int l = rand() % MX;
		int r = rand() % MX;
		if (l > r)
			swap(l, r);
		int res = get(1, 0, MX - 1, l, r);
	}
	return 0;
}