#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <cassert>
using namespace std;

int solve();

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
	return 0;
}

const int MAXN = 5e5 + 23;

int a[MAXN];
int n;
int need[32], cur[32];
void rose(int x, int y) {
	if (y >= n || x < 0) return;
	if (a[x] > a[y]) {
		for (int c = 30; c >= 0; c--) {
			if ((a[x] & (1 << c)) && !(a[y] & (1 << c))) {
				cur[c]++;
				break;
			}
		}
	}

	if (a[x] <= a[y]) {
		for (int c = 30; c >= 0; c--) {
			if (!(a[x] & (1 << c)) && (a[y] & (1 << c))) {
				need[c]++;
				break;
			}
		}
	}
}

void backrose(int x, int y) {
	if (y >= n || x < 0) return;
	if (a[x] > a[y]) {
		for (int c = 30; c >= 0; c--) {
			if ((a[x] & (1 << c)) && !(a[y] & (1 << c))) {
				cur[c]--;
				break;
			}
		}
	}

	if (a[x] <= a[y]) {
		for (int c = 30; c >= 0; c--) {
			if (!(a[x] & (1 << c)) && (a[y] & (1 << c))) {
				need[c]--;
				break;
			}
		}
	}
}


void printAns(int x, int val) {
	int old = a[x];
	backrose(x - 1, x);
	a[x] = val;
	rose(x - 1, x);
	a[x] = old;
	backrose(x, x + 1);
	a[x] = val;
	rose(x, x + 1);

	int ans = 0;
	for (int c = 30; c >= 0; c--) {
		if (cur[c] > 0) ans |= (1 << c);
		if (need[c] > 0 && cur[c] > 0) {
			cout << "-1\n";
			return;
		}
	}
	cout << ans << '\n';
}
int solve() {
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}

	for (int i = 0; i + 1 < n; i++) {
		rose(i, i + 1);
	}

	bool fl = 0;
	int ans = 0;
	for (int c = 30; c >= 0; c--) {
		if (cur[c] > 0) ans |= (1 << c);
		if (need[c] > 0 && cur[c] > 0) {
			cout << "-1\n";
			fl = 1;
			break;
		}
	}

	if (!fl)
		cout << ans << '\n';

	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		int x, y;
		cin >> x >> y;
		printAns(x - 1, y);
	}
	return 0;
}