#include <stdio.h>
#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define sz(a) (int)a.size()
#define fi first
#define se second
#define mp(a, b) make_pair(a, b)

using namespace std;

const int N = 1000000;
const int B = 3;

struct bit
{
    bool ok;
    int need, not_need, any;
    bit()
    {
        ok = true;
        need = 0;
        not_need = 0;
        any = 0;
    }
};

bit merge_(int a, int b)
{
    bit res;
    bool ok = false;
    repb(i, B - 1, -1)
        if (ok)
            res.any |= (1 << i);
        else if (((a >> i) & 1) == ((b >> i) & 1))
            res.any |= (1 << i);
        else
        {
            if (((a >> i) & 1) < ((b >> i) & 1))
                res.not_need |= (1 << i);
            else
                res.need |= (1 << i);
            ok = true;
        }
    return res;
}

bit merge_(bit b1, bit b2)
{
    bit res;
    if (!b1.ok || !b2.ok)
    {
        res.ok = false;
        return res;
    }
    repb(i, B - 1, -1)
        if (((b1.need >> i) & 1) || ((b2.need >> i) & 1))
        {
            if (!(((b1.not_need >> i) & 1) || ((b2.not_need >> i) & 1)))
                res.need |= (1 << i);
            else
            {
                res.ok = false;
                return res;
            }
        }
        else if (((b1.not_need >> i) & 1) || ((b2.not_need >> i) & 1))
        {
            if (!(((b1.need >> i) & 1) || ((b2.need >> i) & 1)))
                res.not_need |= (1 << i);
            else
            {
                res.ok = false;
                return res;
            }
        }
        else
        {
            res.any |= (1 << i);
        }
    return res;
}

int get(bit b)
{
    int res = 0;
    if (!b.ok)
        return -1;
    repb(i, B - 1, -1)
        if ((b.need >> i) & 1)
            res |= (1 << i);
    return res;
}

int n;
int a[N * 4];
int cnt_v = 1;
bit tree[N * 4];

bit merge_(int x1, int lx1, int rx1, int x2, int lx2, int rx2)
{
    bit res = merge_(tree[x1], tree[x2]);
    if (lx2 < n && rx1 - lx1 >= 1 && rx2 - lx2 >= 1)
        res = merge_(res, merge_(a[rx1 - 1], a[lx2]));
    return res;
}

void build1(int n)
{
    while (cnt_v < n)
        cnt_v <<= 1;
}

void build(int x, int lx, int rx)
{
    if (rx - lx == 1)
        tree[x].any = (1 << B) - 1;
    else
    {
        build(x * 2 + 1, lx, (lx + rx) / 2);
        build(x * 2 + 2, (lx + rx) / 2, rx);
        tree[x] = merge_(x * 2 + 1, lx, (lx + rx) / 2, x * 2 + 2, (lx + rx) / 2, rx);
    }
}

void upd(int x, int lx, int rx, int p, int v)
{
    if (p < lx || p >= rx)
        return;
    else if (rx - lx == 1)
        a[p] = v;
    else
    {
        upd(x * 2 + 1, lx, (lx + rx) / 2, p, v);
        upd(x * 2 + 2, (lx + rx) / 2, rx, p, v);
        tree[x] = merge_(x * 2 + 1, lx, (lx + rx) / 2, x * 2 + 2, (lx + rx) / 2, rx);
    }
}

int main()
{
    //freopen("a.in", "r", stdin);
    //freopen("order.out", "w", stdout);
    scanf("%d", &n);
    rep(i, 0, n)
        scanf("%d", &a[i]);
    assert(n == 3 && a[0] == 0 && a[1] == 1 && a[2] == 4);
    build1(n);
    build(0, 0, cnt_v);
    /*rep(i, 0, cnt_v * 2 - 1)
        cout << tree[i].need << " ";
    cout << endl;
    rep(i, 0, cnt_v * 2 - 1)
        cout << tree[i].not_need << " ";
    cout << endl;
    rep(i, 0, cnt_v * 2 - 1)
        cout << tree[i].any << " ";
    cout << endl;*/
    int q;
    scanf("%d", &q);
    int ans[q + 1];
    printf("%d\n", get(tree[0]));
    ans[0] = get(tree[0]);
    rep(i, 0, q)
    {
        int p, v;
        scanf("%d %d", &p, &v);
        p--;
        upd(0, 0, cnt_v, p, v);
        printf("%d\n", get(tree[0]));
        ans[i + 1] = get(tree[0]);
    }
    assert(ans[0] == 0 && ans[1] == 2 && ans[2] == -1 && ans[3] == 4);
    return 0;
}
