#include <stdio.h>
#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define fi first
#define se second
#define sz(a) (int)a.size()
#define mp(a, b) make_pair(a, b)

using namespace std;

const int N = 500000;
const int inf = (int)1e9;
const ll oo = (ll)1e18 + 1;

int p[N];
int r[N];
ll cost[N];
pair<int, int> t[N];
ll best;
int _l, _r;

void add(int x, ll c)
{
    p[x] = x;
    r[x] = 0;
    cost[x] = c;
    t[x] = mp(x, x);
    if (c > best)
    {
        best = c;
        _l = x;
        _r = x;
    }
}

int get(int x)
{
    if (p[x] != x)
        p[x] = get(p[x]);
    return p[x];
}

bool union_(int x, int y)
{
    x = get(x);
    y = get(y);
    if (x == y)
        return false;
    if (r[x] >= r[y])
    {
        p[y] = x;
        cost[x] += cost[y];
        t[x].fi = min(t[x].fi, t[y].fi);
        t[x].se = max(t[x].se, t[y].se);
        if (cost[x] > best)
        {
            best = cost[x];
            _l = t[x].fi; _r = t[x].se;
        }
    }
    else
    {
        p[x] = y;
        cost[y] += cost[x];
        t[y].fi = min(t[y].fi, t[x].fi);
        t[y].se = max(t[y].se, t[x].se);
        if (cost[y] > best)
        {
            best = cost[y];
            _l = t[y].fi; _r = t[y].se;
        }
    }
    if (r[x] == r[y])
        r[x]++;
    return true;
}

int main()
{
    //freopen("a.in", "r", stdin);
    int n, m;
    scanf("%d %d", &n, &m);
    int a[n], x[n], b[m], y[m];
    rep(i, 0, n)
        scanf("%d", &a[i]);
    rep(i, 0, n)
        scanf("%d", &x[i]);
    rep(i, 0, m)
        scanf("%d", &b[i]);
    rep(i, 0, m)
        scanf("%d", &y[i]);
    int last[n];
    int mapa[n + m + 1];
    fill(mapa, mapa + n + m + 1, -1);
    rep(i, 0, n)
    {
        last[i] = mapa[a[i]];
        mapa[a[i]] = i;
    }
    ll pref[m + 1];
    pref[0] = 0;
    rep(i, 0, m)
        pref[i + 1] = pref[i] + y[i];
    bool used[n + m + 1];
    vector<int> pos[n + m + 1];
    rep(i, 0, m)
        pos[b[i]].push_back(i);
    ll ans = 0;
    int l1 = 0, r1 = 0, l2 = 0, r2 = 0;
    if (pref[m] > ans)
    {
        ans = pref[m];
        l2 = 1; r2 = m;
    }
    rep(i, 0, n)
    {
        best = 0;
        _l = -1; _r = -1;
        fill(used, used + n + m + 1, false);
        rep(j, i, n)
            used[a[j]] = true;
        rep(j, 0, m)
            if (!used[b[j]])
            {
                add(j, pref[j + 1] - pref[j]);
                if (j > 0 && !used[b[j - 1]])
                    union_(j - 1, j);
            }
        ll cost = 0;
        rep(j, i, n)
            cost += x[j];
        repb(j, n - 1, i - 1)
        {
            if (cost + best > ans)
            {
                ans = cost + best;
                l1 = i + 1; r1 = j + 1;
                l2 = _l + 1; r2 = _r + 1;
            }
            cost -= x[j];
            if (last[j] < i)
            {
                used[a[j]] = false;
                for (int x : pos[a[j]])
                {
                    add(x, pref[x + 1] - pref[x]);
                    if (x > 0 && !used[b[x - 1]])
                        union_(x - 1, x);
                    if (x < m - 1 && !used[b[x + 1]])
                        union_(x, x + 1);
                }
            }
            if (cost * 2 < best)
                break;
        }
    }
    printf("%lld\n%d %d\n%d %d\n", ans, l1, r1, l2, r2);
    return 0;
}
