#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
using namespace std;

struct TVector {
	long long x, y;
};

TVector operator - (TVector a, TVector b) {
	return TVector{ a.x - b.x, a.y - b.y };
}

long long operator * (TVector a, TVector b) {
	return a.x * b.y - a.y * b.x;
}

bool is_in(TVector x, TVector a, TVector b, TVector c) {
	TVector v1 = a - b, v2 = c - b, v3 = x - b;
	long long q = v1 * v3, w = v3 * v2;
	if ((q > 0 && w < 0) || (q < 0 && w > 0)) {
		return false;
	}
	v1 = b - a;
	v2 = c - a;
	v3 = x - a;
	q = v1 * v3;
	w = v3 * v2;
	if ((q > 0 && w < 0) || (q < 0 && w > 0)) {
		return false;
	}
	return true;
}

bool check(vector<TVector> po, long long a, long long b, long long c) {
	for (long long i = 0; i < po.size(); i++) {
		if (i == a | i == b || i == c) {
			continue;
		}
		if (is_in(po[i], po[a], po[b], po[c])) {
			return false;
		}
	}
	return true;
}

string query(long long a, long long b, long long c) {
	cout << "? 3 " << a << " " << b << " " << c << endl;
	fflush(stdout);
	string s;
	cin >> s;
	return s;
}

int main() {
	long long n;
	cin >> n;
	vector<TVector> po(n + 1);
	for (long long i = 1; i <= n; i++) {
		cin >> po[i].x >> po[i].y;
	}
	long long m;
	cin >> m;
	string s;
	for (long long e = 0; e < m; e++) {
		bool fl = false;
		for (long long i = 1; i <= n; i++) {
			for (long long j = i + 1; j <= n; j++) {
				for (long long k = j + 1; k <= n; k++) {
					if (!check(po, i, j, k)) {
						continue;
					}
					s = query(i, j, k);
					if (s == "Yes") {
						cout << "! 3 " << i << " " << j << " " << k << endl;
						fflush(stdout);
						fl = true;
						break;
					}
				}
				if (fl) {
					break;
				}
			}
			if (fl) {
				break;
			}
		}
	}
	return 0;
}