#include <iostream>
#include <string>
#include <stack>
#include <deque>
#include <vector>
#include <algorithm> 

using namespace std;

typedef long long ll;
typedef pair<ll, ll> llp;

vector<ll> stor;
vector<llp> win;
vector<llp> forw, rev;

const llp EMPTY = { 1, 0 };
const ll INF = 1000000000000;

int main() {
	ll n;
	cin >> n;

	if (n == 1) { cout << 0; return 0; }
	
	stor.resize(n);
	win.resize(n - 1);
	forw.resize(n);
	rev.resize(n);

	for (ll i = 0; i < n; i++) {
		cin >> stor[i];
	}

	for (ll i = 0; i < n - 1; i++) {
		cin >> win[i].first >> win[i].second;
	}

	forw[n - 2].first = max(win[n - 2].first - stor[n - 2], 0ll);
	forw[n - 2].second = win[n - 2].second;
	if (forw[n - 2].first > forw[n - 2].second) { forw[n - 2] = EMPTY; }

	for (ll i = n - 3; i >= 0; i--) {
		if (forw[i + 1] == EMPTY) { forw[i] = EMPTY; continue; }

		if (forw[i + 1].first >= win[i].first) { forw[i].first = forw[i + 1].first; }
		else {
			forw[i].first = win[i].first - stor[i];
		}

		forw[i].second = min(win[i].second, forw[i + 1].second);

		if (forw[i].first > forw[i].second || forw[i].second < win[i].first) { forw[i] = EMPTY; }
	}

	rev[1].first = max(win[0].first - stor[1], 0ll);
	rev[1].second = win[0].second;
	if (rev[1].first > rev[1].second) { rev[1] = EMPTY; }

	for (ll i = 2; i < n; i++) {
		if (rev[i - 1] == EMPTY) { rev[i] = EMPTY; continue; }

		if (rev[i - 1].first >= win[i - 1].first) { rev[i].first = rev[i - 1].first; }
		else {
			rev[i].first = win[i - 1].first - stor[i];
		}

		rev[i].second = min(win[i - 1].second, rev[i - 1].second);

		if (rev[i].first > rev[i].second || rev[i].second < win[i - 1].first) { rev[i] = EMPTY; }
	}

	if (forw[0] == EMPTY || forw[0].second < win[0].first) {
		cout << "-1\n";
	}
	else {
		cout << forw[0].first << "\n";
	}

	for (ll i = 1; i < n - 1; i++) {
		ll tans = max(forw[i].first, rev[i].first);
		if (forw[i] == EMPTY || rev[i] == EMPTY || forw[i].second < win[i].first || rev[i].second < win[i - 1].first || tans > forw[i].second || tans > rev[i].second) {
			cout << "-1\n";
		}
		else {
			cout << tans << "\n";
		}
	}

	if (rev[n-1] == EMPTY || rev[n - 1].second < win[n - 2].first) {
		cout << "-1\n";
	}
	else {
		cout << rev[n - 1].first << "\n";
	}

	return 0;
}