#include <iostream>
#include <cstdio>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>

using namespace std;
typedef long long ll;
typedef pair <ll, ll> par;
typedef long double ld;

ll const LLINF = 1e18;
int l[50000];
int r[50000];
int c[50000];

struct st {
	int mn, mx;
	st() {}
	st(int mn, int mx) : mn(mn), mx(mx) {}
	bool operator < (st const& o) const {
		if (mn != o.mn) return mn < o.mn;
		return mx < o.mx;
	}
};

bool operator < (pair <int, st> const& a, pair <int, st> const& b) {
	if (a.first != b.first) return a.first < b.first;
	return a.second < b.second;
}

set <pair <int, st>> d;
map <st, int> dist;
map <st, bool> w;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	int n, a;
	cin >> n >> a;
	for (int i = 0; i < n; i++) {
		cin >> l[i] >> r[i] >> c[i];
	}
	w[st(0, 0)] = true;
	d.insert({ 0, st(0, 0) });
	dist[st(0, 0)] = 0;
	ll ans = 0;
	while (!d.empty()) {
		st cur = (*d.begin()).second;
		d.erase(d.begin());
		for (int i = 0; i < n; i++) if (cur.mn + r[i] <= a) {
			st nw = st(cur.mn + l[i], cur.mx + r[i]);
			if (!w[nw] || dist[nw] > dist[cur] + c[i]) {
				w[nw] = true;
				dist[nw] = dist[cur] + c[i];
				d.insert({ dist[nw], nw });
			}
		}
	}
	for (auto k = w.begin(); k != w.end(); k++) {
		ans = max(ans, 1LL * k->first.mn * 1000000000 - dist[k->first]);
	}
	cout << ans;
	return 0;
}