#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>

using namespace std;

struct node
{
    int x, y, cnt, fir, las;
    node *L, *R;
    int bit[30];
    node(int X)
    {
        x = fir = las = X;
        y = rand() * rand();
        cnt = 1;
        L = R = nullptr;
        for (int i = 0; i < 30; i++)
            bit[i] = -1;
    }
};

inline int cnt(node *T)
{
    if (T) return T->cnt;
    return 0;
}

inline void update(node *T)
{
    if (T)
    {
        int x = T->x;
        for (int i = 0; i < 30; i++)
            T->bit[i] = -1;
        if (T->L)
        {
            int las = T->L->las;
            bool check = false;
            for (int i = 29; i >= 0; i--)
            {
                if (!check)
                {
                    if (T->L->bit[i] == 2)
                    {
                        T->bit[i] = 2;
                        check = true;
                    }
                    else if (T->L->bit[i] == 0)
                    {
                        if ((x&(1<<i)) > (las&(1<<i)))
                        {
                            T->bit[i] = 0;
                            check = true;
                        }
                        else if ((x&(1<<i)) == (las&(1<<i)))
                            T->bit[i] = 0;
                        else
                        {
                            T->bit[i] = 2;
                            check = true;
                        }
                    }
                    else if (T->L->bit[i] == 1)
                    {
                        if (!(x&(1<<i)) > !(las&(1<<i)))
                        {
                            T->bit[i] = 1;
                            check = true;
                        }
                        else if (!(x&(1<<i)) == !(las&(1<<i)))
                            T->bit[i] = 1;
                        else
                        {
                            T->bit[i] = 2;
                            check = true;
                        }
                    }
                    else
                    {
                        if ((x&(1<<i)) == (las&(1<<i)))
                            T->bit[i] = -1;
                        else
                        {
                            if (las&(1<<i))
                            {
                                T->bit[i] = 1;
                                check = true;
                            }
                            else
                            {
                                T->bit[i] = 0;
                                check = true;
                            }
                        }
                    }
                }
                else
                    T->bit[i] = T->L->bit[i];
            }
            T->fir = T->L->fir;
        }
        else
            T->fir = T->x;
        if (T->R)
        {
            int fir = T->R->fir;
            bool check = false;
            for (int i = 29; i >= 0; i--)
            {
                if (!check)
                {
                    int bitl = T->bit[i], bitr = T->R->bit[i];
                    if (bitl == 2 || bitr == 2)
                    {
                        T->bit[i] = 2;
                        check = true;
                    }
                    else if (bitl == -1)
                    {
                        if (bitr == -1)
                        {
                            if ((fir&(1<<i)) == (x&(1<<i)))
                                T->bit[i] = -1;
                            else
                            {
                                if (x&(1<<i))
                                {
                                    T->bit[i] = 1;
                                    check = true;
                                }
                                else
                                {
                                    T->bit[i] = 0;
                                    check = true;
                                }
                            }
                        }
                        else if (bitr == 0)
                        {
                            if (!(fir&(1<<i)) >= !(x&(1<<i)))
                                T->bit[i] = 0;
                            else
                            {
                                T->bit[i] = 2;
                                check = true;
                            }
                        }
                        else
                        {
                            if ((fir&(1<<i)) >= (x&(1<<i)))
                                T->bit[i] = 0;
                            else
                            {
                                T->bit[i] = 2;
                                check = true;
                            }
                        }
                    }
                    else if (bitl == 0)
                    {
                        if (bitr == 1)
                        {
                            T->bit[i] = 2;
                            check = true;
                        }
                        else
                        {
                            if (!(fir&(1<<i)) >= !(x&(1<<i)))
                                T->bit[i] = 0;
                            else
                            {
                                T->bit[i] = 2;
                                check = true;
                            }
                        }
                    }
                    else
                    {
                        if (bitr == 0)
                        {
                            T->bit[i] = 2;
                            check = true;
                        }
                        else
                        {
                            if ((fir&(1<<i)) >= (x&(1<<i)))
                                T->bit[i] = 1;
                            else
                            {
                                T->bit[i] = 2;
                                check = true;
                            }
                        }
                    }
                }
                else
                    T->bit[i] = T->R->bit[i];
            }
            T->las = T->R->las;
        }
        else
            T->las = T->x;

        T->cnt = cnt(T->L) + 1 + cnt(T->R);
    }
}

inline node* nmerge(node *L, node *R)
{
    if (!L) return R;
    if (!R) return L;
    if (L->y > R->y)
    {
        L->R = nmerge(L->R, R);
        update(L);
        return L;
    }
    else
    {
        R->L = nmerge(L, R->L);
        update(R);
        return R;
    }
}

inline pair <node*, node*> split(node *T, int x, int add = 0)
{
    if (!T) return {nullptr, nullptr};
    int curx = add + cnt(T->L);
    if (x <= curx)
    {
        auto tt = split(T->L, x, add);
        T->L = tt.second;
        update(T);
        return {tt.first, T};
    }
    else
    {
        auto tt = split(T->R, x, curx + 1);
        T->R = tt.first;
        update(T);
        return {T, tt.second};
    }
}

inline int ans(node *T)
{
    int ret = 0;
    if (T)
    {
        for (int i = 0; i < 30; i++)
            if (T->bit[i] == 2)
                return -1;
            else if (T->bit[i] == 1)
                ret += (1<<i);
    }
    return ret;
}

void go(node *T)
{
    if (T)
    {
        go(T->L);
        cout << T->x << ' ';
        go(T->R);
    }
}

int n, q;
node *T = nullptr;

int main()
{
    ios_base::sync_with_stdio(false), cin.tie(nullptr);

    cin >> n;
    for (int i = 0; i < n; i++)
    {
        int a;
        cin >> a;
        T = nmerge(T, new node(a));
    }

    cout << ans(T) << endl;
    cin >> q;
    while (q--)
    {
        int p, v;
        cin >> p >> v;

        auto tt = split(T, p);
        auto tt2 = split(tt.first, p - 1);

        T = nmerge(tt2.first, new node(v));
        T = nmerge(T, tt.second);

        cout << ans(T) << endl;
    }
    return 0;
}

/*
3
0 1 4
3
2 7
3 3
1 4
*/
