#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <deque>
#include <bitset>
#include <utility>
#include <iterator>
#include <sstream>
#include <fstream>

#define X first
#define Y second
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define mp make_pair

#define TASK ""
#define SEED 322

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int INF = 1e9;
const ll LINF = 3e18;
const int MOD = 1e9 + 7;
const double PI = acos(-1.0);
const double EPS = 1e-8;

//SAY HELLO TO MY LIL' FRIEND

struct point {
	ll x, y;

	point() {}
	point(ll x, ll y) : x(x), y(y) {}

	bool operator<(point p) {
		if (y != p.y)
			return y < p.y;
		return x < p.x;
	}
};

struct vt {
	ll x, y;

	vt() {}
	vt(ll x, ll y) : x(x), y(y) {}
	vt(point a, point b) : x(b.x - a.x), y(b.y - a.y) {}

	ll operator^(vt v) {
		return x * v.y - v.x * y;
	}

	ll len2() {
		return x * x + y * y;
	}
};

ll area(point a, point b, point c) {
	return abs(vt(a, b) ^ vt(a, c));
}

bool inside(point p, point a, point b, point c) {
	return (area(a, b, c) == area(p, a, b) + area(p, b, c) + area(p, c, a));
}

bool ask(int a, int b, int c) {
	cout << "? 3 " << a + 1 << " " << b + 1 << " " << c + 1 << endl;

	string res;
	cin >> res;

	return res[0] == 'Y';
}

void say(int a, int b, int c) {
	cout << "! 3 " << a + 1 << " " << b + 1 << " " << c + 1 << endl;
}

int n;
vector<pair<point, int> > p;

void go(pair<point, int> a, pair<point, int> b, pair<point, int> c) {
	if (!ask(a.Y, b.Y, c.Y))
		return;

	vector<pair<point, int> > ins;
	for (int i = 0; i < n; i++) {
		pair<point, int> d = p[i];
		if (d.Y == a.Y || d.Y == b.Y || d.Y == c.Y)
			continue;

		if (inside(d.X, a.X, b.X, c.X))
			ins.push_back(d);
	}

	if (ins.size() == 0) {
		say(a.Y, b.Y, c.Y);
		return;
	}
	
	int p = ((rand() << 16) + rand()) % ins.size();
	go(a, b, ins[p]);
	go(b, c, ins[p]);
	go(c, a, ins[p]);
}

vector<vector<pair<point, int> > > t;
void find_tiger() {
	for (int i = 0; i < t.size(); i++) {
		go(t[i][0], t[i][1], t[i][2]);
	}
}

int main() {
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
#else
	//freopen(TASK".in", "r", stdin);
	//freopen(TASK".out", "w", stdout);
#endif
	srand(time(NULL));

	iostream::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;
	p.resize(n);
	point mn(INF + 10, INF + 10);
	for (int i = 0; i < n; i++) {
		cin >> p[i].X.x >> p[i].X.y;
		p[i].Y = i;

		if (p[i].X < mn)
			mn = p[i].X;
	}

	sort(all(p), [mn](pair<point, int> a, pair<point, int> b) {
		vt va(mn, a.X), vb(mn, b.X);
		ll val = va ^ vb;
		if (val == 0)
			return va.len2() < vb.len2();
		return val > 0;
	});

	vector<pair<point, int> > hull;
	for (int i = 0; i < n; i++) {
		while (hull.size() > 1 && (vt(hull[hull.size() - 2].X, hull.back().X) ^ vt(hull.back().X, p[i].X)) <= 0) {
			hull.pop_back();
		}
		hull.push_back(p[i]);
	}
	t.resize(hull.size() - 2);
	for (int i = 1; i < hull.size() - 1; i++) {
		t[i - 1].push_back(hull[0]);
		t[i - 1].push_back(hull[i]);
		t[i - 1].push_back(hull[i + 1]);
	}

	int q;
	cin >> q;
	for (int x = 0; x < q; x++) {
		find_tiger();
	}

	return 0;
}