#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <queue>
#include <deque>
#include <list>
#include <bitset>
#include <utility>
#include <iterator>
#include <fstream>
#include <sstream>

#define X first
#define Y second
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define mp make_pair

#define TASK "servers"
#define SEED 322

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int INF = 1e9;
const ll LINF = 3e18;
const int MOD = 1e9 + 7;
const double PI = acos(-1.0);
const double EPS = 1e-8;

//oh boi oh boi what's that

int n;
vector<ll> l, r, t;

bool check(int pos, int st) {
	bool flag = true;
	ll curr = st;
	for (int i = pos; i > 0; i--) {
		if (curr + t[i] < l[i - 1]) {
			flag = false;
			break;
		}
		if (curr > r[i - 1]) {
			flag = false;
			break;
		}
		curr = max(curr, l[i - 1]);
	}

	curr = st;
	for (int i = pos; i < n - 1; i++) {
		if (curr + t[i] < l[i]) {
			flag = false;
			break;
		}
		if (curr > r[i]) {
			flag = false;
			break;
		}
		curr = max(curr, l[i]);
	}

	return flag;
}

void solve() {
	ll mn = LINF;
	for (int i = 0; i < n - 1; i++) {
		mn = min(mn, r[i]);
	}

	for (int pos = 0; pos < n; pos++) {
		ll lft = -1, rgt = mn;
		while (rgt - lft > 1) {
			ll mid = (lft + rgt) / 2;

			if (check(pos, mid)) {
				rgt = mid;
			}
			else {
				lft = mid;
			}
		}

		if (check(pos, rgt)) {
			cout << rgt << '\n';
		}
		else {
			cout << -1 << '\n';
		}
	}
}

void solve_fixedt() {
	vector<ll> leftl(n), leftr(n), rightl(n), rightr(n);
	leftl[0] = 0, leftr[0] = LINF;
	rightl[n - 1] = 0, rightr[n - 1] = LINF;

	for (int i = 1; i < n; i++) {
		if (leftr[i - 1] < l[i - 1] || leftl[i - 1] > r[i - 1] + t[i - 1]) {
			leftl[i] = LINF;
			leftr[i] = 0;
		}
		else {
			leftl[i] = max(leftl[i - 1], l[i - 1] - t[i]);
			leftr[i] = min(leftr[i - 1], r[i - 1]);
		}
}
	for (int i = n - 2; i >= 0; i--) {
		if (rightr[i + 1] < l[i] || rightl[i + 1] > r[i] + t[i + 1]) {
			rightl[i] = LINF;
			rightr[i] = 0;
		}
		else {
			rightl[i] = max(rightl[i + 1], l[i] - t[i]);
			rightr[i] = min(rightr[i + 1], r[i]);
		}
	}

	for (int i = 0; i < n; i++) {
		ll lft = max(leftl[i], rightl[i]);
		ll rgt = min(leftr[i], rightr[i]);

		if (lft > rgt) {
			cout << "-1\n";
		}
		else {
			cout << lft << '\n';
		}
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif
	//srand(SEED);

	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;
	t.resize(n);
	l.resize(n - 1);
	r.resize(n - 1);

	bool flag = true;
	for (int i = 0; i < n; i++) {
		cin >> t[i];

		if (t[i] != t[i - 1])
			flag = false;
	}
	for (int i = 0; i < n - 1; i++) {
		cin >> l[i] >> r[i];
	}

	if (flag)
		solve_fixedt();
	else
		solve();

	return 0;
}