#include <bits/stdc++.h>

typedef long long ll;
typedef double ld;

using namespace std;

ld NOL = (ld)(0);

struct Point
{
    ld x;
    ld y;
    Point():
        x(NOL),
        y(NOL) {};
    Point(ld x, ld y):
        x(x),
        y(y) {};
    Point(ld x1, ld y1, ld x2, ld y2):
        x(x2 - x1),
        y(y2 - y1) {};
    Point(Point a, Point b):
        x(b.x - a.x),
        y(b.y - a.y) {};
};

struct Line
{
    ld a, b, c;
    Line():
        a(NOL),
        b(NOL),
        c(NOL) {};
    Line(ld a, ld b, ld c):
        a(a),
        b(b),
        c(c) {};
    Line(Point p, Point q):
        a(p.y - q.y),
        b(q.x - p.x),
        c( (q.y - p.y) * p.x + (p.x - q.x) * p.y) {};
};

ld dist(Point p, Line l)
{
    return p.x * l.a + p.y * l.b + l.c;
}

ld len(Point p)
{
    return sqrt(p.x * p.x + p.y * p.y);
}

ld scal(Point p, Point q)
{
    return p.x * q.x + p.y * q.y;
}

ld cosinus(Point p, Point q)
{
    return scal(p, q) / len(p) / len(q);
}

vector<pair<Point, int>> a;
vector<Point> aa;
vector<int> b, c, used, d;

bool ask(vector<int> v)
{
    cout << "? " << v.size();
    for (int i : v)
        cout << " " << i + 1;
    cout << endl;
    string s;
    cin >> s;
    return s == "Yes";
}

Point N = Point(1, 0);

ld pol(Point a)
{
    return cosinus(N, a);
}

ld vect(Point a, Point b)
{
    return a.x * b.y - a.y * b.x;
}


bool cmp (pair<Point, int> a, pair<Point, int> b)
{
    return pol(a.first) > pol(b.first) || (pol(a.first) == pol(b.first) && len(a.first) < len(b.first));
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    a.resize(n);
    aa.resize(n);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i].first.x >> a[i].first.y;
        aa[i] = a[i].first;
        a[i].second = i;
        a[i].first.y += 1e9 + 5;
    }
    sort(a.begin(), a.end(), cmp);
    for (int i = 0; i < n; i++)
    {
        cout << a[i].second + 1 << endl;
        while (b.size() >= 2 && vect(Point(aa[b[b.size() - 2]], aa[b[b.size() - 1]]), Point(aa[b[b.size() - 2]], a[i].first)) < NOL)
            b.pop_back();
        b.push_back(a[i].second);
    }
    int q;
    cin >> q;
    for (int i : b) cout << i + 1 << endl;
    for (int ui = 0; ui < q; ui++)
    {
        c = b;
        while (true)
        {
            used.assign(n, 0);
            for (int i : c)
                used[i] = 1;
            int t = -1;
            for (int i = 0; t == -1 && i < n; i++)
            {
                if (used[i])
                    continue;
                bool good = true;
                for (int j = 0; good && j < c.size(); j++)
                {
                    Line l = Line(aa[c[j]], aa[c[(j + 1) % c.size()]]);
                    if (dist(aa[c[(j + 2) % c.size()]], l) * dist(aa[i], l) < NOL)
                        good = false;
                }
                if (good)
                    t = i;
            }
            if (t == -1)
                break;
            for (int i = 0; i < c.size(); i++)
            {
                d = {t, c[i], c[(i + 1) % c.size()]};
                if (ask(d))
                {
                    c = d;
                    break;
                }
            }
        }
        cout << "! " << c.size();
        for (int i : c)
            cout << " " << i + 1;
        cout << endl;
    }
    return 0;
}
/*
6
3 0
0 2
2 4
4 2
5 5
6 1
4
*/
