#include <bits/stdc++.h>

typedef long long ll;
typedef double ld;

using namespace std;

ld NOL = (ld)(0);

struct Point
{
    ld x;
    ld y;
    Point():
        x(NOL),
        y(NOL) {};
    Point(ld x, ld y):
        x(x),
        y(y) {};
    Point(ld x1, ld y1, ld x2, ld y2):
        x(x2 - x1),
        y(y2 - y1) {};
    Point(Point a, Point b):
        x(b.x - a.x),
        y(b.y - a.y) {};
};

struct Line
{
    ld a, b, c;
    Line():
        a(NOL),
        b(NOL),
        c(NOL) {};
    Line(ld a, ld b, ld c):
        a(a),
        b(b),
        c(c) {};
    Line(Point p, Point q):
        a(p.y - q.y),
        b(q.x - p.x),
        c( (q.y - p.y) * p.x + (p.x - q.x) * p.y) {};
};

ld dist(Point p, Line l)
{
    return p.x * l.a + p.y * l.b + l.c;
}

ld len(Point p)
{
    return sqrt(p.x * p.x + p.y * p.y);
}

ld scal(Point p, Point q)
{
    return p.x * q.x + p.y * q.y;
}

ld cosinus(Point p, Point q)
{
    return scal(p, q) / len(p) / len(q);
}

vector<Point> a;
vector<int> b, c, used, d;

bool ask(vector<int> v)
{
    cout << "? " << v.size();
    for (int i : v)
        cout << " " << i + 1;
    cout << endl;
    string s;
    cin >> s;
    return s == "Yes";
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++)
        cin >> a[i].x >> a[i].y;
    int f = 0;
    for (int i = 1; i < n; i++)
        if (a[f].y > a[i].y || (a[f].y == a[i].y && a[i].x < a[f].x))
            f = i;
    b.push_back(f);
    int g = 0;
    if (f == 0)
        g = 1;
    for (int i = 0; i < n; i++)
        if (i != f && (a[i].x - a[f].x) / len(Point(a[f], a[i])) > (a[g].x - a[f].x) / len(Point(a[f], a[g])))
            g = i;
    b.push_back(g);
    while (b.back() != f)
    {
        int q = 0, k = b.back();
        if (k == 0)
            q = 1;
        for (int i = 0; i < n; i++)
            if (i != k && dist(a[q], Line(a[k], a[i])) * dist(a[b[b.size() - 2]], Line(a[k], a[i])) > NOL)
                q = i;
        b.push_back(q);
    }
    b.pop_back();
    int q;
    cin >> q;
    for (int ui = 0; ui < q; ui++)
    {
        c = b;
        while (c.size() > 3)
        {
            d.clear();
            for (int i = 0; i <= c.size() / 2; i++)
                d.push_back(c[i]);
            if (ask(d))
            {
                c = d;
                continue;
            }
            d.clear();
            for (int i = c.size() / 2; i < c.size(); i++)
                d.push_back(c[i]);
            d.push_back(c[0]);
            c = d;
        }
        while(true)
        {
            used.assign(n, 0);
            for (int i : c)
                used[i] = 1;
            int t = -1;
            for (int i = 0; t == -1 && i < n; i++)
            {
                if (used[i])
                    continue;
                bool good = true;
                for (int j = 0; good && j < c.size(); j++)
                {
                    Line l = Line(a[c[j]], a[c[(j + 1) % c.size()]]);
                    if (dist(a[c[(j + 2) % c.size()]], l) * dist(a[i], l) < NOL)
                        good = false;
                }
                if (good)
                    t = i;
            }
            if (t == -1)
                break;
            for (int i = 0; i < c.size(); i++)
            {
                d = {t, c[i], c[(i + 1) % c.size()]};
                if (ask(d))
                {
                    c = d;
                    break;
                }
            }
        }
        cout << "! " << c.size();
        for (int i : c)
            cout << " " << i + 1;
        cout << endl;
    }
    return 0;
}
/*
6
3 0
0 2
2 4
4 2
5 5
6 1
4
*/
