#include <bits/stdc++.h>

typedef long long ll;
typedef double ld;

using namespace std;

ld NOL = (ld)(0);

struct Point
{
    ld x;
    ld y;
    Point():
        x(NOL),
        y(NOL) {};
    Point(ld x, ld y):
        x(x),
        y(y) {};
    Point(ld x1, ld y1, ld x2, ld y2):
        x(x2 - x1),
        y(y2 - y1) {};
    Point(Point a, Point b):
        x(b.x - a.x),
        y(b.y - a.y) {};
};

struct Ppoint
{
    ll x;
    ll y;
    Ppoint():
        x(0),
        y(0) {};
    Ppoint(ll x, ll y):
        x(x),
        y(y) {};
    Ppoint(ll x1, ll y1, ll x2, ll y2):
        x(x2 - x1),
        y(y2 - y1) {};
    Ppoint(Ppoint a, Ppoint b):
        x(b.x - a.x),
        y(b.y - a.y) {};
};

struct Line
{
    ll a, b, c;
    Line():
        a(0),
        b(0),
        c(0) {};
    Line(ll a, ll b, ll c):
        a(a),
        b(b),
        c(c) {};
    Line(Ppoint p, Ppoint q):
        a(p.y - q.y),
        b(q.x - p.x),
        c( (q.y - p.y) * p.x + (p.x - q.x) * p.y) {};
};

struct Lline
{
    ld a, b, c;
    Lline():
        a(NOL),
        b(NOL),
        c(NOL) {};
    Lline(ld a, ld b, ld c):
        a(a),
        b(b),
        c(c) {};
    Lline(Point p, Point q):
        a(p.y - q.y),
        b(q.x - p.x),
        c( (q.y - p.y) * p.x + (p.x - q.x) * p.y) {};
};


ld dist(Point p, Lline l)
{
    return p.x * l.a + p.y * l.b + l.c;
}

ld distt(Ppoint p, Line l)
{
    return p.x * l.a + p.y * l.b + l.c;
}

ld len(Point p)
{
    return sqrt(p.x * p.x + p.y * p.y);
}

ld scal(Point p, Point q)
{
    return p.x * q.x + p.y * q.y;
}

ld cosinus(Point p, Point q)
{
    return scal(p, q) / len(p) / len(q);
}

vector<Point> a;
vector<Ppoint> A;
vector<int> b, c, used, d;

bool ask(vector<int> v)
{
    cout << "? " << v.size();
    for (int i : v)
        cout << " " << i + 1;
    cout << "\n";
    fflush(stdout);
    string s;
    cin >> s;
    return s == "Yes";
}

set<int> qq;

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++)
    {
        int aaa, bbb;
        cin >> aaa >> bbb;
        //scanf("%d %d", &aaa, &bbb);
        a[i].x = aaa;
        a[i].y = bbb;
    }
    int f = 0;
    for (int i = 1; i < n; i++)
        if (a[f].y > a[i].y || (a[f].y == a[i].y && a[i].x < a[f].x))
            f = i;
    b.push_back(f);
    int g = 0;
    if (f == 0)
        g = 1;
    for (int i = 0; i < n; i++)
        if (i != f && (a[i].x - a[f].x) / len(Point(a[f], a[i])) > (a[g].x - a[f].x) / len(Point(a[f], a[g])))
            g = i;
    used.assign(n, 0);
    b.push_back(g);
    used[g] = 1;
    while (b.back() != f)
    {
        int q = 0, k = b.back();
        while (used[q])
            q++;
        for (int i = 0; i < n; i++)
            if ((b.size() > 2 || i != f) && !used[i] && dist(a[q], Lline(a[k], a[i])) * dist(a[b[b.size() - 2]], Lline(a[k], a[i])) > NOL)
                q = i;
        b.push_back(q);
        used[q] = 1;
    }
    for (int i = 0; i < n; i++)
        A.push_back(Ppoint(a[i].x, a[i].y));
    b.pop_back();
    int q;
    cin >> q;
    for (int ui = 0; ui < q; ui++)
    {
        c = b;
        for (int i = 1; i + 1 < c.size(); i++)
        {
            d = {c[0], c[i], c[i + 1]};
            if (ask(d))
            {
                c = d;
                break;
            }
        }
        for (int i = 0; i < n; i++)
            qq.insert(i);
        while(true)
        {
            used.assign(n, 0);
            for (int i : c)
                used[i] = 1;
            int t = -1;
            for (int i : qq)
            {
                qq.erase(i);
                if (used[i])
                    continue;
                bool good = true;
                for (int j = 0; good && j < c.size(); j++)
                {
                    Line l = Line(A[c[j]], A[c[(j + 1) % c.size()]]);
                    if (distt(A[c[(j + 2) % c.size()]], l) * distt(A[i], l) < 0)
                        good = false;
                }
                if (good)
                {
                    t = i;
                    break;
                }
            }
            if (t == -1)
                break;
            for (int i = 0; i < c.size(); i++)
            {
                d = {t, c[i], c[(i + 1) % c.size()]};
                if (ask(d))
                {
                    c = d;
                    break;
                }
            }
        }
        cout << "! " << c.size();
        for (int i : c)
            cout << " " << i + 1;
        cout << "\n";
        fflush(stdout);
    }
    return 0;
}
/*
6
3 0
0 2
2 4
4 2
5 5
6 1
4
*/
