#define first X
#define second Y
#define push_back pb
#define pop_back pob
#define make_pair mp
#define _p(x, y) pair<x, y>

#include <iostream>
#include <set>
#include <map>
#include <stdio.h>
#include <string>
#include <vector>
#include <queue>
#include <algorithm>
#include <cmath>
#include <iterator>
#include <climits>

using namespace std;

typedef long long i64;
#define endl '\n'

const int INF = 1000000007;
const i64 LINF = 1000000000000000007;

struct dsu {

	vector < int > data, sz;

	explicit dsu(int n) {
		data.resize(n);
		sz.resize(n, 1);
		for (int i = 0; i < n; i++) {
			data[i] = i;
		}
	}

	int get(int a) {
		if (data[a] == a) {
			return a;
		}

		return data[a] = get(data[a]);
	}

	int unite(int a, int b) {

		if (a == -1)
			return b;
		if (b == -1)
			return a;

		a = get(a);
		b = get(b);

		if (a == b)
			return a;

		if (sz[a] > sz[b]) {
			data[b] = a;
			sz[a] += sz[b];
			return a;
		}
		else {
			data[a] = b;
			sz[b] += sz[a];
			return b;
		}

		return -1;
	}

};

struct seg {

	int l, r;
	int size;
	char c;
	bool ch;

	explicit seg(int tl, int tr, int ts, int tc, bool ch = false) {
		l = tl;
		r = tr;
		size = ts;
		c = tc;
		this->ch = ch;
	}

};

int main() {

#ifdef _DEBUG
	freopen("B.txt", "r", stdin);
#endif

	int n;
	scanf("%d", &n);

	vector < _p(i64, i64) > pref(n, mp(LINF, 0)), suff(n, mp(LINF, 0));
	vector < char > cor(n, 0);
	pref[0] = suff[n - 1] = mp(0, LINF);
	cor[0]++;
	cor[n - 1]++;

	vector < i64 > w8(n);
	for (int i = 0; i < n; i++) {
		scanf("%lld", &w8[i]);
	}

	vector < _p(i64, i64) > edge(n - 1);
	for (int i = 0; i < n - 1; i++) {
		scanf("%lld%lld", &edge[i].X, &edge[i].Y);
	}

	bool bad = false;
	for (int i = 1; i < n && !bad; i++) {
		pref[i] = pref[i - 1];
		pref[i].X = max(pref[i].X, edge[i - 1].X);
		pref[i].Y = min(pref[i].Y, edge[i - 1].Y);

		if (pref[i].X > pref[i].Y) {
			bad = true;
			continue;
		}

		cor[i]++;

		if (edge[i - 1].X >= pref[i - 1].X) {
			pref[i].X -= w8[i];
			pref[i].X = max(pref[i].X, 0LL);
		}
	}

	bad = false;
	for (int i = n - 2; i >= 0 && !bad; i--) {
		suff[i] = suff[i + 1];

		suff[i].X = max(suff[i].X, edge[i].X);
		suff[i].Y = min(suff[i].Y, edge[i].Y);

		if (suff[i].X > suff[i].Y) {
			bad = true;
			continue;
		}

		cor[i]++;

		if (edge[i].X >= suff[i + 1].X) {
			suff[i].X -= w8[i];
			suff[i].X = max(suff[i].X, 0LL);
		}
	} 

	for (int i = 0; i < n; i++) {
	
		if (cor[i] < 2) {
			printf("-1\n");
			continue;
		}

		if (suff[i].X > pref[i].Y || pref[i].X > suff[i].Y)
			printf("-1\n");
		else
			printf("%lld\n", max(pref[i].X, suff[i].X));

	}


	return 0;
}