#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <stack>
#include <set>

using namespace std;

typedef long long ll;

struct point
{
	ll x;
	ll y;
	ll ind;
};

ll Plus(vector<int> &v)
{
	ll cnt = 0;

	ll ost = 1;

	for (int i = v.size() - 1; i >= 0; --i)
	{
		v[i] += ost;
		ost = 0;

		if (v[i] >= 2)
		{
			v[i] %= 2;
			ost = 1;
		}

		if (v[i] == 1)
			++cnt;
	}
	return cnt;
}

bool comp(point a, point b)
{
	if (a.x == b.x)
		return a.y < b.y;

	return a.x < b.x;
}

ll psevd(point a, point b, point c) // [ac; bc]
{
	return (a.x - c.x) * (b.y - c.y) - (a.y - c.y) * (b.x - c.x);
}

int main()
{
	ll n, cnt = 0;
	cin >> n;
	vector<point> v(n);

	for (int i = 0; i < n; ++i)
	{
		cin >> v[i].x >> v[i].y;
		v[i].ind = i;
	}

	sort(v.begin(), v.end(), comp);

	ll q;
	cin >> q;

	vector<int> mask(n);

	for (int t = 0; t <= (1 << n); ++t)
	{
		if (cnt == q)
			break;

		ll cnt = Plus(mask);
		if (cnt < 3)
		{
			continue;
		}

		int fl = 0;

		stack<point> st;

		for (int i = 0; i < n; ++i)
		{
			if (mask[i] == 1)
			{
				if (st.size() >= 3)
				{
					point Top = st.top();
					st.pop();

					if (st.size() >= 2 && psevd(v[i], Top, st.top()) >= 0)
					{
						while (st.size() >= 2 && psevd(v[i], Top, st.top()) >= 0)
						{
							Top = st.top();
							st.pop();
						}
					}
					else
					{
						st.push(Top);
					}
					st.push(v[i]);
				}
				else
				{
					st.push(v[i]);
				}
			}
		}

		vector<point> req;
		while (!st.empty())
		{
			req.push_back(st.top());
			st.pop();
		}

		int fl = 0;

		for (int j = 0; j < n; ++j)
		{
			if (mask[j] == 1)
				continue;

			for (int i = 0; i < req.size() - 1; ++i)
			{
				if (psevd(req[i], req[i + 1], v[j]) >= 0)
				{
					fl = 1;
					break;
				}
			}
		}

		if (!fl)
		{
			if (cnt == q)
				break;

			cout << "? ";
			for (int yy = 0; yy < req.size(); ++yy)
				cout << req[yy].ind << " ";
			cout << endl;

			string answer;
			cin >> answer;

			if (answer == "Yes")
			{
				++cnt;
			}
			if (cnt == q)
				break;
		}
	}

	return 0;
}

/*
3
0 1 4
3
2 7
3 3
1 4

*/