#include <iostream>
#include <stack>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ld, ld> pll;
ld len(pll a, pll b) {
	return sqrtl((a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second));
}
ld sq(pll a, pll b, pll c) {
	ld ab = len(a, b), ac = len(a, c), bc = len(b, c);
	ld p = (ab + bc + ac) / 2;
	return sqrtl(p * (p - ab) * (p - ac) * (p - bc));
}
#define all(s) s.begin(), s.end()
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin >> n;
	int q;
	vector<pair<ld, vector<int>> > triangles;
	vector<pair<ld, ld> > points(n);
	for (int i = 0; i < n; i++)
		cin >> points[i].first >> points[i].second;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			for (int k = j + 1; k < n; k++) {
				ld s = sq(points[i], points[j], points[k]);
				int flag = 1;
				for (int p = 0; p < n; p++)
					if (p != i && p != j && p != k && abs(sq(points[p], points[i], points[j]) + sq(points[p], points[i], points[k]) + sq(points[p], points[j], points[k]) - s) <= 1e-8) {
						flag = 0;
						break;
					}
				if(flag)
					triangles.push_back({ sq(points[i], points[j], points[k]), vector<int>{i, j, k} });
			}
		}
	}
	random_shuffle(all(triangles));
	cin >> q;
	for (int i = 0; i < q; i++) {
		for (auto j : triangles) {
			cout << "? 3 " << j.second[0] + 1 << ' ' << j.second[1] + 1 << ' ' << j.second[2] + 1 << endl;
			string req;
			cin >> req;
			if (req == "Yes") {
				cout << "! 3 " << j.second[0] + 1 << ' ' << j.second[1] + 1 << ' ' << j.second[2] + 1 << endl;
				break;
			}
		}
	}
}