#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>

using namespace std;
#define pb push_back
#define mp make_pair
#define pii pair <int, int>
#define ff first
#define ss second

vector <int> par, szs;

int get(int v) {
	if (par[v] == v)
		return v;
	return par[v] = get(par[v]);
}

void join(int u, int v) {
	u = get(u); v = get(v);
	szs[u] += szs[v];
	par[v] = u;
}


bool solve_dumber(vector <int> &a) {
	int n = a.size();
	int ok = 1;
	set <int> unfound;
	queue <int> q;
	for (int i = 1; i < n; i += 2) {
		unfound.insert(i);
		q.push(i);
	}
	szs.assign(n, 0); par.assign(n, 0);
	for (int i = 0; i < n; ++i) {
		par[i] = i; szs[i] = a[i];
	}

	while (!q.empty()) {
		int i = q.front();
		q.pop();
		if (!unfound.count(i))
			continue;
		int ls = get(i - 1), rs = get(i + 1);
		if (szs[ls] > a[i] || szs[rs] > a[i]) {
			int nsum = szs[ls] + a[i] + szs[rs];
			unfound.erase(i);
			szs[ls] += a[i];
			join(ls, rs);

			auto nxtl = unfound.lower_bound(i);
			if (nxtl != unfound.end())
				q.push(*nxtl);
			if (nxtl != unfound.begin())
				q.push(*(--nxtl));
		}
	}
	return unfound.empty();
}


bool solve() {
	string s, t;
	cin >> s >> t;
	if (s.size() != t.size())
		return 0;
	vector <int> sts, stt;
	sts.pb(0); stt.pb(0);
	for (int i = 1; i < s.size(); ++i)
		if (s[i] != s[i - 1])
			sts.pb(i);
	for (int i = 1; i < t.size(); ++i)
		if (t[i] != t[i - 1])
			stt.pb(i);

	int j = 0;
	for (auto i : stt) {
		while (j < sts.size() && sts[j] < i)
			j++;
		if (j == sts.size() || sts[j] != i)
			return 0;
	}
	stt.pb(s.size()); sts.pb(t.size());

	vector <pii> was, is;
	was.pb(mp(0, 0));
	for (int i = 0; i + 1 < sts.size(); ++i) 
		was.pb(mp(sts[i + 1] - sts[i], s[sts[i]] != t[sts[i]]));

	for (int i = 0; i + 1 < was.size(); ++i)
		if (was[i].ss && was[i + 1].ss)
			return 0;
	was.pb(mp(0, 0));

	int st = 0;
	while (st < was.size()) {
		while (st < was.size() && !was[st].ss)
			st++;
		if (st == was.size())
			break;
		int fn = st;
		while (fn + 2 < was.size() && was[fn + 2].ss)
			fn += 2;
		vector <int> a;
		for (int i = st - 1; i <= fn + 1; ++i)
			a.pb(was[i].ff);
		if (!solve_dumber(a))
			return 0;
		st = fn + 2;
	}
	
	return 1;
}



int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	int q;
	cin >> q;
	while (q--) {
		if (solve())
			cout << "Yes\n";
		else
			cout << "No\n";
	}
}