#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>

using namespace std;
#define pb push_back
#define mp make_pair
#define pii pair <int, int>
#define ff first
#define ss second

#define int long long

vector <int> par;
vector <int> sz;
int mxsz = 0;

int get(int u) {
	if (u == par[u])
		return u;
	return par[u] = get(par[u]);
}
void join(int u, int v) {
	u = get(u); v = get(v);
	sz[u] += sz[v];
	par[v] = u;
	mxsz = max(mxsz, sz[u]);
}


int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	int n, m;
	cin >> n >> m;
	vector <int> a(n), x(n), b(m), y(m);
	vector <int> px(n + 1, 0), py(m + 1, 0);
	for (auto & i : a)
		cin >> i;
	for (auto & i : x)
		cin >> i;
	for (auto & i : b)
		cin >> i;
	for (auto & i : y)
		cin >> i;

	for (int i = 1; i <= n; ++i)
		px[i] = px[i - 1] + x[i - 1];
	for (int i = 1; i <= m; ++i)
		py[i] = py[i - 1] + y[i - 1];

	vector <int> whereb(n + m + 1, -1);
	vector <int> wherea(n + m + 1, -1);
	for (int i = 0; i < m; ++i)
		whereb[b[i]] = i;
	for (int i = 0; i < n; ++i)
		wherea[a[i]] = i;

	par.resize(m); sz.resize(m);
	int ans = -1, ansi = -1, ansj = -1;
	for (int i = 0; i < n; ++i) {
		mxsz = 0;
		vector <bool> bad(m, 0);
		for (int j = 0; j < m; ++j) {
			if (wherea[b[j]] >= i)
				bad[j] = 1;
			par[j] = j;
			sz[j] = y[j];
			if (!bad[j])
				mxsz = max(mxsz, sz[j]);
		}
		for (int j = 1; j < m; ++j) {
			if (!bad[j] && !bad[j - 1])
				join(j, j - 1);
		}
		if (px.back() - px[i] + mxsz > ans) {
			ans = px.back() - px[i] + mxsz;
			ansi = i;
			ansj = n;
		}
		for (int j = n - 1; j >= i; --j) {
			int k = whereb[a[j]];
			if (k != -1) {
				bad[k] = 0;
				mxsz = max(mxsz, sz[k]);
				if (k != 0 && !bad[k - 1])
					join(k, k - 1);
				if (k + 1 != m && !bad[k + 1])
					join(k, k + 1);
			}

			if (px[j] - px[i] + mxsz > ans) {
				ans = px[j] - px[i] + mxsz;
				ansi = i;
				ansj = j;
			}
		}
	}
	cout << ans << endl;
	if (ansj == ansi) 
		cout << "0 0\n";
	else 
		cout << ansi + 1 << ' ' << ansj << '\n';

	vector <int> goods;
	for (int k = 0; k < m; ++k) {
		if (!(wherea[b[k]] >= ansi && wherea[b[k]] < ansj))
			goods.pb(k);
	}
	for (int i = 0; i < goods.size(); ++i) {
		int j = i;
		while (j + 1 < goods.size() && goods[j + 1] == goods[j] + 1)
			j++;
		if (px[ansj] - px[ansi] + py[goods[j] + 1] - py[goods[i]] == ans) {
			cout << goods[i] + 1 << ' ' << goods[j] + 1 << '\n';
			return 0;
		}
	} 
	cout << "0 0\n";
}