#include <vector>
#include <iostream>
#include <fstream>

using namespace std;

const int MAX_N = 1e6 + 1;

int n, m;
vector< pair<int, int> > g[MAX_N];
bool seen[MAX_N];

typedef long long ll;

ll currTSum = 0;
ll currT2Sum = 0;

ll bestTSum = 1e18;
ll bestT2Sum = 0;

void dfs(int v) {
    if (v == n - 1) {
        if (currTSum < bestTSum || (currTSum == bestTSum && currT2Sum > bestT2Sum)) {
            bestTSum = currTSum;
            bestT2Sum = currT2Sum;
        }
    }

    if (currTSum > bestTSum)
        return;

    if (seen[v]) return;
    seen[v] = true;

    for (auto p : g[v]) {
        int u = p.first;
        int t = p.second;

        currTSum += t;
        currT2Sum += ((ll)t) * t;
        dfs(u);
        currTSum -= t;
        currT2Sum -= ((ll)t) * t;
    }

    seen[v] = false;
}

int main() {
    ifstream fin("trains.in");
    fin >> n >> m;
    for (int i = 0; i < n; i++)
        seen[i] = false;

    for (int i = 0; i < m; i++) {
        int s;
        fin >> s;
        int vPrev;
        fin >> vPrev;
        vPrev--;
        for (int j = 0; j < s; j++) {
            int t, v;
            fin >> t >> v;
            v--;
            g[vPrev].push_back(make_pair(v, t));
            vPrev = v;
        }
    }
    /*
    for (int i = 0; i < n; i++) {
        cout << i << ":";
        for (auto p : g[i])
            cout << " " << p.first << " [" << p.second << "]";
        cout << endl;
    }
    */
    dfs(0);
    cout << bestTSum << " " << bestT2Sum << endl;
}
