#define _CRT_SECURE_NO_WARNINGS

#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <cassert>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef pair<int, int> pii;
typedef vector<pii> vpii;

#define X first
#define Y second
#define mk make_pair
#define inb push_back
#define all(v) v.begin(), v.end()

int solve();

int main()
{
	//ios_base::sync_with_stdio(0);
	//cin.tie(0);
	//cout.tie(0);
	srand(2569);
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
}

const int MAXN = (int)5e4 + 7;

struct Point
{
	ll x, y, id;
	Point() {};
	Point(ll x, ll y) : x(x), y(y) {};
	Point operator- (Point a)
	{
		return Point(x - a.x, y - a.y);
	}
	ll operator% (Point a)
	{
		return x * a.x + y * a.y;
	}
	ll operator* (Point a)
	{
		return x * a.y - y * a.x;
	}
};

Point makeV(Point a, Point b)
{
	return b - a;
}

struct triangle
{
	Point a, b, c;
	triangle() {};
	triangle(Point a, Point b, Point c) : a(a), b(b), c(c) {};
	bool ask()
	{
		cout << "? 3 " << a.id + 1 << " " << b.id + 1 << " " << c.id + 1 << endl;
		string res;
		cin >> res;
		return res[0] == 'Y';
	}
	void print()
	{
		cout << "! 3 " << a.id + 1 << " " << b.id + 1 << " " << c.id + 1 << endl;
	}
	ll getsq()
	{
		Point v1 = makeV(a, b);
		Point v2 = makeV(a, c);
		return abs(v1 * v2);
	}
};

bool pinside(triangle t, Point p)
{
	Point vpa = makeV(p, t.a), vpb = makeV(p, t.b), vpc = makeV(p, t.c);
	int zn = vpa * vpb < 0;
	if (vpa * vpb == 0)
		return 0;
	{
		int nzn = vpb * vpc < 0;
		if (nzn != zn)
			return 0;
		if (vpb * vpc == 0)
			return 0;
	}
	{
		int nzn = vpc * vpa < 0;
		if (nzn != zn)
			return 0;
		if (vpc * vpa == 0)
			return 0;
	}
	return 1;
}

int n;
Point p[5001];
vector <triangle> q;
int qrs;

bool cmp(triangle a, triangle b)
{
	return a.getsq() > b.getsq();
}
int GET()
{
	for (auto t : q)
	{
		if (t.ask())
		{
			t.print();
			return 0;
		}
	}
	return 0;
}

int solve()
{
	cin >> n;
	for (int i = 0; i < n; ++i)
	{
		cin >> p[i].x >> p[i].y;
		p[i].id = i;
	}
	for (int i = 0; i < n; ++i)
	{
		for (int j = i + 1; j < n; ++j)
		{
			for (int z = j + 1; z < n; ++z)
			{
				int f = 1;
				triangle cur = triangle(p[i], p[j], p[z]);
				for (int k = 0; k < n; ++k)
				{
					if (!f)
						break;
					if (k != i && k != j && k != z)
					{
						if (pinside(cur, p[k]))
						{
							f = 0;
							break;
						}
					}
				}
				if (f)
					q.inb(cur);
			}
		}
	}
	sort(all(q), cmp);
	if (n > 20)
		assert(n == 60), random_shuffle(all(q)), random_shuffle(all(q));
	cin >> qrs;
	while (qrs--)
	{
		GET();
	}
	return 0;
}