import java.io.*;
import java.util.*;

public class C {
	public static BufferedReader bf;
	public static PrintWriter out;

	public static void main(String[] args) throws IOException {
		bf = new BufferedReader(new FileReader(new File("trains.in")));
		out = new PrintWriter(new File("trains.out"));

		solve();

		bf.close();
		out.close();
	}

	static int n;
	static int m;

	static ArrayList<Edge>[] graph;

	static Pair dist[];

	private static void solve() throws IOException {
		nextInt();

		graph = new ArrayList[n];
		dist = new Pair[n];

		for (int i = 0; i < n; i++) {
			graph[i] = new ArrayList<>();
		}

		for (int i = 0; i < m; i++) {
			read();
		}

		func(0);
	}

	public static void func(int start) {
		TreeSet<Triple> set = new TreeSet<>();

		for (int i = 0; i < n; i++) {
			dist[i] = new Pair(Long.MAX_VALUE / 3, Long.MAX_VALUE / 3);
		}

		set.add(new Triple(start, start, 0));

		while (!set.isEmpty()) {
			Triple e = set.pollFirst();

			int v = e.v;
			int prev = e.u;

			if (v == prev) {
				dist[v].a = 0;
				dist[v].b = 0;
			} else {
				if (dist[v].a < dist[prev].a + e.b) {
					continue;
				}

				dist[v].a = dist[prev].a + e.b;
				dist[v].b = Math.max(dist[v].b, dist[prev].b + e.b * e.b);
			}

			for (Edge edge : graph[v]) {
				if (dist[edge.to].a < dist[v].a + edge.len) {
					continue;
				} else {
					set.add(new Triple(edge.to, v, edge.len));
				}
			}
		}

		out.println(dist[n - 1].a + " " + dist[n - 1].b);
	}

	public static void read() throws IOException {
		StringTokenizer st = new StringTokenizer(bf.readLine());

		int s = Integer.parseInt(st.nextToken());
		int last = Integer.parseInt(st.nextToken()) - 1;

		for (int i = 0; i < s; i++) {
			int w = Integer.parseInt(st.nextToken());
			int v = Integer.parseInt(st.nextToken()) - 1;

			graph[last].add(new Edge(v, w));

			last = v;
		}
	}

	private static void nextInt() throws IOException {
		StringTokenizer st = new StringTokenizer(bf.readLine());
		n = Integer.parseInt(st.nextToken());
		m = Integer.parseInt(st.nextToken());
	}

	public static class Pair {
		long a;
		long b;

		public Pair(long d, long l) {
			a = d;
			b = l;
		}

		@Override
		public String toString() {
			return a + " " + b;
		}
	}

	public static class Triple implements Comparable<Triple> {
		int v;
		int u;
		long b;

		public Triple(int a, int c, long l) {
			v = a;
			u = c;
			b = l;
		}

		@Override
		public int compareTo(Triple o) {
			long len1 = dist[u].a + b;
			long len2 = dist[o.u].a + o.b;
			
			if (len1 == len2) {
				if (b == o.b) {
					return Integer.compare(v, o.v);
				}
				return Long.compare(b, o.b);
			} 
			
			return Long.compare(len1, len2);
		}

		@Override
		public String toString() {
			return u + " " + v + " " + b;
		}
	}

	public static class Edge implements Comparable<Edge> {
		int to;
		int len;

		public Edge(int v, int l) {
			to = v;
			len = l;
		}

		@Override
		public int compareTo(Edge o) {
			if (len == o.len) {
				return Integer.compare(to, o.to);
			}

			return Long.compare(len, o.len);
		}

		@Override
		public String toString() {
			return to + " " + len;
		}
	}
}
