#include <iostream>
#include <algorithm>
#include <set>
#include <map>
 
using namespace std;
 
typedef long long ll;
 
const int INF = (int) 1e9 + 123;
const ll LINF = (ll) 1e18 + 123;
 
void run();
 
int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    run();
    return 0;
}
 
const int N = (int) 1e6 + 12;
const int L = 30;
 
struct Trie {
    int to[2];
    int mi, ma;
     
    Trie() {
        to[0] = to[1] = -1;
        mi = INF;
        ma = -INF;
    }
};
 
Trie t[20097152 + 12345];
int ptr = 1;
 
int n, qcnt;
int a[N];
pair<int, int> b[N];
set<int>* q[2 * N];
int ok[L], nok[L];
int tmp[2 * N];
int repl[2 * N];
 
void ans() {
    bool f = true;
    int qq = 0;
    for (int i = 0; i < L; i++) {
        if (ok[i]) {
            qq |= (1 << i);
            if (nok[i]) {
                f = false;
            }
        }
    }
     
    cout << (f ? qq : -1) << "\n";
}
 
void just_add(int x, int v = 0, int level = L) {
    if (level == 0) {
        return;
    }
     
    bool bit = bool(x & (1 << (level - 1)));
    if (t[v].to[bit] == -1) {
        t[v].to[bit] = ptr++;
    }
    just_add(x, t[v].to[bit], level - 1);
}
 
void rem_old(int v, int level) {
    if (t[v].to[0] != -1 && t[v].to[1] != -1) {
        int x = t[v].to[0];
        int y = t[v].to[1];
         
        if (t[x].ma > t[y].mi) {
            ok[level - 1]--;
        }
        if (t[y].ma > t[x].mi) {
            nok[level - 1]--;
        }
    }
}
 
void add_new(int v, int level) {
    if (t[v].to[0] != -1 && t[v].to[1] != -1) {
        int x = t[v].to[0];
        int y = t[v].to[1];
         
        if (t[x].ma > t[y].mi) {
            ok[level - 1]++;
        }
        if (t[y].ma > t[x].mi) {
            nok[level - 1]++;
        }
    }
}
 
void recalc(int pos, int v = 0, int level = L) {
    if (level == 0) {
        if (q[tmp[pos]]->empty()) {
            t[v].ma = -INF;
            t[v].mi = INF;
        } else {
            t[v].ma = *(*q[tmp[pos]]).rbegin();
            t[v].mi = *(*q[tmp[pos]]).begin();
        }
        return;
    }
     
    rem_old(v, level);
    int bit = bool(a[pos] & (1 << (level - 1)));
    if (t[v].to[bit] == -1) {
        t[v].to[bit] = ptr++;
    }
    recalc(pos, t[v].to[bit], level - 1);
     
    t[v].ma = -INF;
    t[v].mi = INF;
    for (int i = 0; i < 2; i++) {
        if (t[v].to[i] != -1) {
            t[v].ma = max(t[v].ma, t[t[v].to[i]].ma);
            t[v].mi = min(t[v].mi, t[t[v].to[i]].mi);
        }
    }
     
    add_new(v, level);
}
 
int get_val(int ind) {
    if (ind >= n) {
        return b[ind - n].second;
    } else {
        return a[ind];
    }
}
 
bool cmp(int i, int j) {
    return get_val(i) < get_val(j);
}
 
void ff(int x){
    if (q[x] == 0) q[x] = new set<int>();
}
 
void run() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
     
    cin >> qcnt;
    for (int i = 0; i < qcnt; i++) {
        int p, v;
        cin >> p >> v;
        p--;
        b[i] = {p, v};
    }
     
    for (int i = 0; i < n + qcnt; i++) {
        tmp[i] = i;
    }
     
    sort(tmp, tmp + n + qcnt, cmp);
    int cc = 0;
    for (int i = 0; i < n + qcnt; i++) {
        int j = i;
        while (j + 1 < n + qcnt && get_val(tmp[j + 1]) == get_val(tmp[i])) j++;
         
        for (int k = i; k <= j; k++) {
            repl[tmp[k]] = cc;
        }
         
        i = j;
        cc++;
    }
     
    for (int i = 0; i < n; i++) {
        tmp[i] = repl[i];
    }
     
    for (int i = 0; i < n; i++) {
        just_add(a[i]);
        ff(tmp[i]);
        q[tmp[i]]->insert(i);
    }
     
    for (int i = 0; i < n; i++) {
        recalc(i);
    }
     
    ans();
     
    for (int i = 0; i < qcnt; i++) {
        int p = b[i].first;
        int v = b[i].second;
         
        q[tmp[p]]->erase(p);
        recalc(p);
         
        a[p] = v;
        tmp[p] = repl[i + n];
         
        ff(tmp[p]);
        q[tmp[p]]->insert(p);
        recalc(p);
        
        ans();
    }
}
