#include <iostream>
#include <algorithm>
#include <set>
#include <map>
 
using namespace std;
 
typedef long long ll;
 
const int INF = (int) 1e9 + 123;
const ll LINF = (ll) 1e18 + 123;
 
void run();
 
int main() {
    /*ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);*/
    run();
    return 0;
}
 
const int N = (int) 1e6 + 123;
const int L = 30;
 
struct Trie {
    int to[2];
    int mi, ma;
     
    Trie() {
        to[0] = to[1] = -1;
        mi = INF;
        ma = -INF;
    }
};
 
Trie t[20097152];
int ptr = 1;
 
int n, qcnt;
int a[N];
map<int, set<int>> q;
int ok[L], nok[L];
 
void ans() {
    bool f = true;
    int qq = 0;
    for (int i = 0; i < L; i++) {
        if (ok[i]) {
            qq |= (1 << i);
            if (nok[i]) {
                f = false;
            }
        }
    }
     
    printf("%d\n", (f ? qq : -1));
}
 
void just_add(int x, int v = 0, int level = L) {
    if (level == 0) {
        return;
    }
     
    bool bit = bool(x & (1 << (level - 1)));
    if (t[v].to[bit] == -1) {
        t[v].to[bit] = ptr++;
    }
    just_add(x, t[v].to[bit], level - 1);
}
 
void rem_old(int v, int level) {
    if (t[v].to[0] != -1 && t[v].to[1] != -1) {
        int x = t[v].to[0];
        int y = t[v].to[1];
         
        if (t[x].ma > t[y].mi) {
            ok[level - 1]--;
        }
        if (t[y].ma > t[x].mi) {
            nok[level - 1]--;
        }
    }
}
 
void add_new(int v, int level) {
    if (t[v].to[0] != -1 && t[v].to[1] != -1) {
        int x = t[v].to[0];
        int y = t[v].to[1];
         
        if (t[x].ma > t[y].mi) {
            ok[level - 1]++;
        }
        if (t[y].ma > t[x].mi) {
            nok[level - 1]++;
        }
    }
}
 
void build(int v = 0, int cur = 0, int level = L) {
    for (int i = 0; i < 2; i++) {
        int ncur = cur;
        if (i) {
            ncur += (1 << (level - 1));
        }
        if (t[v].to[i] != -1) {
            build(t[v].to[i], ncur, level - 1);
            t[v].ma = max(t[v].ma, t[t[v].to[i]].ma);
            t[v].mi = min(t[v].mi, t[t[v].to[i]].mi);
        }
    }
     
    if (level == 0) {
        t[v].ma = *q[cur].rbegin();
        t[v].mi = *q[cur].begin();
    }
     
    add_new(v, level);
}
 
void recalc(int pos, int v = 0, int level = L) {
    if (level == 0) {
        if (q[a[pos]].empty()) {
            t[v].ma = -INF;
            t[v].mi = INF;
        } else {
            t[v].ma = *q[a[pos]].rbegin();
            t[v].mi = *q[a[pos]].begin();
        }
        return;
    }
     
    rem_old(v, level);
    int bit = bool(a[pos] & (1 << (level - 1)));
    if (t[v].to[bit] == -1) {
        t[v].to[bit] = ptr++;
    }
    recalc(pos, t[v].to[bit], level - 1);
     
    t[v].ma = -INF;
    t[v].mi = INF;
    for (int i = 0; i < 2; i++) {
        if (t[v].to[i] != -1) {
            t[v].ma = max(t[v].ma, t[t[v].to[i]].ma);
            t[v].mi = min(t[v].mi, t[t[v].to[i]].mi);
        }
    }
     
    add_new(v, level);
}
 
void run() {
	scanf("%d", &n);
    for (int i = 0; i < n; i++) {
        scanf("%d", &a[i]);
        just_add(a[i]);
        q[a[i]].insert(i);
    }
     
    build();
    ans();
     
    scanf("%d", &qcnt);
    for (int i = 0; i < qcnt; i++) {
		scanf("%d%d", &p, &v);
        p--;
        q[a[p]].erase(p);
        recalc(p);
        a[p] = v;
        q[a[p]].insert(p);
        recalc(p);
        ans();
    }
}
