import java.io.*;
import java.util.ArrayList;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {
    int[] tree;
    int sh = 1;

    public void build(int[] a, int n) {
        while (sh < n) {
            sh *= 2;
        }
        tree = new int[2 * sh];
        for (int i = 0; i < n; i++) {
            tree[i + sh] = a[i];
        }
        for (int i = sh - 1; i > 0; i--) {
            tree[i] = tree[2 * i] + tree[2 * i + 1];
        }
    }

    public int sum(int x, int l1, int r1, int l, int r) {
        if (l1 > r || l > r1) {
            return 0;
        }
        if (l <= l1 && r1 <= r) {
            return tree[x];
        }
        return sum(2 * x, l1, (l1 + r1) / 2, l, r) + sum(2 * x + 1, (l1 + r1) / 2 + 1, r1, l, r);
    }

    public void solve() throws IOException {
        int n = nextInt();
        int m = nextInt();
        boolean[] used = new boolean[n + m];
        int[] a = new int[n];
        int[] x = new int[n];
        int[] b = new int[m];
        int[] y = new int[m];
        int l1 = 0;
        int r1 = 0;
        int l2 = 0;
        int r2 = 0;
        long s = 0;
        for (int i = 0; i < n; i++) {
            a[i] = nextInt() - 1;
        }
        long aa = 0;
        for (int i = 0; i < n; i++) {
            x[i] = nextInt();
            aa += x[i];
        }
        if (aa > s) {
            s = aa;
            l1 = 1;
            r1 = n;
        }
        for (int i = 0; i < m; i++) {
            b[i] = nextInt() - 1;
        }
        aa = 0;
        for (int i = 0; i < m; i++) {
            y[i] = nextInt();
            aa += y[i];
        }
        if (aa > s) {
            l2 = 1;
            r2 = m;
            l1 = 0;
            r1 = 0;
            s = aa;
        }
        int[] p = new int[n];
        for (int i = 0; i < n; i++) {
            p[i] = -1;
            for (int j = 0; j < m; j++) {
                if (a[i] == b[j]) {
                    p[i] = j;
                }
            }
        }
        build(y, m);
        for (int i = 0; i < n; i++) {
            long t = 0;
            ArrayList<Integer> q = new ArrayList<>();
            for (int j = i; j < n; j++) {
                t += x[j];
                if (p[j] != -1) {
                    q.add(p[j]);
                }
                q.sort(Integer::compareTo);
                for (int k1 = 0; k1 < q.size(); k1++) {
                    int k = 0;
                    int l = 0;
                    if (k1 == 0) {
                        if (q.get(k1) != 0) {
                            k = 0;
                            l = q.get(k1) - 1;
                        } else {
                            l = -1;
                        }
                    } else {
                        k = q.get(k1 - 1) + 1;
                        l = q.get(k1) - 1;
                    }
                    if (k <= l) {
                        int yy = sum(1,sh,2 * sh - 1,sh + k,sh + l);
                        if (s < t + yy) {
                            l1 = i + 1;
                            r1 = j + 1;
                            l2 = k + 1;
                            r2 = l + 1;
                            s = Math.max(s, t + yy);
                        }
                    }
                }
                if(q.size() > 0 && q.get(q.size() - 1) != m - 1){
                    int k = q.get(q.size() - 1) + 1;
                    int l = m - 1;
                    int yy = sum(1,sh,2 * sh - 1,sh + k,sh + l);
                    if (s < t + yy) {
                        l1 = i + 1;
                        r1 = j + 1;
                        l2 = k + 1;
                        r2 = l + 1;
                        s = Math.max(s, t + yy);
                    }
                }
            }
        }

        out.println(s);
        out.println(l1 + " " + r1);
        out.println(l2 + " " + r2);
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                return null;
            }
        }
        return sc.nextToken();
    }

    public Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
//            br = new BufferedReader(new FileReader("storage.in"));
//            out = new PrintWriter(new File("storage.out"));
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}