#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

vector<long long> x;
vector<long long> y;

bool cw(long long a, long long b, long long c) {
    return (x[b] - x[a]) * (y[c] - y[a]) - (y[b] - y[a]) * (x[c] - x[a]) > 0;
}

bool inside(long long a, long long b, long long c, long long i) {
    bool t1 = cw(i, a, b);
    bool t2 = cw(i, c, c);
    bool t3 = cw(i, c, a);
    return (t1 == t2) && (t1 == t3);

}

int main() {
    long long n, q;
    cin >> n;
    x.resize(n);
    y.resize(n);
    for (long long i = 0; i < n; ++i)
        cin >> x[i] >> y[i];
    cin >> q;
    string c;
    for (long long j = 0; j < q; ++j) {
        bool pass = false;
        for (long long t1 = 1; t1 <= n; ++t1) {
            for (long long t2 = t1 + 1; t2 <= n; ++t2) {
                for (long long t3 = t2 + 1; t3 <= n; ++t3) {
                    cout << "? 3 " << t1 << ' ' << t2 << ' ' << t3 << endl;
                    cin >> c;
                    if (c[0] == 'Y') {
                        pass = true;
                        for (int i = 1; i <= n; ++i)
                            if (i != t1 && i != t2 && i != t3)
                                if (inside(t1 - 1, t2 - 1, t3 - 1, i - 1)) {
                                    pass = false;
                                    break;
                                }
                        if (pass) {
                            cout << "! 3 " << t1 << ' ' << t2 << ' ' << t3 << endl;
                            break;
                        }
                    }
                }
                if (pass) break;
            }
            if (pass) break;
        }
    }
    return 0;
}

/*
6
3 0
0 2
2 4
4 2
5 5
6 1
4
*/
