#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 5000, INDEX = 1;

int sgn(long long x) {
    if (x > 0) {
        return 1;
    }

    if (x < 0) {
        return -1;
    }

    return 0;
}

struct Point {
    int x, y;

    Point() {
        ;
    }

    Point(int x, int y) {
        this->x = x;
        this->y = y;
    }
};

struct Line {
    long long a, b, c;

    Line() {
        ;
    }

    Line(Point a, Point b) {
        this->a = b.y - a.y;
        this->b = a.x - b.x;
        this->c = -(this->a * a.x + this->b * a.y);
    }

    int getSide(Point p) {
        return sgn(a * (long long)(p.x) + b * (long long)(p.y) + c);
    }
};

struct Triangle {
    int a, b, c;

    Triangle() {
        ;
    }

    Triangle(int a, int b, int c) {
        this->a = a;
        this->b = b;
        this->c = c;
    }

    friend bool operator < (Triangle a, Triangle b) {
        if (a.a < b.a) {
            return true;
        }

        if (a.a > b.a) {
            return false;
        }

        if (a.b < b.b) {
            return true;
        }

        if (a.b > b.b) {
            return false;
        }

        if (a.c < b.c) {
            return true;
        }

        if (a.c > b.c) {
            return false;
        }

        return false;
    }
};

int n, x[MAX_N + INDEX], y[MAX_N + INDEX];
int q;

set<Triangle> goodTriangles;

bool isGoodTriangle(Triangle triangle) {
    Point pa = Point(x[triangle.a], y[triangle.a]), pb = Point(x[triangle.b], y[triangle.b]), pc = Point(x[triangle.c], y[triangle.c]);

    Line la = Line(pb, pc), lb = Line(pa, pc), lc = Line(pa, pb);

    for (int i = 1; i <= n; i++) {
        Point p = Point(x[i], y[i]);

        if (i != triangle.a && i != triangle.b && i != triangle.c) {
//            cerr << triangle.a << ' ' << triangle.b << ' ' << triangle.c << '\n';

//            cerr << la.getSide(pa) << ' ' << la.getSide(p) << '\n';
//            cerr << lb.getSide(pb) << ' ' << lb.getSide(p) << '\n';
//            cerr << lc.getSide(pc) << ' ' << lc.getSide(p) << '\n';

            if (la.getSide(p) == la.getSide(pa) && lb.getSide(p) == lb.getSide(pb) && lc.getSide(p) == lc.getSide(pc)) {
                return false;
            }
        }
    }

    return true;
}

bool getRequest(int a, int b, int c) {
    string res;

    cout << '?' << ' ' << 3 << ' ' << a << ' ' << b << ' ' << c << endl;

    cin >> res;

    if (res == "Yes") {
        return true;
    }

    if (res == "No") {
        return false;
    }
}

void writeAns(int a, int b, int c) {
    cout << '!' << ' ' << 3 << ' ' << a << ' ' << b << ' ' << c << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();

    cin >> n;

    for (int j = 1; j <= n; j++) {
        cin >> x[j] >> y[j];
    }

    for (int i = 1; i <= n; i++) {
        for (int j = i + 1; j <= n; j++) {
            for (int k = j + 1; k <= n; k++) {
                if (isGoodTriangle(Triangle(i, j, k))) {
                    goodTriangles.insert(Triangle(i, j, k));
                }
            }
        }
    }

    cin >> q;

    while (q > 0) {
        for (auto triangle: goodTriangles) {
            if (getRequest(triangle.a, triangle.b, triangle.c)) {
                writeAns(triangle.a, triangle.b, triangle.c);

                break;
            }
        }

        q--;
    }

    return 0;
}
