#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <inttypes.h>
#include <vector>
#include <random>
#include <algorithm>
#include <functional>

using std::vector;

struct point_t {
    int x, y;
} pts[5010];

bool qu(vector<int>::const_iterator first, vector<int>::const_iterator last)
{
    assert(last - first > 2);
    printf("? %d ", (int)(last - first));
    while (first != last)
        printf("%d ", 1 + *first), ++first;
    printf("\n");
    fflush(stdout);
    static char buf[10];
    scanf("%s", buf);
    return buf[0] == 'Y';
}

inline
bool qu(const std::tuple<int, int, int>& arr)
{
    printf("? 3 %d %d %d\n", std::get<0>(arr)+1, std::get<1>(arr)+1, std::get<2>(arr)+1);
    fflush(stdout);
    static char buf[10];
    scanf("%s", buf);
    return buf[0] == 'Y';
}

inline
void put_ans(const std::tuple<int, int, int>& arr)
{
    printf("! 3 %d %d %d\n", std::get<0>(arr)+1, std::get<1>(arr)+1, std::get<2>(arr)+1);
    fflush(stdout);
}

int64_t scal_prod(int x1, int y1, int x2, int y2)
{
    return (int64_t)x1*y2 - (int64_t)x2*y1;
}

int sgn64(int64_t val)
{
    if (val < 0) return -1;
    if (0 < val) return 1;
    return 0;
}

struct check_in_tr {
    int a, b, c;
    check_in_tr(int _a, int _b, int _c) :
        a(_a), b(_b), c(_c) {};
    bool operator()(int p) {
        if (p == a || p == b || p == c)
            return false;
        if (sgn64(scal_prod(pts[a].x - pts[b].x, pts[a].y - pts[b].y, pts[p].x - pts[b].x, pts[p].y - pts[b].y)) !=
            sgn64(scal_prod(pts[p].x - pts[b].x, pts[p].y - pts[b].y, pts[c].x - pts[b].x, pts[c].y - pts[b].y)))
            return false;
        if (sgn64(scal_prod(pts[b].x - pts[c].x, pts[b].y - pts[c].y, pts[p].x - pts[c].x, pts[p].y - pts[c].y)) !=
            sgn64(scal_prod(pts[p].x - pts[c].x, pts[p].y - pts[c].y, pts[a].x - pts[c].x, pts[a].y - pts[c].y)))
            return false;
        return true;
    }
};

struct node {
    int a, b, c;
    int p;
    node *abp, *acp, *bcp;
    node (int _a, int _b, int _c, const vector<int>& in_base) : a(_a), b(_b), c(_c) {
        std::vector<int> in; in.reserve(in_base.size());
        std::copy_if(in_base.begin(), in_base.end(), std::back_inserter(in), check_in_tr(a, b, c));
        if (!in.size()) {
            p = -1;
            abp = acp = bcp = NULL;
            return;
        }

        p = in[rand() % in.size()];
        abp = new node(a, b, p, in);
        acp = new node(a, c, p, in);
        bcp = new node(b, c, p, in);
    }
    std::tuple<int, int, int> qu_find() {
        if (p == -1) return {a, b, c};
        if (qu({a, b, p}))
            return abp->qu_find();
        if (qu({a, c, p}))
            return acp->qu_find();
        return bcp->qu_find();
    }
};

struct points_set {
    vector<int> conv;
    vector<node> nodes;

    points_set(int n) {
        vector<int> base(n);
        std::iota(base.begin(), base.end(), 0);

        conv.reserve(base.size());
        vector<int> in_conv;
        in_conv.reserve(2*n);

        std::sort(base.begin(), base.end(), [](int a, int b) {
                        if (pts[a].x != pts[b].x) return pts[a].x < pts[b].x;
                        if (pts[a].y != pts[b].y) return pts[a].y < pts[b].y;
                        return false;
                  });

        for (int it : base) {
            while (conv.size() > 1 && scal_prod(pts[it].x - pts[conv.back()].x, pts[it].y - pts[conv.back()].y,
                                                pts[conv.back()].x - pts[conv[conv.size()-2]].x, pts[conv.back()].y - pts[conv[conv.size()-2]].y) < 0)
                   in_conv.push_back(conv.back()),
                   conv.pop_back();
            conv.push_back(it);
        }
        base.pop_back();
        std::reverse(base.begin(), base.end());
        for (int it : base) {
            while (conv.size() > 1 && scal_prod(pts[it].x - pts[conv.back()].x, pts[it].y - pts[conv.back()].y,
                                                pts[conv.back()].x - pts[conv[conv.size()-2]].x, pts[conv.back()].y - pts[conv[conv.size()-2]].y) < 0)
                   in_conv.push_back(conv.back()),
                   conv.pop_back();
            conv.push_back(it);
        }
        if (conv.front() == conv.back())
            conv.pop_back();

        std::sort(in_conv.begin(), in_conv.end());
        in_conv.resize(std::unique(in_conv.begin(), in_conv.end()) - in_conv.begin());
        nodes.reserve(conv.size());
        for (int i = 0; i+2 < (int)conv.size(); ++i)
            nodes.emplace_back(conv[0], conv[i+1], conv[i+2], in_conv);
    }

    std::tuple<int, int, int> qu_find() {
        int l = 1, r = conv.size()-1;
        while (r - l > 1) {
            int mid = (l+r+1)/2;
            //printf("(%d, %d], mid = %d\n", l, r, mid);
            if (qu(conv.begin(), conv.begin() + mid+1))
                r = mid;
            else
                l = mid;
        }
        return nodes[r-2].qu_find();
    }
};

int main()
{
    int n; scanf("%d", &n);
    for (int i = 0; i < n; ++i)
        scanf("%d %d", &pts[i].x, &pts[i].y);
    points_set ps(n);
    int q; scanf("%d", &q);
    while (q --> 0) put_ans(ps.qu_find());
    return 0;
}
