#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <inttypes.h>
#include <vector>
#include <random>
#include <algorithm>
#include <functional>

const int N = 1<<20;

char str1[N];
char str2[N];

bool equal_check(int l, int r)
{
    char need = str2[l];
    for (int i = l; i < r; ++i)
        if (str2[i] != need)
            return false;
    return true;
}

void inv_sub_str(int l, int r)
{
    for (int i = l; i < r; ++i)
        str1[i] = "+-"[str1[i] == '+'];
}

bool sub_solve(int sl, int sr)
{
    int p_sz = 0;
    static int p_ls[N];
    static int p_rs[N];
    int m_sz = 0;
    static int m_ls[N];
    static int m_rs[N];

    int l = sl;
    for (int r = sl+1; r < sr; ++r) if (str1[l] != str1[r] ) {
        if (str1[l] == '+') {
            p_ls[p_sz] = l;
            p_rs[p_sz] = r;
            ++p_sz;
        } else {
            m_ls[m_sz] = l;
            m_rs[m_sz] = r;
            ++m_sz;
        }
        l = r;

        while (p_sz > 1 && p_rs[p_sz-2] == p_ls[p_sz-1]) {
            p_sz--;
            p_rs[p_sz-1] = p_rs[p_sz];
        }

        while (p_sz && m_sz && (m_rs[m_sz-1] - m_ls[m_sz-1]) < (p_rs[p_sz-1] - p_ls[p_sz-1])) {
            p_rs[p_sz-1] = std::max(p_rs[p_sz-1], m_rs[m_sz-1]);
            p_ls[p_sz-1] = std::min(p_ls[p_sz-1], m_ls[m_sz-1]);
            m_sz--;

            while (p_sz > 1 && p_rs[p_sz-2] == p_ls[p_sz-1]) {
                p_sz--;
                p_rs[p_sz-1] = p_rs[p_sz];
            }
        }

    }
    if (str1[l] == '+') {
        p_ls[p_sz] = l;
        p_rs[p_sz] = sr;
        ++p_sz;
    } else {
        m_ls[m_sz] = l;
        m_rs[m_sz] = sr;
        ++m_sz;
    }

    while (p_sz > 1 && p_rs[p_sz-2] == p_ls[p_sz-1]) {
        p_sz--;
        p_rs[p_sz-1] = p_rs[p_sz];
    }
    while (p_sz && m_sz && (m_rs[m_sz-1] - m_ls[m_sz-1]) < (p_rs[p_sz-1] - p_ls[p_sz-1])) {
        p_rs[p_sz-1] = std::max(p_rs[p_sz-1], m_rs[m_sz-1]);
        p_ls[p_sz-1] = std::min(p_ls[p_sz-1], m_ls[m_sz-1]);
        m_sz--;

        while (p_sz > 1 && p_rs[p_sz-2] == p_ls[p_sz-1]) {
            p_sz--;
            p_rs[p_sz-1] = p_rs[p_sz];
        }
    }

    return m_sz == 0;
}

bool solve()
{
    scanf("%s%s", str1, str2);
    int n = strlen(str1);
    assert(n == (int)strlen(str2));

    int l = 0;
    for (int r = 1; r <= n; ++r)
        if (str1[l] != str1[r]) {
            if (!equal_check(l, r))
                return false;
            l = r;
        }

    l = 0;
    for (int r = 1; r < n; ++r)
        if (str2[l] != str2[r]) {
            if (str2[l] == '-')
                inv_sub_str(l, r);
            if (!sub_solve(l, r))
                return false;
            r = l;
        }
    return sub_solve(l, n);
}

int main()
{
    int q; scanf("%d", &q);
    while (q --> 0)
        printf(solve() ? "Yes\n" : "No\n");
    return 0;
}
