#include <algorithm>
#include <fstream>
#include <bitset>
#include <set>
#include <map>
#include <string>
#include <cassert>
#include <ctime>
#include <random>

using namespace std;

template<class T> inline void chkmin(T& a, T b) { if (a > b) a = b; }
template<class T> inline void chkmax(T& a, T b) { if (a < b) a = b; }

typedef long long ll;
typedef long double ld;

const string FILENAME = "order";
ifstream cin(FILENAME + ".in");
ofstream cout(FILENAME + ".out");

bool GetBit(int n, int i) {
	return (n >> i) & 1;
}

const int MAXN = 1e6;
const int MAXL = 30;

int isGood[MAXN];
int isCorrectChange[2][MAXN];
int badChangeNum[2][MAXL];
int nums[MAXN];

inline bool IsBad(int i, int l) {
	return (nums[i] >> l + 1) == (nums[i + 1] >> l + 1);
}

int main() {
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i)
		cin >> nums[i];
	for (int i = 0; i < n - 1; ++i) {
		for (int l = 0; l < MAXL; ++l) {
			if (GetBit(nums[i], l) != GetBit(nums[i + 1], l) && IsBad(i, l))
				++badChangeNum[GetBit(nums[i], l)][l];
		}
	}
	int res = 0;
	bool canRock = true;
	for (int l = 0; l < MAXL; ++l) {
		if (badChangeNum[0][l] && badChangeNum[1][l])
			canRock = false;
		if (badChangeNum[1][l])
			res |= 1 << l;
	}
	cout << res << '\n';
	int q;
	cin >> q;
	for (int w = 0; w < q; ++w) {
		int i, val;
		cin >> i >> val;
		--i;
		for (int l = 0; l < MAXL; ++l) {
			if (i && GetBit(nums[i - 1], l) != GetBit(nums[i], l) && IsBad(i - 1, l))
				--badChangeNum[GetBit(nums[i - 1], l)][l];
			if (i < n - 1 && GetBit(nums[i], l) != GetBit(nums[i + 1], l) && IsBad(i, l))
				--badChangeNum[GetBit(nums[i], l)][l];
		}
		nums[i] = val;
		for (int l = 0; l < MAXL; ++l) {
			if (i && GetBit(nums[i - 1], l) != GetBit(nums[i], l) && IsBad(i - 1, l))
				++badChangeNum[GetBit(nums[i - 1], l)][l];
			if (i < n - 1 && GetBit(nums[i], l) != GetBit(nums[i + 1], l) && IsBad(i, l))
				++badChangeNum[GetBit(nums[i], l)][l];
		}
		int res = 0;
		bool canRock = true;
		for (int l = 0; l < MAXL; ++l) {
			if (badChangeNum[0][l] && badChangeNum[1][l])
				canRock = false;
			if (badChangeNum[1][l])
				res |= 1 << l;
		}
		if (canRock)
			cout << res << '\n';
		else
			cout << "-1\n";
	}
}

