#include <cmath>
#include <algorithm>
#include <iostream>
#include <bitset>
#include <set>
#include <map>
#include <string>
#include <cassert>
#include <ctime>
#include <random>

using namespace std;

template<class T> inline void chkmin(T& a, T b) { if (a > b) a = b; }
template<class T> inline void chkmax(T& a, T b) { if (a < b) a = b; }

typedef long long ll;
typedef long double ld;

struct Point {
	ll x, y;

	Point() : x(0), y(0) {}
	Point(ll x, ll y) : x(x), y(y) {}
};

ll operator* (Point a, Point b) {
	return a.x * b.x + a.y * b.y;
}

ll operator% (Point a, Point b) {
	return a.x * b.y - a.y * b.x;
}

bool operator< (Point a, Point b) {
	return make_pair(a.x, a.y) < make_pair(b.x, b.y);
}

Point operator- (Point a, Point b) {
	return Point(a.x - b.x, a.y - b.y);
}

bool operator== (Point a, Point b) {
	return a.x == b.x && a.y == b.y;
}

ostream& operator<< (ostream& fin, Point p) {
	return fin << p.x << ' ' << p.y;
}

istream& operator>> (istream& cin, Point& p) {
	return cin >> p.x >> p.y;
}

vector<Point> pol;

int main() {
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		Point p;
		cin >> p;
		pol.push_back(p);
	}
	int q;
	cin >> q;
	for (int w = 0; w < q; ++w) {
		bool ansd = false;
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < i; ++j) {
				for (int k = 0; k < j; ++k) {
					bool jonnyBeGood = true;
					for (int l = 0; l < n; ++l) {
						if (l == i || l == j || l == k) continue;
						Point a = pol[l] - pol[i];
						Point b = pol[l] - pol[j];
						Point c = pol[l] - pol[k];
						if (abs(atan2(a % b, a * b) + atan2(b % c, b * c) + atan2(c % a, c * a)) > 2) {
							jonnyBeGood = false;
							break;
						}
					}
					if (jonnyBeGood == false) continue;
					cout << "? 3 " << i + 1 << ' ' << j + 1 << ' ' << k + 1 << '\n';
					string res;
					cin >> res;
					if (res == "Yes") {
						cout << "! 3 " << i + 1 << ' ' << j + 1 << ' ' << k + 1 << '\n';
						ansd = true;
						break;
					}
				}
				if (ansd) break;
			}
			if (ansd) break;
		}
		if (ansd) continue;
	}
}