#include <algorithm>
#include <fstream>
#include <cmath>
#include <random>
#include <cassert>
#include <ctime>
#include <set>
#include <map>
#include <bitset>
#include <string>
#include <vector>
#include <utility>

using namespace std;

template<class t> inline void chkmin(t& a, t b) { if (a > b) a = b; }
template<class t> inline void chkmax(t& a, t b) { if (a < b) a = b; }

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> seg;

const string FILENAME = "servers";
ifstream cin(FILENAME + ".in");
ofstream cout(FILENAME + ".out");

const ll INF = 1e18;
const int MAXN = 2e5 + 1;

seg Inter(seg a, seg b) {
	seg res(max(a.first, b.first), min(a.second, b.second));
	if (res.first > res.second) return seg(INF, INF);
	return res;
}

int t[MAXN];
seg bounds[MAXN];
seg leftRes[MAXN];
seg rghtRes[MAXN];

int main() {
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i)
		cin >> t[i];
	for (int i = 0; i < n - 1; ++i)
		cin >> bounds[i].first >> bounds[i].second;
	leftRes[0] = seg(0, INF);
	rghtRes[n - 1] = seg(0, INF);
	for (int i = 1; i < n; ++i) {
		leftRes[i] = Inter(leftRes[i - 1], bounds[i - 1]);
		if (leftRes[i].first == bounds[i - 1].first)
			leftRes[i].first -= t[i];
		chkmax(leftRes[i].first, 0LL);
	}
	for (int i = n - 2; i >= 0; --i) {
		rghtRes[i] = Inter(rghtRes[i + 1], bounds[i]);
		if (rghtRes[i].first == bounds[i].first)
			rghtRes[i].first -= t[i];
		chkmax(rghtRes[i].first, 0LL);
	}
	for (int i = 0; i < n; ++i) {
		seg res = Inter(leftRes[i], rghtRes[i]);
		cout << (res.first >= (INF >> 1) ? -1 : res.first) << '\n';
	}
}

