#include <bits/stdc++.h>


// INT -> LL

using namespace std;

typedef long double ld;

struct point {
    int x, y;
};

struct triangle {
    int a, b, c;
    triangle(int x, int y, int z) : a(x), b(y), c(z) {};
};

ld get_angle(point a, point b, point c) {
    int v1x = a.x - b.x;
    int v1y = a.y - b.y;
    int v2x = c.x - b.x;
    int v2y = c.y - b.y;

    ld v1_len = sqrt(v1x * v1x + v1y * v1y);
    ld v2_len = sqrt(v2x * v2x + v2y * v2y);

    ld mult = v1x * v2x + v1y * v2y;
    mult /= v1_len * v2_len;
    return acos(mult);
}

inline bool ask(triangle t) {
    cout << "? " << t.a + 1 << " " << t.b + 1 << " " << t.c + 1 << endl;
    string res;
    cin >> res;
    return (res[0] == 'Y' || res[0] == 'y');
}

inline void print (triangle t) {
    cout << "! " << t.a + 1 << " " << t.b + 1 << " " << t.c + 1 << endl;
}

int main()
{
    int n, q;
    cin >> n;
    vector< point > points(n);
    for (int i = 0; i < n; ++i) {
        cin >> points[i].x >> points[i].y;
    }
    cin >> q;

    vector< triangle > triangles;

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            for (int k = j + 1; k < n; ++k) {
                bool ok = true;
                for (int other = 0; other < n; ++other) {
                    if (other == i || other == j || other == k) continue;
                    ld sum_angle = get_angle(points[i], points[other], points[j]) + get_angle(points[j], points[other], points[k]) + get_angle(points[k], points[other], points[i]);
                    if (sum_angle > 1.0) {
                        ok = false;
                        break;
                    }
                }
                if (ok) {
                    triangles.push_back(*(new triangle(i, j, k)));
                }
            }
        }
    }

    for (auto t : triangles) {
        cout << t.a << " " << t.b << " " << t.c << endl;
    }


    while (q--) {
        for (auto t : triangles) {
            bool res = ask(t);
            if (res) {
                print(t);
                break;
            }
        }
    }
    return 0;
}
