#include <bits/stdc++.h>



// INT -> LL

using namespace std;

typedef long double ld;
typedef long long ll;

struct point {
    ll x, y;
    point() {};
    point(ll a, ll b) : x(a), y(b) {};
};

struct vec {
    ll x, y;

    vec(ll a, ll b) : x(a), y(b) {};
    vec(point a, point b) : x (b.x - a.x), y(b.y - a.y) {};

    ld get_len() {
        return sqrt(x * x + y * y);
    }
};



vector< point > points;

struct triangle {
    ll a, b, c;
    triangle(ll x, ll y, ll z) : a(x), b(y), c(z) {};
};

ld mult(vec a, vec b) {
    return (1.0 * (a.x * b.y - a.y * b.x)) / (a.get_len() * b.get_len());
}


bool inside(int other, triangle t) {
    point ins = points[other];

    vector< point > pts;
    pts.push_back(points[t.a]);
    pts.push_back(points[t.b]);
    pts.push_back(points[t.c]);
    pts.push_back(points[t.a]);

    int cnt = 0;

    for (int i = 0; i < 3; ++i) {
        point cur = pts[i], next = pts[i + 1];
        if (cur.y < next.y) {
            swap(cur, next);
        }
        if (cur.y > ins.y && next.y > ins.y) {
            continue;
        }
        if (cur.y < ins.y && cur.y < ins.y) {
            continue;
        }

        if (cur.y == ins.y) continue;
        if (next.y == ins.y && next.x >= ins.x) {
            ++cnt;
            continue;
        }

        ld m = mult(*(new vec(next, ins)), *(new vec(next, cur)));

        ld eps = 0.00001;
        if (m < eps) ++cnt;

    }

    return cnt % 2;
}

inline bool ask(triangle t) {
    cout << "? 3 " << t.a + 1 << " " << t.b + 1 << " " << t.c + 1 << endl;
    string res;
    cin >> res;
    return (res[0] == 'Y' || res[0] == 'y');
}

inline void print (triangle t) {
    cout << "! 3 " << t.a + 1 << " " << t.b + 1 << " " << t.c + 1 << endl;
}

int main()
{
    /*
    points.push_back(*(new point(6, 1)));
    points.push_back(*(new point(3, 0)));
    points.push_back(*(new point(0, 2)));
    points.push_back(*(new point(2, 4)));

    cout << inside(0, *(new triangle(1, 2, 3))) << endl;


    */

    int n, q;
    cin >> n;
    points.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> points[i].x >> points[i].y;
    }
    cin >> q;



    vector< triangle > triangles;



    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            for (int k = j + 1; k < n; ++k) {
                bool ok = true;
                for (int other = 0; other < n; ++other) {
                    if (other == i || other == j || other == k) continue;
                    triangle cur_triangle = *(new triangle(i, j, k));
                    if (inside(other, cur_triangle)) {
                        ok = false;
                        break;
                    }
                }
                if (ok) {
                    triangles.push_back(*(new triangle(i, j, k)));
                }
            }
        }
    }

/*
    for (auto t : triangles) {
        cout << t.a << " " << t.b << " " << t.c << endl;
    }
*/

    while (q--) {
        bool printed = false;
        for (auto t : triangles) {
            bool res = ask(t);
            if (res) {
                print(t);
                printed = true;
                break;
            }
        }
    }
    return 0;

}
