#include <algorithm>
#include <iostream>
#include <cstdio>
#include <vector>
#include <cmath>
using namespace std;
#define int long long

struct dot {
	int x, y, id;
	dot (int x = 0, int y = 0) : x(x), y(y) {}
	int operator | (dot A) {
		return ((x - A.x) * (x - A.x) + (y - A.y) * (y - A.y));
	}
};

struct vec {
	int x, y;
	vec (int x = 0, int y = 0) : x(x), y(y) {}
	vec(dot A, dot B) {
		x = B.x - A.x;
		y = B.y - A.y;
	}
	int operator * (vec A) {
		return x * A.x + y * A.y;
	}
	int operator % (vec A) {
		return x * A.y - y * A.x;
	}
};

vec operator >> (dot A, dot B) {
	return vec(A, B);
}

int sgn(int x) {
	if (x == 0)
		return 0;
	if (x < 0)
		return -1;
	return 1;
}

bool inside(dot A, dot B, dot C, dot P) {
	if ((sgn(((A >> C) % (A >> B))) * sgn(((A >> P) % (A >> B)))) <= 0)
		return false;
	return true;
}

bool doins(dot A, dot B, dot C, dot P) {
	return inside(A, B, C, P) && inside(B, C, A, P) && inside(C, A, B, P); 
}

dot read_dot(int i) {
	dot A;
	cin >> A.x >> A.y;
	A.id = i;
	return A;
}
int n;
vector <dot> arr;

vector <vector <dot> > imp;

dot cmp_dot;

bool cmp_hull (dot A, dot B) {
	if (((cmp_dot >> A) % (cmp_dot >> B)) == 0) {
		return (cmp_dot|A) < (cmp_dot|B);
	}
	return (((cmp_dot >> A) % (cmp_dot >> B)) > 0);
}

bool cmp(dot A, dot B) {
	return (A.y < B.y || (A.y == B.y && A.x < B.x));
}

void sol() {
	for (auto x : imp) {
		cout << "? 3 " << x[0].id << " " << x[1].id << " " << x[2].id << endl;
		string resp;
		cin >> resp;
		if (resp == "Yes") {
			cout << "! 3 " << x[0].id << " " << x[1].id << " " << x[2].id << endl;
			return;
		}
	}
}


signed main() {
	cin >> n;
	arr.resize(n);
	for (int i = 0; i < n; i++) {
		arr[i] = read_dot(i + 1);
	}
	int q;
	cin >> q;

	cmp_dot = *min_element(arr.begin(), arr.end(), cmp);
	sort(arr.begin(), arr.end(), cmp_hull);
	for (int i = 1; i < n - 1; i++) {
		imp.push_back(vector <dot> ({arr[0], arr[i], arr[i + 1]}));
	}
	for (int i = 2; i < n - 1; i++) {
		if (((arr[i - 1] >> arr[i]) % (arr[i] >> arr[i + 1])) < 0) {
			imp.push_back(vector <dot> ({arr[i - 1], arr[i], arr[i + 1]}));
		}
	}


	for (int i = 0; i < q; i++) {
		sol();
	}
	return 0;
}