#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <queue>
using namespace std;
#define rep(i, n) for (int i = 0; i < n; i++)
#define repp(i, a, b) for (int i = a; i < b; i++)
#define all(v) v.begin(), v.end()
typedef long long ll;
typedef pair<int, int> pii;
vector<int> p, len, l, r;
int find(int a) {
	if (a == p[a]) return a;
	return p[a] = find(p[a]);
}
void unite(int a, int b) {
	a = find(a);
	b = find(b);
	if (a == b) return;
	if (len[a] < len[b]) swap(a, b);
	p[b] = a;
	len[a] += len[b];
	r[a] = max(r[a], r[b]);
	l[a] = min(l[a], l[b]);
}
int main() {
	ios_base::sync_with_stdio(0);
	int n;
	cin >> n;
	while (n--) {
		string s1, s2;
		cin >> s1 >> s2;
		int m = s1.size();
		p.resize(m);
		l.resize(m);
		r.resize(m);
		len.resize(m);
		vector<int> k(m);
		vector<bool> must(m);
		rep(i, m) {
			p[i] = i;
			r[i] = i + 1;
			l[i] = i - 1;
			len[i] = 1;
		}
		rep(i, m - 1) {
			if (s1[i] == s1[i + 1]) unite(i, i + 1);
		}
		rep(i, m) if (s1[i] != s2[i]) {
			int a = find(i);
			k[a]++;
		}
		bool ans = 1;
		queue<int> can;
		vector<bool> inv(m);
		rep(i, m) {
			if (k[i] == 0) continue;
			if (k[i] != len[i]) {
				ans = 0;
				break;
			}
			must[i] = 1;
			int a = (l[i] == -1 ? -1 : find(l[i]));
			int b = (r[i] == m ? m : find(r[i]));
			if (a != -1 && must[a]) {
				ans = 0;
				break;
			}
			if (a == -1 && b == m) {
				ans = 0;
				break;
			}
			if (a == -1) {
				if (len[b] > len[i]) {
					can.push(i);
					inv[i] = 1;
				}
			}
			else if (b == m) {
				if (len[a] > len[i]) {
					can.push(i);
					inv[i] = 1;
				}
			}
			else if (len[a] > len[i] || len[b] > len[i]) {
				can.push(i);
				inv[i] = 1;
			}
		}
		if (!ans) {
			cout << "No\n";
			continue;
		}
		while (!can.empty()) {
			int cur = can.front();
			can.pop();
			int a = (l[cur] == -1 ? -1 : find(l[cur]));
			int b = (r[cur] == m ? m : find(r[cur]));
			if (a != -1) unite(a, cur);
			if (b != m) unite(b, cur);
			cur = find(cur);
			int lc = (l[cur] == -1 ? -1 : find(l[cur]));
			int rc = (r[cur] == m ? m : find(r[cur]));
			if (lc != -1 && must[lc] && !inv[lc]
				&& len[lc] < len[cur]) {
				can.push(lc);
				inv[lc] = 1;
			}
			if (rc != m && must[rc] && !inv[rc]
				&& len[rc] < len[cur]) {
				can.push(rc);
				inv[rc] = 1;
			}
		}
		rep(i, m) {
			int q = find(i);
			if (must[q] && !inv[q]) {
				ans = 0;
				break;
			}
		}
		if (ans) cout << "Yes\n";
		else cout << "No\n";
	}
}