#include <iostream>
#include <list>
#include <set>

using namespace std;

int main()
{
    int n, m;
    cin >> n >> m;
    list<pair<int, int> > roads[n];
    for(int i = 0; i < m; i++)
    {
        int s;
        cin >> s;
        if(s != 1)
            return 1;
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        c--;
        roads[a].push_back(make_pair(c, b));
        roads[c].push_back(make_pair(a, b));
    }
    pair<long double, long double> dists[n];
    for(int i = 0; i < n; i++)
        dists[i].first = dists[i].second = 1. / 0;
    dists[0].first = dists[0].second = 0;
    set<pair<pair<long double, long double>, int> > dijkstra;
    dijkstra.insert(make_pair(make_pair(0.L, 0.L), 0));
    while(!dijkstra.empty())
    {
        pair<pair<long double, long double>, int> data = *dijkstra.begin();
        dijkstra.erase(dijkstra.begin());
        for(list<pair<int, int> >::iterator iter = roads[data.second].begin(); iter != roads[data.second].end(); ++iter)
        { 
            pair<long double, long double> new_path_length;
            new_path_length.first = data.first.first + iter->second;
            new_path_length.second = data.first.second - iter->second * iter->second;
            if(new_path_length < dists[iter->first])
            {
                dists[iter->first] = new_path_length;
                dijkstra.insert(make_pair(new_path_length, iter->first));
            }
        }
    }
    cout << dists[n - 1].first << ' ' << -dists[n - 1].second << endl;
    return 0;
}
