#include <iostream>
#include <vector>
#include <string>

using namespace std;

struct Elem
{
	int cnt;
	bool sign;
	Elem *prev, *next;

	Elem(int _cnt = 0, bool _sign = false, Elem *_prev = 0, Elem *_next = 0) : cnt(_cnt), sign(_sign), prev(_prev), next(_next) {}
};

struct List
{
	Elem *root, *end;

	List() : root(new Elem), end(root) {}

	void push(int cnt, bool sign, Elem *prev = 0)
	{
		if (prev == 0)
		{
			Elem *nw = new Elem(cnt, sign, end);
			end->next = nw;
			end = nw;
		}
		else
		{
			Elem *nw = new Elem(cnt, sign, prev, prev->next);
			prev->next->prev = nw;
			prev->next = nw;
		}
	}

	void pop(Elem *elem)
	{
		elem->prev->next = elem->next;
		if (elem->next != 0)
			elem->next->prev = elem->prev;
		delete elem;
	}
};

int main()
{
	int q;
	cin >> q;
	for (; q > 0; --q)
	{
		string s, t;
		cin >> s >> t;
		List comp;
		for (int i = 0; i < s.size();)
		{
			int j;
			for (j = i + 1; j < s.size() && s[j] == s[i]; ++j) {}
			comp.push(j - i, s[i] == '+');
			i = j;
		}
		bool flag = true;
		while (true)
		{
			bool flag2 = true;
			for (Elem *it = comp.root->next; it != 0; it = it->next)
			{
				if (!it->sign)
				{
					if (it != comp.root->next && it->prev->cnt > it->cnt)
					{
						flag2 = false;
						int cnt = it->cnt;
						if (it != comp.end)
						{
							cnt += it->next->cnt;
							comp.pop(it->next);
						}
						it->prev->cnt += cnt;
						comp.pop(it);
						break;
					}
					else if (it != comp.end && it->next->cnt > it->cnt)
					{
						flag2 = false;
						int cnt = it->cnt;
						if (it != comp.root->next)
						{
							cnt += it->prev->cnt;
							comp.pop(it->prev);
						}
						it->next->cnt += cnt;
						comp.pop(it);
						break;
					}
					flag = false;
					break;
				}
			}
			if (!flag || flag2)
				break;
		}
		if (flag)
			cout << "Yes\n";
		else
			cout << "No\n";
	}
    return 0;
}

