#include <iostream>
#include <cstring>
#include <cmath>
#include <iomanip>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

const int N = 2e6;

struct pt
{
    int x, y, ind;
};

int x[N], y[N];

vector <pt> xr, yr;

bool cmp(pt a, pt b)
{
    return (a.x < b.x) || (a.x == b.x && a.y < b.y);
}

bool cmp1(pt a, pt b)
{
    return (a.y < b.y) || (a.y == b.y && a.x < b.x);
}

bool cc(pt a, pt b, pt c)
{
    int aa = b.y - a.y;
    int bb = a.x - b.x;
    int cc = -aa * a.x - bb * a.y;
    return aa * c.x + bb * c.y + cc <= 0;
}

bool cc1(pt a, pt b, pt c)
{
    int aa = b.y - a.y;
    int bb = a.x - b.x;
    int cc = -aa * a.x - bb * a.y;
    return aa * c.x + bb * c.y + cc >= 0;
}

bool prove(int l, int m)
{

    if (m - l + 1 < 3)
        return 0;

    vector <int> ar;
    vector <pt> st0, st1;

    st0.push_back(xr[l]);
    st1.push_back(xr[l]);

    for (int i = l + 1; i <= m; i++)
    {
        while (st0.size() > 1 && cc(st0[st0.size() - 2], st0[st0.size() - 1], xr[i]))
            st0.pop_back();
        st0.push_back(xr[i]);
        while (st1.size() > 1 && cc1(st1[st1.size() - 2], st1[st1.size() - 1], xr[i]))
            st1.pop_back();
        st1.push_back(xr[i]);
    }

    for (int i = 0; i < st0.size(); i++)
        ar.push_back(st0[i].ind);
    for (int i = st1.size() - 2; i > 0; i--)
        ar.push_back(st1[i].ind);
    if (ar.size() < 3)
        return 0;
    cout << "? " << ar.size() << ' ';
    for (int i = 0; i < ar.size(); i++)
        cout << ar[i] + 1 << ' ';
    cout << endl;
    string pp;
    cin >> pp;
    if (pp == "Yes")
        return 1;
    else
        return 0;
}



bool prove1(int l, int m)
{

    if (m - l + 1 < 3)
        return 0;

    vector <int> ar;
    vector <pt> st0, st1;

    vector <pt> xx;

    for (int i = l; i <= m; i++)
        xx.push_back(yr[i]);

    sort(xx.begin(), xx.end(), cmp);

    st0.push_back(xx[l]);
    st1.push_back(xx[l]);

    for (int i = l + 1; i <= m; i++)
    {
        while (st0.size() > 1 && cc(st0[st0.size() - 2], st0[st0.size() - 1], xx[i]))
            st0.pop_back();
        st0.push_back(xx[i]);
        while (st1.size() > 1 && cc1(st1[st1.size() - 2], st1[st1.size() - 1], xx[i]))
            st1.pop_back();
        st1.push_back(xx[i]);
    }

    for (int i = 0; i < st0.size(); i++)
        ar.push_back(st0[i].ind);
    for (int i = st1.size() - 2; i > 0; i--)
        ar.push_back(st1[i].ind);
    if (ar.size() < 3)
        return 0;
    cout << "? " << ar.size() << ' ';
    for (int i = 0; i < ar.size(); i++)
        cout << ar[i] + 1 << ' ';
    cout << endl;
    string pp;
    cin >> pp;
    if (pp == "Yes")
        return 1;
    else
        return 0;
}

void check(int l, int m)
{
    vector <int> ar;
    vector <pt> st0, st1;

    vector <pt> xx;

    for (int i = l; i <= m; i++)
        xx.push_back(yr[i]);

    sort(xx.begin(), xx.end(), cmp);

     int n = xx.size();

    int f = 0;
    for (int i = 0; i < n; i++)
    {
        for (int j = i + 1; j < n; j++)
        {
            for (int k = j + 1; k < n; k++)
            {

                int ff =0;
                for (int f = 0; f < n; f++)
                {
                    if (f != i && f != j && f != k)
                        if ((cc(xx[i], xx[j], xx[f]) && cc(xx[j], xx[k], xx[f]) && cc(xx[k], xx[i], xx[f])) || (!cc(xx[i], xx[j], xx[f]) && !cc(xx[j], xx[k], xx[f]) && !cc(xx[k], xx[i], xx[f])))
                        {
                            ff = 1;
                            break;
                        }
                }
                if (!ff && !f)
                {
                        cout << "? " << 3 << ' ' <<  xx[i].ind + 1 << ' ' << xx[j].ind + 1 << ' ' << xx[k].ind + 1 << endl;
                        string p;
                        cin >> p;
                        if (p == "Yes")
                        {
                            f = 1;
                            cout << "! " << 3 << ' ' << xx[i].ind + 1 << ' ' << xx[j].ind + 1 << ' ' << xx[k].ind + 1 << endl;
                        }
                }
            }
        }
    }
}

int main()
{
    ll n, m;
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        cin >> x[i] >> y[i];
        pt e;
        e.x = x[i];
        e.y = y[i];
        e.ind = i;
        xr.push_back(e);
    }
    sort(xr.begin(), xr.end(), cmp);

    int q;
    cin >> q;
    for (int k = 0; k < q; k++)
    {

        yr.clear();

        int l = -1, r = n - 1;
        while (l + 1 < r)
        {
            int m = (l + r) / 2;
            if (prove(0, m))
                r = m;
            else
                l = m;
        }
        int pr = r;

        while (pr < n && xr[pr + 1].x == xr[pr].x)
            pr++;
        l = 0, r = n;
        while (l + 1 < r)
        {
            int m = (l + r) / 2;
            if (prove(m, pr))
                l = m;
            else
                r = m;
        }

        int lr = l;
        while (lr > 0 && xr[lr - 1].x == xr[lr].x)
            lr--;

        for (int i = lr; i <= pr; i++)
            yr.push_back(xr[i]);
        sort(yr.begin(), yr.end(), cmp1);

        l = -1, r = n - 1;
        while (l + 1 < r)
        {
            int m = (l + r) / 2;
            if (prove1(0, m))
                r = m;
            else
                l = m;
        }
        pr = r;

        while (pr < yr.size() && yr[pr + 1].y == yr[pr].y)
            pr++;

        l = 0, r = n;
        while (l + 1 < r)
        {
            int m = (l + r) / 2;
            if (prove1(m, pr))
                l = m;
            else
                r = m;
        }

        lr = l;

        while (lr > 0 && xr[lr - 1].y == xr[lr].y)
            lr--;

        check(lr, pr);
    }
    return 0;
}
