// ConsoleApplication1.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <unordered_map>
#include <cassert>

using namespace std;
#define int long long
#define pi pair<int, int>

pair<int, int> intersect_segs(pi a, pi b) {
	return{ max(a.first, b.first), min(a.second, b.second) };
}

int main()
{

	int n;
	cin >> n;

	vector<int> time(n);

	for (int i = 0; i < n; i++) 
		cin >> time[i];

	vector<pair<int, int>> segs(n - 1);
	for (int i = 0; i < n - 1; i++) {
		int a, b;
		cin >> a >> b;
		segs[i] = { a , b };
	}

	vector<pi> precount_l;
	precount_l.push_back({-2000000000000LL, 2000000000000LL });

	for (int i = 1; i < n; i++) {
		auto cur = intersect_segs(precount_l[i - 1], segs[i - 1]);

		if (cur.first > cur.second) {
			for (int j = i; j < n; j++) {
				precount_l.push_back({ -1, -1 });
			}
			break;
		}

		cur.first -= time[i];

		cur = intersect_segs(cur, precount_l[i - 1]);

		if (cur.first > cur.second) {
			for (int j = i; j < n; j++) {
				precount_l.push_back({ -1, -1 });
			}
			break;
		}

		precount_l.push_back(cur);
	}

	vector<pi> precount_r(n);
	precount_r[n - 1] = { -2000000000000LL, 2000000000000LL };
	for (int i = n - 2; i >= 0; i--) {
		auto cur = intersect_segs(precount_r[i + 1], segs[i]);

		if (cur.first > cur.second) {
			for (int j = i; j >= 0; j--) {
				precount_r[j] = { -1, -1 };
			}
			break;
		}

		cur.first -= time[i];
		cur = intersect_segs(cur, precount_r[i + 1]);

		if (cur.first > cur.second) {
			for (int j = i; j >= 0; j--) {
				precount_r[j] = { -1, -1 };
			}
			break;
		}

		precount_r[i] = cur;
	}


	for (int i = 0; i < n; i++) {
		auto l = precount_l[i];
		auto r = precount_r[i];

		//cout << l.first << ' ' << l.second << ' ' << r.first << ' ' << r.second << endl;

		auto in = intersect_segs(l, r);

		if (l.first == -1 || r.first == -1)
			cout << -1 << endl;
		else
			cout << max(0LL, in.first) << endl;
		
	}

	return 0;
}

