#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::abs;
using std::min;
using std::max;
using std::swap;
using std::pair;
using std::vector;
using std::set;
using std::map;
using std::string;
using std::bitset;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define ff first
#define ss second
#define pb emplace_back
#ifdef LOCAL
#define dbg(as...) {\
	string _cur, _loc;\
	std::stringstream _ss(#as);\
	vector<string> _v;\
	while (getline(_ss,_cur, ',')) {\
		while (count(_cur.begin(), _cur.end(), '(') != count(_cur.begin(), _cur.end(), ')')) {\
			getline(_ss, _loc, ',');\
			_cur += ',' + _loc;\
		}\
		_v.pb(_cur);\
	}\
	err(_v.begin(), as);\
}
#else
#define dbg(as...) {}
#endif

template<typename T> void err(vector<string>::iterator it, T a) {
	cerr << *it << " = " << a << '\n';
}

template <typename T, typename...Ts>
void err(vector<string>::iterator it, T a, Ts...as) {
	cerr << *it << " = " << a << ',';
	err(++it, as...);
}

struct init{
	init() {
		std::iostream::sync_with_stdio(0);
		cin.tie(0);
		cout << std::fixed << std::setprecision(10);
		cerr << std::fixed << std::setprecision(3);
	}
} init;

const int MAXN = 2e5 + 25, INF = 1e9 + 7, MAXT = 5000;
// #define int ll
int c[MAXN];
int l[MAXN], r[MAXN];

int pl[MAXN], pr[MAXN], nl[MAXN], nr[MAXN];

int32_t main() {
	int n;
	cin >> n;
	for (int i = 1; i <= n; ++i) {
		cin >> c[i];
	}
	for (int i = 2; i <= n; ++i) 
		cin >> l[i] >> r[i];

	pl[0] = 0;
	pr[0] = +INF;
	pl[1] = 0;
	pr[1] = +INF;

	for (int i = 2; i <= n; ++i) {
		int cl = l[i] - c[i];
		int cr = r[i] - c[i];
		pl[i] = max(pl[i - 1], cl);
		pr[i] = min(pr[i - 1], cr);
	}	

	nl[n] = 0;
	nr[n] = +INF;
	nl[n + 1] = 0;
	nr[n + 1] = +INF;

	l[1] = 0;
	r[1] = INF;

	l[n + 1] = 0;
	r[n + 1] = INF;

	for (int i = n - 1; i >= 1; --i) {
		int cl = l[i + 1] - c[i];
		int cr = r[i + 1] - c[i];
		nl[i] = max(nl[i + 1], cl);
		nr[i] = min(nr[i + 1], cr);
	}

	for (int i = 1; i <= n; ++i) {
		int goleftl = max(l[i], pl[i - 1]);
		int goleftr = min(r[i], pr[i - 1]);
		int gorightl = max(l[i + 1], nl[i + 1]);
		int gorightr = min(r[i + 1], nr[i + 1]);
		dbg(i, goleftl, goleftr, gorightl, gorightr);
		if (goleftl > goleftr) {
			cout << "-1\n";
			continue;
		}
		if (gorightl > gorightr) {
			cout << "-1\n";
			continue;
		}
		int tm = 0;
		for (; tm <= MAXT; ++tm) {
			bool ok = true;
			if (l[i] <= tm && tm <= r[i])
				ok &= goleftl <= tm && tm <= goleftr;
			else if (l[i] > tm && l[i] <= tm + c[i])
				ok &= goleftl <= l[i] && l[i] <= goleftr;
			else 
				ok = 0;
			dbg(tm, ok);
			if (l[i + 1] <= tm && tm <= r[i + 1])
				ok &= gorightl <= tm && tm <= gorightr;
			else if (l[i + 1] > tm && l[i + 1] <= tm + c[i])
				ok &= gorightl <= l[i + 1] && l[i + 1] <= gorightr;
			else 
				ok = 0;
			// dbg((l[i + 1] <= tm && r[i + 1] <= tm && gorightl <= tm && tm <= gorightr));
			// dbg((l[i + 1] > tm && l[i + 1] <= tm + c[i] && gorightl <= l[i + 1] && l[i + 1] <= gorightr));
			if (ok) {
				cout << tm << '\n';
				break;
			}
		}
		if (tm > MAXT)
			cout << "-1\n";
	}

	return 0;
}