#include <iostream>
#include <vector>
#include <fstream>
#include <algorithm>

using namespace std;

const long long num = 1000000000;
const long long max_num = 1000000000000000000;

struct elem {
    int left, right, cost;
};

struct point {
    int left, right;
    pair <long long, int> num;
};

pair <long long, int> ask(point *st, int u, int left, int right) {
    pair <long long, int> res1, res2;
    if (right < left) {
        return make_pair(max_num, -1);
    }
    else if (st[u].left == left && st[u].right == right) {
        return st[u].num;
    }
    else {
        res1 = ask(st, u * 2, left, min(right, st[u * 2].right));
        res2 = ask(st, u * 2 + 1, max(left, st[u * 2 + 1].left), right);
        if (res1.first < res2.first) {
            return res1;
        }
        else {
            return res2;
        }
    }
}

void change(point *st, int u, int id, long long num) {
    if (st[u].left == st[u].right) {
        st[u].num = make_pair(num, id);
    }
    else {
        if (id <= st[u * 2].right) {
            change(st, u * 2, id, num);
        }
        else {
            change(st, u * 2 + 1, id, num);
        }
        st[u].num = min(st[u * 2].num, st[u * 2 + 1].num);
    }
}

int main() {
    ifstream fin;
    fin.open("anti.in");
    ofstream fout;
    fout.open("anti.out");
    int n, a, len, id;
    long long minimum;
    pair <long long, int> tmp;
    fin >> n >> a;
    vector <elem> variants(n);
    for (int i = 0; i < n; i++) {
        fin >> variants[i].left >> variants[i].right >> variants[i].cost;
    }
    len = 1;
    while (len < a + 1) {
        len *= 2;
    }
    point st[len * 2];
    for (int i = 0; i < len; i++) {
        st[i + len].left = i;
        st[i + len].right = i;
    }
    for (int i = 0; i <= a; i++) {
        st[i + len].num = make_pair(num * i, i);
    }
    for (int i = len + a + 1; i < len * 2; i++) {
        st[i].num = make_pair(max_num, i - len);
    }
    for (int i = len - 1; i > 0; i--) {
        st[i].left = st[i * 2].left;
        st[i].right = st[i * 2 + 1].right;
        st[i].num = min(st[i * 2].num, st[i * 2 + 1].num);
    }
/*
    for (int i = 1; i < 2 * len; i++) {
        cout << "i: " << st[i].left << ' ' << st[i].right << ' ' << st[i].num.first << ' ' << st[i].num.second << '\n';
    }
*/
    long long dp[a + 1];
    dp[a] = 0;
    for (int i = a - 1; i >= 0; i--) {
        dp[i] = 0;
        for (int j = 0; j < n; j++) {
            if (i + variants[j].right <= a) {
                tmp = ask(st, 1, i + variants[j].left, i + variants[j].right);
                id = tmp.second;
                minimum = dp[id] + num * (id - i) - variants[j].cost;
                if (minimum > dp[i]) {
                    dp[i] = minimum;
                }
            }
        }
        change(st, 1, i, dp[i] + num * i);
    }
/*
    for (int i = 0; i <= a; i++) {
        cout << dp[i] << ' ';
    }
    cout << '\n';
    for (int i = 1; i < 2 * len; i++) {
        cout << "i: " << st[i].left << ' ' << st[i].right << ' ' << st[i].num.first << ' ' << st[i].num.second << '\n';
    }
*/
    fout << dp[0] << '\n';
    fin.close();
    fout.close();
    return 0;
}
