#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:512000000")

#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cassert>

using namespace std;

typedef long long ll;
typedef double ld;

#define forn(i, n) for(int i = 0; i < (int)(n); i++)
#define for1(i, n) for(int i = 1; i <=(int)(n); i++)

void solve();

int main() {
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
	return 0;
}

const int MAXN = 2507;

struct vt {
	ll x, y; int num;

	ll operator ^(const vt &v) const{
		return x * v.y - y * v.x;
	}

	vt operator -(const vt &v) const {
		return{ x - v.x, y - v.y };
	}

	ll len() {
		return x * x + y * y;
	}
} a[MAXN], v0;

int n, q;

void print(vector<vt> v) {
	cout << "! " << v.size() << ' ';
	for (vt p : v) cout << p.num << ' ';
	cout << endl;
}

bool ask(vector<vt> v) {
	cout << "? " << v.size() << ' ';
	for (auto p : v) cout << p.x << ' ';
	cout << endl;
	string tmp;
	cin >> tmp;
	return tmp == "Yes";
}

bool inside(vt cur_p, vt p1, vt p2, vt p3) {
	vt v1 = p1 - cur_p;
	vt v2 = p2 - cur_p;
	vt v3 = p3 - cur_p;

	ll s1 = abs(v1 ^ v2) + abs(v2 ^ v3) + abs(v3 ^ v1);

	ll s2 = abs((p2 - p1) ^ (p3 - p1));

	return s1 == s2;
}

bool cmp(vt &v1, vt &v2) {
	vt dv1 = v1 - v0, dv2 = v2 - v0;
	ll p = dv1 ^ dv2;
	if (p == 0) {
		return dv1.len() < dv2.len();
	}
	return p > 0;
}

vector<vt> convex(vector<vt> v){
	forn(i, v.size()) {
		if (v[i].x < v[0].x || (v[i].x == v[0].x && v[i].y < v[0].y)) {
			swap(v[i], v[0]);
		}
	}
	v0 = v[0];
	sort(v.begin() + 1, v.end(), cmp);

	vector<vt> stck = { v0 };
	for (int i = 1; i < (int)v.size(); i++) {
		while (stck.size() >= 2) {
			vt last = stck.back();
			vt prev = stck[(int)stck.size() - 2];
			if (((last - prev) ^ (v[i] - last)) < 0) {
				stck.pop_back();
			}
			else {
				break;
			}
		}
		stck.push_back(v[i]);
	}
	return stck;
}

bool cmpx(const vt &v1, const vt &v2) {
	return v1.x < v2.x;
}

void guess(vector<vt> v) {
	if (v.size() == 3) {
		print(v);
		return;
	}

	sort(v.begin(), v.end(), cmpx);

	vt div = v[v.size() / 2];

	vector<vt> l_half, r_half;
	for (auto p : v) {
		if (p.x <= div.x) {
			l_half.push_back(p);
		}
		if (p.x >= div.x) {
			r_half.push_back(p);
		}
	}

	vector<vt> l_conv = convex(l_half);
	vector<vt> r_conv = convex(r_half);
	vector<vt> all_conv = convex(v);

	if (ask(l_conv)) {
		guess(l_half);
		return;
	}
	if (ask(r_conv)) {
		guess(r_half);
		return;
	}

	vector<vector<vt> > buf;

	forn(i, all_conv.size()) {
		int ni = (i + 1) % all_conv.size();
		int minx = min(all_conv[i].x, all_conv[ni].x);
		int maxx = max(all_conv[i].x, all_conv[ni].x);

		if (minx <= div.x && div.x <= maxx) {
			buf.push_back({ all_conv[i], all_conv[ni] });
		}
	}
	for (auto tuple : buf) {
		vector<vt> tmp;
		for (auto curp : v) {
			if (inside(curp, div, tuple[0], tuple[1])) {
				tmp.push_back(curp);
			}
		}
		vector<vt> tmp_conv = convex(tmp);

		if (ask(tmp_conv)) {
			guess(tmp);
			return;
		}
	}
}

void solve() {
	vector<vt> everything;
	scanf("%d", &n);
	forn(i, n) {
		scanf("%lld%lld", &a[i].x, &a[i].y);
		a[i].num = i + 1;
		everything.push_back(a[i]);
	}

	scanf("%d", &q);
	forn(_, q) {
		guess(everything);
	}
}