#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>
using namespace std;

const int len = 1000 * 1000;
int x;
int a[len];

int t[31][len * 2];
int c01[31], c10[31], bad[31], c0[31], c1[31];

void build(int i, int v, int l, int r, int *a) {
	if (l == r - 1) {
		t[i][v] = ((a[l]) >> i) & 1;
		return;
	}
	int m = l + r >> 1;
	build(i, v * 2 + 1, l, m, a);
	build(i, v * 2 + 2, m, r, a);
	t[i][v] = t[i][2 * v + 1] + t[i][2 * v + 2];
}

void st(int i, int v, int l, int r, int pos, int value) {
	if (l == r - 1) {
		t[i][v] = value;
		return;
	}
	int m = l + r >> 1;
	if (pos < m)
		st(i, 2 * v + 1, l, m, pos, value);
	else
		st(i, 2 * v + 2, m, r, pos, value);
	t[i][v] = t[i][2 * v + 1] + t[i][2 * v + 2];
}

int gs(int i, int v, int l, int r, int from, int to) {
	if (from <= l && r <= to)
		return t[i][v];
	if (from >= r || to <= l)
		return 0;
	int m = l + r >> 1;
	return gs(i, 2 * v + 1, l, m, from, to) + gs(i, 2 * v + 2, m, r, from, to);
}

int solve() {
	int ans = 0;
	for (int i = 0; i < 31; i++) {
		if (c01[i] != 0 && c10[i] != 0)
			return -1;
		if (bad[i] != 0)
			return -1;
		if (c10[i] != 0)
			ans += 1 << i - 1;
	}
	return ans;
}

void run(int i, int l, int r) {
	if (l >= r) {
		exit(1);
		return;
	}
	if (i <= 0)
		return;
	int sum = gs(i - 1, 0, 0, x, l, r);
	if (sum == 0) {
		c0[i]++;
		run(i - 1, l, r);
		return;
	}
	if (sum == r - l) {
		c1[i]++;
		run(i - 1, l, r);
		return;
	}
	if (gs(i - 1, 0, 0, x, l, l + sum) == sum) {
		c10[i]++;
		if (r - l >= 1) {
			run(i - 1, l, l + sum);
			run(i - 1, l + sum, r);
		}
	}
	else if(gs(i - 1, 0, 0, x, r - sum, r) == sum) {
		c01[i]++;
		if (r - l >= 1) {
			run(i - 1, l, r - sum);
			run(i - 1, r - sum, r);
		}
	}
	else { 
		bad[i]++;
	}
}

int bi = -1, bl, br;

void rp(int i, int l, int r, int pos, int v) {
	if (pos < l || pos >= r)
		return;
	if (l >= r)
		return;
	if (i <= 0)
		return;
	int sum = gs(i - 1, 0, 0, x, l, r);
	if (sum == 0) {
		c0[i] += v;
		rp(i - 1, l, r, pos, v);
		return;
	}
	if (sum == r - l) {
		c1[i] += v;
		rp(i - 1, l, r, pos, v);
		return;
	}
	if (gs(i - 1, 0, 0, x, l, l + sum) == sum) {
		c10[i] += v;
		if (r - l >= 1) {
			rp(i - 1, l, l + sum, pos, v);
			rp(i - 1, l + sum, r, pos, v);
		}
	}
	else if (gs(i - 1, 0, 0, x, r - sum, r) == sum) {
		c01[i] += v;
		if (r - l >= 1) {
			rp(i - 1, l, r - sum, pos, v);
			rp(i - 1, r - sum, r, pos, v);
		}
	}
	else {
		if (bi != -1)
			exit(1);
		bi = i;
		bl = l;
		br = r;
		bad[i] += v;
	}
}

void process(int pos, int value) {
	bi = -1;
	rp(30, 0, x, pos, -1);
	// (int i = 0; i <= 30; i++)
	//	bad[i] = c01[i] = c10[i] = c1[i] = c0[i] = 0;
	for (int i = 29; i >= 0; i--) {
		st(i, 0, 0, x, pos, (value >> i) & 1);
	}
	if(bi != -1)
		run(bi, bl, br);
	//run(30, 0, x);
	rp(30, 0, x, pos, 1);
}

int main() {
	freopen("order.in", "r", stdin);
	freopen("order.out", "w", stdout);
	cin >> x;
	for (int i = 0; i < x; i++)
		cin >> a[i];
	for (int i = 0; i < 30; i++)
		build(i, 0, 0, x, a);

	run(30, 0, x);
	cout << solve() << endl;
	int q;
	cin >> q;
	while (q--) {
		int pos, v;
		cin >> pos >> v;
		process(--pos, v);
		cout << solve() << endl;
	}
}