#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 2517;
int n;

struct point {
    int x, y;

    point(int x, int y) :
        x(x),
        y(y)
    {}
};

bool operator == (point A, point B) {
    return (A.x == B.x && A.y == B.y);
}

vector<point> a;

struct line {
    int a, b, c; /// xa + yb + c

    line (point p1, point p2) :
        a(p2.y - p1.y),
        b(p1.x - p2.x),
        c(p2.x * p1.y - p1.x * p2.y)
    {}

    int sign(point p) {
        long long tmp = 1LL * a * p.x + 1LL * b * p.y + c;
        if (tmp > 0) return 1;
        else if (tmp == 0) return 0;
        else return -1;
    }
};

struct triangle {
    point A, B, C;

    triangle (point A, point B, point C) :
        A(A),
        B(B),
        C(C)
    {}

    bool check() {
        bool ok = true;
        line l1(A, B);
        line l2(A, C);
        line l3(B, C);
        for (int i = 0; i < n; ++i) {
            if (a[i] == A || a[i] == B || a[i] == C) continue;
            if (l1.sign(a[i]) == l1.sign(C) && (l2.sign(a[i]) == l2.sign(B)) && (l3.sign(a[i]) == l3.sign(A))) {
                ok = false;
                break;
            }
        }
        return ok;
    }

};

void f() {
    fflush(stdout);
}

void query(int a1, int a2, int a3) {
    cout << "? 3 " << a1 + 1 << ' ' << a2 + 1 << ' ' << a3 + 1 << endl;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(nullptr);

    cin >> n;
    for (int i = 0; i < n; ++i) {
        //cin >> a[i].x >> a[i].y;
        int xx, yy; cin >> xx >> yy;
        a.push_back(point(xx, yy));
    }

    int q; cin >> q;
    while (q--) {
        bool go = false;
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                for (int k = j + 1; k < n; ++k) {
                    triangle t(a[i], a[j], a[k]);
                    if (!t.check()) continue;
                    query(i, j, k);
                    string ans; cin >> ans;
                    if (ans[0] == 'Y') {
                        cout << "! 3 " << i + 1 << ' ' << j + 1 << ' ' << k + 1 << endl;
                        go = true;
                        break;
                    }
                }
                if (go) break;
            }
            if (go) break;
        }
    }

    return 0;
}
/*
6
3 0
0 2
2 4
4 2
5 5
6 1
*/
