#include <iostream>
#include <bitset>
#include <vector>

using namespace std;

int n;
vector<bitset<31>> nums;

void remake(int bit, vector<pair<int, int>>& seq) {
    vector<pair<int, int>> temp_seq;
    int start = 0, current = 0;
    for (int i = 1; i <= n; ++i) {
        if (seq[current].second == i) {
            temp_seq.push_back(make_pair(start, i));
            start = i;
            ++current;
        } else if (nums[i][bit] != nums[i - 1][bit]) {
            temp_seq.push_back(make_pair(start, i));
            start = i;
        }
    }
    seq = temp_seq;
    temp_seq.clear();
}

pair<bool, unsigned int> calc() {
    unsigned int num = 0, step = 1 << 31;
    bool ok;
    vector<pair<int, int>> seq(1, make_pair(0, n));
    for (int bit = 30; bit >= 0; --bit) {
        step >>= 1;

        ok = true;
        for (auto& p: seq)
            for (int i = p.first + 1; i < p.second; ++i)
                if (nums[i][bit] < nums[i - 1][bit])
                    ok = false;

        if (ok) {
            remake(bit, seq);
            continue;
        }

        ok = true;
        for (auto& p: seq)
            for (int i = p.first + 1; i < p.second; ++i)
                if (nums[i][bit] > nums[i - 1][bit])
                    ok = false;

        if (ok) {
            remake(bit, seq);
            num |= step;
            continue;
        }

        return {false, 0};
    }
    return {true, num};
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cin >> n;
    nums.resize(n);
    unsigned int x;
    for (int i = 0; i < n; ++i) {
        cin >> x;
        nums[i] = x;
    }
    auto result = calc();
    if (result.first)
        cout << result.second << endl;
    else
        cout << -1 << endl;
    int q;
    cin >> q;
    for (int i = 0, p; i < q; ++i) {
        cin >> p >> x;
        nums[--p] = x;
        auto result = calc();
        if (result.first)
            cout << result.second << endl;
        else
            cout << -1 << endl;
    }
    return 0;
}