#include <iostream>
#include <fstream>
#include <vector>
#include <set>

using namespace std;


const int sum[6][6] = { {0, 1, 4, 1, 4, 0},
                        {4, 4, 4, 1, 4, 1},
                        {2, 4, 4, 4, 4, 2},
                        {2, 4, 2, 3, 4, 3},
                        {4, 4, 4, 4, 4, 4},
                        {0, 1, 2, 3, 4, 5}};

struct sig_tree {
    vector <int8_t> v;
    int n;
    sig_tree(int N) {
        n = 1;
        while(n < N)
            n *= 2;
        v.resize(2 * n, 0);
    }
    void set(int id, int u) {
        id += n;
        v[id] = u;
        while (id > 1) {
            id /= 2;
            v[id] = sum[v[id * 2]][v[id * 2 + 1]];
        }
    }
    int get(int ql, int qr, int u = 1, int l = 0, int r = -1) {
        if (r == -1)
            r = n;
        if (ql <= l && r <= qr)
            return v[u];
        if (r <= ql || qr <= l)
            return 5;
        return sum[get(ql, qr, u * 2, l, (l + r) / 2)][get(ql, qr, u * 2 + 1, (l + r) / 2, r)];
    }
};

int mis(int a, int b) {
    int res = 30;
    while ((a & (1 << res)) == (b & (1 << res)))
        res--;
    return res;

}

struct sig {
    int l, r;
    sig(int l = 0, int r = 0): l(l), r(r) {}
};

bool operator< (sig a, sig b) {
    return a.l < b.l;
}

int cnt[30][6], res[30], n;
bool valid;
set <sig> s[30];
vector <sig_tree> st;

void init(vector <int> &a) {
    st.clear();
    valid = true;
    int mask = (1 << 30) - 1, lst;
    for (int i = 0; i < 30; i++) {
        //cout << i << "th:\n";
        lst = 0;
        for (int j = 0; j < 6; j++)
            cnt[i][j] = 0;
        st.push_back(sig_tree(n));
        s[i].clear();
        for (int j = 0; j < n; j++)
            if (a[j] & (1<<(29 - i))) {
                st[i].set(j, 3);
                //cout << 1;
            } else {
                //cout << 0;
            }
        //cout << endl;
        for (int j = 1; j <= n; j++) {
            if (j < n && (a[j] | mask) == (a[j - 1] | mask))
                continue;
            s[i].insert(sig(lst, j));
            cnt[i][st[i].get(lst, j)]++;
            //cout << '[' << lst << ", " << j << ")="<< st[i].get(lst, j) << ' ';
            lst = j;
        }
        //cout << endl;
        if (cnt[i][4] > 0 || (cnt[i][1] > 0 && cnt[i][2] > 0)) {
            //cout << 313123;
            valid = false;
        }else
            if (cnt[i][2])
                res[i] = 1;
            else
                res[i] = 0;
        mask /= 2;
    }
}

int g_res() {
    if (!valid)
        return -1;
    int cres = 0;
    for (int i = 0; i < 30; i++)
        if (res[29 - i])
            cres += (1 << i);
    return cres;
}

int main() {
    ifstream cin("order.in");
    int ci, cn, q;
    cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    init(a);
    cout << g_res() << '\n';
    for (cin >> q; q > 0; q--) {
        cin >> ci >> cn;
        ci--;
        if (a[ci] == cn) {
            cout << g_res() << '\n';
            continue;
        }
        a[ci] = cn;
        init(a);
        cout << g_res() << '\n';
        //int j = mis(a[ci], cn);
    }
    return 0;
}
