#include <iostream>
#include <fstream>
#include <vector>
#include <set>

using namespace std;


const int sum[6][6] = { {0, 1, 4, 1, 4, 0},
                        {4, 4, 4, 1, 4, 1},
                        {2, 4, 4, 4, 4, 2},
                        {2, 4, 2, 3, 4, 3},
                        {4, 4, 4, 4, 4, 4},
                        {0, 1, 2, 3, 4, 5}};

struct sig_tree {
    vector <int8_t> v;
    int n;
    sig_tree(int N) {
        n = 1;
        while(n < N)
            n *= 2;
        v.resize(2 * n, 0);
    }
    void set(int id, int u) {
        //cout << "SET " << id << ' ' << u << endl;
        id += n;
        v[id] = u;
        while (id > 1) {
            id /= 2;
            v[id] = sum[v[id * 2]][v[id * 2 + 1]];
        }
    }
    int get(int ql, int qr, int u = 1, int l = 0, int r = -1) {
        //return 0;
        if (r == -1)
            r = n;
        if (ql <= l && r <= qr)
            return v[u];
        if (r <= ql || qr <= l)
            return 5;
        int mid = (l + r) / 2;
        return sum[get(ql, qr, u * 2, l, mid)][get(ql, qr, u * 2 + 1, mid, r)];
    }
};

int mis(int a, int b) {
    int res = 30;
    while ((a & (1 << res)) == (b & (1 << res)))
        res--;
    return 29 - res;

}

struct sig {
    int l, r;
    sig(int l = 0, int r = 0): l(l), r(r) {}
};

bool operator< (sig a, sig b) {
    return a.l < b.l;
}

int cnt[30][6], res[30], n;
set <sig> s[30];
vector <sig_tree> st;

void init(vector <int> &a) {
    st.clear();
    int mask = (1 << 30) - 1, lst;
    for (int i = 0; i < 30; i++) {
        //cout << i << "th:\n";
        lst = 0;
        for (int j = 0; j < 6; j++)
            cnt[i][j] = 0;
        st.push_back(sig_tree(n));
        s[i].clear();
        for (int j = 0; j < n; j++)
            if (a[j] & (1<<(29 - i))) {
                st[i].set(j, 3);
                //cout << 1;
            } else {
                //cout << 0;
            }
        //cout << endl;
        for (int j = 1; j <= n; j++) {
            if (j < n && (a[j] | mask) == (a[j - 1] | mask))
                continue;
            s[i].insert(s[i].end(), sig(lst, j));
            cnt[i][st[i].get(lst, j)]++;
            //cout << '[' << lst << ", " << j << ")="<< st[i].get(lst, j) << ' ';
            lst = j;
        }
        //cout << endl;
        if (cnt[i][4] > 0 || (cnt[i][1] > 0 && cnt[i][2] > 0)) {
            //cout << 3131
        }else
            if (cnt[i][2])
                res[i] = 1;
            else
                res[i] = 0;
        mask /= 2;
    }
}

int g_res() {
    for (int i = 0; i < 30; i++)
        if (cnt[i][4] || (cnt[i][1] && cnt[i][2]))
            return -1;
    int cres = 0;
    for (int i = 27; i < 27; i++) {
        cout << "cnt[" << i << "]: ";
        for (int j = 0; j < 6; j++)
            cout << cnt[i][j] << ' ';
        for (sig j : s[i]) {
            cout << '[' << j.l <<','<<j.r<<") ";
        }
        cout << endl;
    }
    for (int i = 0; i < 30; i++)
        if (cnt[i][2])
            cres += (1 << (29 - i));
    return cres;
}

int main() {
    ifstream cin("order.in");
    ofstream cout("order.out");
    int ci, cn, q;
    cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    init(a);
    cout << g_res() << '\n';
    for (cin >> q; q > 0; q--) {
        cin >> ci >> cn;
        ci--;
        if (a[ci] == cn) {
            cout << g_res() << '\n';
            continue;
        }
        for (int i = mis(a[ci], cn); i < 30; i++) {
            int pref_mask = (1 << (30 - i)) - 1;
            //cout << i << "th:\n" << endl;
            set<sig>::iterator it = s[i].lower_bound(sig(ci));
            if(it == s[i].end() || (*it).l != ci)  {
                it--;
            }
            sig to_ins = *it;
            //cout << "cur in " << to_ins.l << ' ' << to_ins.r << endl;
            vector <set<sig>::iterator> to_rem(1, it);
            if ((*it).l == ci && ci > 0 && (a[ci - 1] | pref_mask) == (cn | pref_mask)) {
                it--;
                to_rem.push_back(it);
                to_ins.l = it->l;
                it++;
            }
            if (to_ins.r == ci + 1 && ci != n - 1 && (a[ci + 1] | pref_mask) == (cn | pref_mask)) {
                it++;
                to_rem.push_back(it);
                to_ins.r = it->r;
            }
            //cout << "aftrem " << to_ins.l << ' ' << to_ins.r << endl;

            for (set<sig>::iterator it2 : to_rem) {
                cnt[i][st[i].get(it2->l, it2->r)]--;
                s[i].erase(it2);
            }
            st[i].set(ci, ((cn & (1 << (29 - i)))?3:0));
            if (ci != to_ins.l && (a[ci - 1] | pref_mask) != (cn | pref_mask)){
                //cout << "strip bef " << (a[ci - 1] | (1 << (30 - i))) << " != " << (cn | (1 << (30 - i))) << endl;
                s[i].insert(sig(to_ins.l, ci));
                cnt[i][st[i].get(to_ins.l, ci)]++;
                to_ins.l = ci;
            }
            if (ci != to_ins.r - 1 && (a[ci + 1] | pref_mask) != (cn | pref_mask)) {
                s[i].insert(sig(ci + 1, to_ins.r));
                cnt[i][st[i].get(ci + 1, to_ins.r)]++;
                to_ins.r = ci + 1;
            }
            //cout << "aftspl " << to_ins.l << ' ' << to_ins.r << endl;

            s[i].insert(to_ins);
            cnt[i][st[i].get(to_ins.l, to_ins.r)]++;
        }
        a[ci] = cn;
        cout << g_res() << '\n';
        //int j = mis(a[ci], cn);
    }
    return 0;
}
