#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <stack>

using namespace std;

typedef long long ll;
const ll infinite = 1000000000000;

struct Edge {
	ll to, num, dist;
	Edge(ll to, ll num, ll dist) : to(to), num(num), dist(dist) {};
};

ll best_distance[10000];
ll new_quality[10000] = {0};
ll prev_quality[10000] = {0};
ll prev_number[10000];
vector<Edge> g[10000];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	
	ll n, m;
	cin >> n >> m;
	
	for (int i = 0; i < 1000; i++) {
		best_distance[i] = infinite;
	}
	for (int i = 0; i < m; i++) {
		ll s;
		cin >> s;
		ll p;
		cin >> p;
		p--;
		for (int j = 0; j < s; j++) {
			ll d, to;
			cin >> d >> to;
			to--;
			g[p].push_back(Edge(to, i, d));
			p = to;
		}
	}
	best_distance[0] = 0;
	vector<ll> known;
	known.push_back(0);
	prev_number[0] = -1;
	while (best_distance[n - 1] == infinite) {
		ll min_dist = infinite;
		ll max_prev_quality = 0;
		ll max_new_quality = 0;
		ll to = -1;
		ll prev_num = -1;
		for (ll cur : known) {
			for (Edge& edge : g[cur]) {
				ll new_dist = best_distance[cur] + edge.dist;
				ll new_prev_quality;
				ll new_new_quality;
				if (prev_number[cur] == edge.num) {
					new_prev_quality = prev_quality[cur];
					new_new_quality = new_quality[cur] + edge.dist;
				}
				else {
					new_prev_quality = prev_quality[cur] + new_quality[cur] * new_quality[cur];
					new_new_quality = edge.dist;
				}

				if (new_dist < best_distance[edge.to]) {
					if (new_dist < min_dist) {
						min_dist = new_dist;
						max_prev_quality = new_prev_quality;
						max_new_quality = new_new_quality;
						to = edge.to;
						prev_num = edge.num;
					}
					else {
						if (new_prev_quality + new_new_quality * new_new_quality > max_prev_quality + max_new_quality*max_new_quality) {
							max_prev_quality = new_prev_quality;
							max_new_quality = new_new_quality;
							to = edge.to;
							prev_num = edge.num;
						}
					}
				}
			}
		}
		best_distance[to] = min_dist;
		prev_quality[to] = max_prev_quality;
		new_quality[to] = max_new_quality;
		known.push_back(to);
		prev_number[to] = prev_num;
	}
	cout << best_distance[n - 1] << " " << prev_quality[n - 1] + new_quality[n - 1] * new_quality[n - 1] << endl;
	return 0;
}