#pragma comment(linker, "/Stack:128000000")
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <queue>

using namespace std;

typedef long long LL;

const LL INFll = (LL) 1e18;
const LL k = (LL)1e9;

int n, a;

struct Exp {
  int L, R, c;

  bool operator<(const Exp &e) const {
    return R != e.R ? R < e.R : L != e.L ? L > e.L : c < e.c;
  }
};

Exp exps[150];
const int MAXA = (int)1e6 + 100;

LL ST[MAXA * 2];

void add(int root, int L, int R, int id, LL x) {
  if (L == R - 1) {
    ST[root] += x;
    return;
  }
 
  int md = (L + R) >> 1;

  if (id < md)
    add(root * 2, L, md, id, x);
  else
    add(root * 2 + 1, md, R, id, x);

  ST[root] = min(ST[root * 2], ST[root * 2 + 1]);
}

LL get(int root, int L, int R, int ql, int qr) {
  if (L >= qr || R <= ql) return INFll;
  if (ql <= L && R <= qr) {
    return ST[root];
  }

  int md = (L + R) >> 1;

  return min(get(root * 2, L, md, ql, qr), get(root * 2 + 1, md, R, ql, qr));
}

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#elif 1
# define PROB "anti"
  freopen(PROB".in", "r", stdin);
  freopen(PROB".out", "w", stdout);
#endif
  cin.tie(0);
  cin.sync_with_stdio(0);

  cin >> n >> a;

  for (int i = 0; i < n; ++i) {
    cin >> exps[i].L >> exps[i].R >> exps[i].c;
  }

  sort(exps, exps + n);

  LL ans = 0;

  int root = 1;

  for (int cur = 0; cur <= a; ++cur) {
    add(root, 0, a + 2, cur, (a - cur) * k);
  }

  for (int cur = 1; cur <= a; ++cur) {
    LL mem = 0;
    for (int i = 0; i < n && exps[i].R <= cur; ++i) {
      LL tmp = get(root, 0, a + 2, cur - exps[i].R, cur - exps[i].L + 1) - exps[i].c - (a - cur) * k;
      mem = max(mem, tmp);
    }
    add(root, 0, a + 2, cur, mem);
    ans = max(ans, mem);
  }

  cout << ans << endl;
  return 0;
}