#pragma comment(linker, "/Stack:128000000")
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <queue>

using namespace std;

typedef long long LL;

const LL INFll = (LL) 1e18;
const LL k = (LL)1e9;

/*
const int MAX_MEM = 120000000;

char MEM[MAX_MEM];
char *m_pos = MEM;

inline void* operator new(size_t n){
  char *res = m_pos;
  m_pos += n;
  return (void*)res;
}

inline void operator delete(void*) {};
*/
int n, a;

struct Exp {
  int L, R, c;

  bool operator<(const Exp &e) const {
    return R != e.R ? R < e.R : L != e.L ? L > e.L : c < e.c;
  }
};

Exp exps[150];
const int MAXA = (int)1e6 + 100;

LL ST[MAXA * 4];
int id;
LL x;
int ql, qr;

inline void add(int root, int L, int R) {
  if (L == R - 1) {
    ST[root] += x;
    return;
  }
 
  int md = (L + R) >> 1;

  if (id < md)
    add(root << 1, L, md);
  else
    add((root << 1) + 1, md, R);

  ST[root] = min(ST[root << 1], ST[(root << 1) + 1]);
}

inline LL get(int root, int L, int R) {
  if (L >= qr || R <= ql) return INFll;
  if (ql <= L && R <= qr) {
    return ST[root];
  }

  int md = (L + R) >> 1;

  return min(get(root * 2, L, md), get(root * 2 + 1, md, R));
}

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#elif 1
# define PROB "anti"
  freopen(PROB".in", "r", stdin);
  freopen(PROB".out", "w", stdout);
#endif
  cin.tie(0);
  cin.sync_with_stdio(0);

  cin >> n >> a;

  for (int i = 0; i < n; ++i) {
    cin >> exps[i].L >> exps[i].R >> exps[i].c;
  }

  sort(exps, exps + n);

  LL ans = 0;

  int root = 1;

  for (int cur = 0; cur <= a; ++cur) {
    id = cur;
    x = (a - cur) * k;
    add(root, 0, a + 2);
  }

  for (int cur = 1; cur <= a; ++cur) {
    LL mem = 0;
    for (int i = 0; i < n && exps[i].R <= cur; ++i) {
      ql = cur - exps[i].R;
      qr = cur - exps[i].L + 1;
      mem = max(mem, get(root, 0, a + 2) - exps[i].c - (a - cur) * k);
    }
    id = cur;
    x = mem;
    add(root, 0, a + 2);
    ans = max(ans, mem);
  }

  cout << ans << endl;
  return 0;
}