#pragma comment(linker, "/Stack:512000000")
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <queue>

using namespace std;

typedef long long LL;


struct ST {
  LL val;
  LL valLeft, valRight;
  pair<int, int> ans, ansLeft, ansRight;

  bool state;

  ST *left, *right;

  ST(int L, int R, const vector<int> &y) {
    ansLeft = ansRight = ans = { L, R - 1 };
    if (L == R - 1) {
      state = 1;
      val = valLeft = valRight = y[L];
      left = right = nullptr;
    }
    else {
      state = 1;
      
      int mid = (L + R) / 2;
      left = new ST(L, mid, y);
      right = new ST(mid, R, y);

      val = valRight = valLeft = left->val + right->val;
    }
  }
};

const int INF = (int)1e9;

void set0(ST *root, int L, int R, int id) {
  if (L == R - 1) {
    root->state = 0;
    root->val = -INF;
    root->valLeft = -INF;
    root->valRight = -INF;
    root->ansLeft = root->ansRight = root->ans = { -1, -1 };
    return;
  }

  int mid = (L + R) / 2;

  if (id < mid)
    set0(root->left, L, mid, id);
  else
    set0(root->right, mid, R, id);

  root->val = 0;
  root->state = 0;

  if (root->left->val == -INF && root->right->val == -INF) {
    root->ans = { -1, -1 };
    root->valLeft = -INF;
    root->valRight = -INF;
    root->val = -INF;
    root->ansLeft = root->ans;
    root->ansRight = root->ans;
  }
  else if (root->left->val == -INF) {
    root->ans = root->right->ans;
    root->val = root->right->val;
    root->valLeft = -INF;
    root->ansLeft = { -1, -1 };
    root->valRight = root->right->valRight;
    root->ansRight = root->right->ansRight;
  }
  else if (root->right->val == -INF) {
    root->ans = root->left->ans;
    root->val = root->left->val;
    root->valLeft = root->left->valLeft;
    root->ansLeft = root->left->ansLeft;
    root->valRight = -INF;
    root->ansRight = { -1, -1 };
  }
  else {
    if (root->left->state) {
      root->valLeft = root->left->val + root->right->valLeft;
      root->ansLeft = { root->left->ansLeft.first, root->right->ansLeft.second };

      root->valRight = root->right->valRight;
      root->ansRight = root->right->ansRight;
    }
    else if (root->right->state) {
      root->valLeft = root->left->val;
      root->ansLeft = root->left->ansLeft;

      root->valRight = root->right->valRight + root->left->valRight;
      root->ansRight = { root->left->ansRight.first, root->right->ansRight.second };
    }
    else {
      root->valLeft = root->left->val;
      root->ansLeft = root->left->ansLeft;

      root->valRight = root->right->val;
      root->ansRight = root->right->ansRight;
    }

    if (root->val < root->left->val) {
      root->val = root->left->val;
      root->ans = root->left->ans;
    }
    if (root->val < root->right->val) {
      root->val = root->right->val;
      root->ans = root->right->ans;
    }
    if (root->val < root->valLeft) {
      root->val = root->valLeft;
      root->ans = root->ansLeft;
    }
    if (root->val < root->valRight) {
      root->val = root->valRight;
      root->ans = root->ansRight;
    }
    if (root->val < root->left->valRight + root->right->valLeft) {
      root->val = root->left->valRight + root->right->valLeft;
      root->ans = { root->left->ansRight.first, root->right->ansLeft.second };
    }
  }
}

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#elif 1
# define PROB "internship"
  freopen(PROB".in", "r", stdin);
  freopen(PROB".out", "w", stdout);
#endif
  cin.tie(0);
  cin.sync_with_stdio(0);

  int n, m;
  cin >> n >> m;

  vector<int> a(n), b(m);
  vector<int> x(n), y(m);

  for (int i = 0; i < n; ++i) {
    cin >> a[i];
    --a[i];
  }
  for (int i = 0; i < n; ++i)
    cin >> x[i];

  for (int i = 0; i < m; ++i) {
    cin >> b[i];
    --b[i];
  }
  for (int i = 0; i < m; ++i)
    cin >> y[i];

  vector<int> revA(n + m, -1), revB(n + m, -1);

  for (int i = 0; i < n; ++i)
    revA[a[i]] = i;
  for (int i = 0; i < m; ++i)
    revB[b[i]] = i;

  LL ans = 0;
  int ansi = -1, ansj = -1, ansilen = 0, ansjlen = 0;

  LL sum = 0;
  for (int i = 0; i < n; ++i)
    sum += x[i];

  if (sum > ans) {
    ans = sum;
    ansi = 0, ansilen = n - 1;
    ansj = -1, ansjlen = -1;
  }

  sum = 0;
  for (int i = 0; i < m; ++i)
    sum += y[i];

  if (sum > ans) {
    ans = sum;
    ansi = -1, ansilen = -1;
    ansj = 0, ansjlen = m - 1;
  }

  sum = 0;

  for (int i = 0; i < n; ++i) {
    sum = 0;

    ST *root = new ST(0, m, y);
    
    for (int j = i; j < n; ++j) {
      sum += x[j];
      
      if (revB[a[j]] != -1) set0(root, 0, m, revB[a[j]]);

      if (ans < sum + root->val) {
        ans = sum + root->val;
        ansi = i;
        ansilen = j;
        ansj = root->ans.first;
        ansjlen = root->ans.second;
      }
    }
  }

  cout << ans << '\n';
  cout << ansi + 1 << ' ' << ansilen + 1 << '\n';
  cout << ansj + 1 << ' ' << ansjlen + 1 << '\n';

  return 0;
}