#include <bits/stdc++.h>

using namespace std;

const int maxN = 1000005;

bool dpSBeg[maxN];
bool dpSEnd[maxN];
bool dpTBeg[maxN];
bool dpTEnd[maxN];

void build(string& s, bool* dpBeg, bool* dpEnd)
{
    for(int i = 0; i < s.size();)
    {
        dpBeg[i] = 1;
        int j = i;
        while(j < s.size() && s[j] == s[i]) j++;
        dpEnd[j - 1] = 1;
        i = j;
    }
}

int pv[maxN];
int sz[maxN];
void buildSNM(int n)
{
    for(int i = 0; i < n; i++) pv[i] = i, sz[i] = 1;
}

int get_p(int v)
{
    if(pv[v] == v) return v;
    return pv[v] = get_p(pv[v]);
}

void union_s(int v, int u)
{
    v = get_p(v);
    u = get_p(u);

    if(v == u) return;

    if(sz[v] > sz[u]) swap(v, u);

    pv[v] = u;
    sz[u] += sz[v];
}


struct Seg
{
    int l, r;
    Seg() {}
    Seg(int _l, int _r) : l(_l), r(_r) {}
};

bool operator < (Seg s1, Seg s2)
{
    return s1.r - s1.l < s2.r - s2.l;
}

int solve(string& s, string& t, int l, int r)
{
    if(t[l] == '+')
    {
        for(int i = l; i < r; i++) s[i] = (s[i] == '+' ? '-' : '+');
        for(int i = l; i < r; i++) t[i] = '-';
    }

    vector<int> len(s.size());
    while(1)
    {
        fill(len.begin(), len.end(), 0);
        int cnt = 0;
        for(int i = l; i < r;)
        {
            int j = i;
            while(j < r && s[j] == s[i]) j++;
            for(int k = i; k < j; k++) len[k] = j - i;
            i = j;
            cnt++;
        }

        int ok = 0;
        for(int i = l; i < r;)
        {
            int j = i;
            while(j < r && s[j] == s[i]) j++;

            if(s[i] == '+')
            {
                int sz1 = -1, sz2 = -1;
                if(i > l) sz1 = len[i - 1];
                if(j < r) sz2 = len[j];

                if(len[i] < max(sz1, sz2))
                {
                    for(int k = i; k < j; k++) s[k] = '-';
                    ok = 1;
                    break;
                }
            }

            i = j;
        }

        if(!ok)
        {
            if(s[l] == '-' && cnt == 1) return 1;
            else return 0;
        }
    }
}

int solve(string& s, string& t)
{
    int n = s.size();

    build(s, dpSBeg, dpSEnd);
    build(t, dpTBeg, dpTEnd);

    for(int i = 0; i < n; i++) if(dpTBeg[i] && !dpSBeg[i] || dpTEnd[i] && !dpSEnd[i]) return 0;

    for(int i = 0; i < n - 1; i++) if(dpTEnd[i] && s[i] != t[i]) return 0;
    for(int i = 1; i < n; i++) if(dpTBeg[i] && s[i] != t[i]) return 0;

    for(int i = 0; i < n;)
    {
        int j = i;
        while(!dpTEnd[j]) j++;

        if(!solve(s, t, i, j + 1)) return 0;

        i = j + 1;
    }

    return 1;
}

int main()
{
    #ifdef DEBUG
        freopen("in.in", "r", stdin);
        //freopen("in.out", "w", stdout);
    #endif // DEBUG

    int q;
    cin >> q;
    while(q--)
    {
        string s, t;
        cin >> s >> t;

        fill(dpSBeg, dpSBeg + s.size(), 0);
        fill(dpTBeg, dpTBeg + s.size(), 0);
        fill(dpSEnd, dpSEnd + s.size(), 0);
        fill(dpTEnd, dpTEnd + s.size(), 0);

        cout << (solve(s, t) ? "Yes" : "No") << endl;
    }

    return 0;
}
